/* 
 * Copyright (c) [2010-2019] zhenfei.mzf@gmail.com rights reserved.
 * 
 * AntiSpy is licensed under the Mulan PSL v1.
 * You can use this software according to the terms and conditions of the Mulan PSL v1.
 * You may obtain a copy of Mulan PSL v1 at:
 *
 *     http://license.coscl.org.cn/MulanPSL
 *
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR
 * FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v1 for more details.
*/
#include "stdafx.h"
#include "ShadowFunctions.h"

WCHAR *W2kShadow[] = 
{
	L"NtGdiAbortDoc",
	L"NtGdiAbortPath",
	L"NtGdiAddFontResourceW",
	L"NtGdiAddRemoteFontToDC",
	L"NtGdiAddFontMemResourceEx",
	L"NtGdiRemoveMergeFont",
	L"NtGdiAddRemoteMMInstanceToDC",
	L"NtGdiAlphaBlend",
	L"NtGdiAngleArc",
	L"NtGdiAnyLinkedFonts",
	L"NtGdiFontIsLinked",
	L"NtGdiArcInternal",
	L"NtGdiBeginPath",
	L"NtGdiBitBlt",
	L"NtGdiCancelDC",
	L"NtGdiCheckBitmapBits",
	L"NtGdiCloseFigure",
	L"NtGdiColorCorrectPalette",
	L"NtGdiCombineRgn",
	L"NtGdiCombineTransform",
	L"NtGdiComputeXformCoefficients",
	L"NtGdiConsoleTextOut",
	L"NtGdiConvertMetafileRect",
	L"NtGdiCreateBitmap",
	L"NtGdiCreateClientObj",
	L"NtGdiCreateColorSpace",
	L"NtGdiCreateColorTransform",
	L"NtGdiCreateCompatibleBitmap",
	L"NtGdiCreateCompatibleDC",
	L"NtGdiCreateDIBBrush",
	L"NtGdiCreateDIBitmapInternal",
	L"NtGdiCreateDIBSection",
	L"NtGdiCreateEllipticRgn",
	L"NtGdiCreateHalftonePalette",
	L"NtGdiCreateHatchBrushInternal",
	L"NtGdiCreateMetafileDC",
	L"NtGdiCreatePaletteInternal",
	L"NtGdiCreatePatternBrushInternal",
	L"NtGdiCreatePen",
	L"NtGdiCreateRectRgn",
	L"NtGdiCreateRoundRectRgn",
	L"NtGdiCreateServerMetaFile",
	L"NtGdiCreateSolidBrush",
	L"NtGdiD3dContextCreate",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroyAll",
	L"NtGdiD3dValidateTextureStageState",
	L"NtGdiD3dDrawPrimitives2",
	L"NtGdiDdGetDriverState",
	L"NtGdiDdAddAttachedSurface",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAttachSurface",
	L"NtGdiDdBeginMoCompFrame",
	L"NtGdiDdBlt",
	L"NtGdiDdCanCreateSurface",
	L"NtGdiDdCanCreateD3DBuffer",
	L"NtGdiDdColorControl",
	L"NtGdiDdCreateDirectDrawObject",
	L"NtGdiDdCreateSurface",
	L"NtGdiDdCreateD3DBuffer",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdDeleteDirectDrawObject",
	L"NtGdiDdDeleteSurfaceObject",
	L"NtGdiDdDestroyMoComp",
	L"NtGdiDdDestroySurface",
	L"NtGdiDdDestroyD3DBuffer",
	L"NtGdiDdEndMoCompFrame",
	L"NtGdiDdFlip",
	L"NtGdiDdFlipToGDISurface",
	L"NtGdiDdGetAvailDriverMemory",
	L"NtGdiDdGetBltStatus",
	L"NtGdiDdGetDC",
	L"NtGdiDdGetDriverInfo",
	L"NtGdiDdGetDxHandle",
	L"NtGdiDdGetFlipStatus",
	L"NtGdiDdGetInternalMoCompInfo",
	L"NtGdiDdGetMoCompBuffInfo",
	L"NtGdiDdGetMoCompGuids",
	L"NtGdiDdGetMoCompFormats",
	L"NtGdiDdGetScanLine",
	L"NtGdiDdLock",
	L"NtGdiDdLockD3D",
	L"NtGdiDdQueryDirectDrawObject",
	L"NtGdiDdQueryMoCompStatus",
	L"NtGdiDdReenableDirectDrawObject",
	L"NtGdiDdReleaseDC",
	L"NtGdiDdRenderMoComp",
	L"NtGdiDdResetVisrgn",
	L"NtGdiDdSetColorKey",
	L"NtGdiDdSetExclusiveMode",
	L"NtGdiDdSetGammaRamp",
	L"NtGdiDdCreateSurfaceEx",
	L"NtGdiDdSetOverlayPosition",
	L"NtGdiDdUnattachSurface",
	L"NtGdiDdUnlock",
	L"NtGdiDdUnlockD3D",
	L"NtGdiDdUpdateOverlay",
	L"NtGdiDdWaitForVerticalBlank",
	L"NtGdiDvpCanCreateVideoPort",
	L"NtGdiDvpColorControl",
	L"NtGdiDvpCreateVideoPort",
	L"NtGdiDvpDestroyVideoPort",
	L"NtGdiDvpFlipVideoPort",
	L"NtGdiDvpGetVideoPortBandwidth",
	L"NtGdiDvpGetVideoPortField",
	L"NtGdiDvpGetVideoPortFlipStatus",
	L"NtGdiDvpGetVideoPortInputFormats",
	L"NtGdiDvpGetVideoPortLine",
	L"NtGdiDvpGetVideoPortOutputFormats",
	L"NtGdiDvpGetVideoPortConnectInfo",
	L"NtGdiDvpGetVideoSignalStatus",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDvpWaitForVideoPortSync",
	L"NtGdiDeleteClientObj",
	L"NtGdiDeleteColorSpace",
	L"NtGdiDeleteColorTransform",
	L"NtGdiDeleteObjectApp",
	L"NtGdiDescribePixelFormat",
	L"NtGdiGetPerBandInfo",
	L"NtGdiDoBanding",
	L"NtGdiDoPalette",
	L"NtGdiDrawEscape",
	L"NtGdiEllipse",
	L"NtGdiEnableEudc",
	L"NtGdiEndDoc",
	L"NtGdiEndPage",
	L"NtGdiEndPath",
	L"NtGdiEnumFontChunk",
	L"NtGdiEnumFontClose",
	L"NtGdiEnumFontOpen",
	L"NtGdiEnumObjects",
	L"NtGdiEqualRgn",
	L"NtGdiEudcEnumFaceNameLinkW",
	L"NtGdiEudcLoadUnloadLink",
	L"NtGdiExcludeClipRect",
	L"NtGdiExtCreatePen",
	L"NtGdiExtCreateRegion",
	L"NtGdiExtEscape",
	L"NtGdiExtFloodFill",
	L"NtGdiExtGetObjectW",
	L"NtGdiExtSelectClipRgn",
	L"NtGdiExtTextOutW",
	L"NtGdiFillPath",
	L"NtGdiFillRgn",
	L"NtGdiFlattenPath",
	L"NtGdiFlushUserBatch",
	L"NtGdiFlush",
	L"NtGdiForceUFIMapping",
	L"NtGdiFrameRgn",
	L"NtGdiFullscreenControl",
	L"NtGdiGetAndSetDCDword",
	L"NtGdiGetAppClipBox",
	L"NtGdiGetBitmapBits",
	L"NtGdiGetBitmapDimension",
	L"NtGdiGetBoundsRect",
	L"NtGdiGetCharABCWidthsW",
	L"NtGdiGetCharacterPlacementW",
	L"NtGdiGetCharSet",
	L"NtGdiGetCharWidthW",
	L"NtGdiGetCharWidthInfo",
	L"NtGdiGetColorAdjustment",
	L"NtGdiGetColorSpaceforBitmap",
	L"NtGdiGetDCDword",
	L"NtGdiGetDCforBitmap",
	L"NtGdiGetDCObject",
	L"NtGdiGetDCPoint",
	L"NtGdiGetDeviceCaps",
	L"NtGdiGetDeviceGammaRamp",
	L"NtGdiGetDeviceCapsAll",
	L"NtGdiGetDIBitsInternal",
	L"NtGdiGetETM",
	L"NtGdiGetEudcTimeStampEx",
	L"NtGdiGetFontData",
	L"NtGdiGetFontResourceInfoInternalW",
	L"NtGdiGetGlyphIndicesW",
	L"NtGdiGetGlyphIndicesWInternal",
	L"NtGdiGetGlyphOutline",
	L"NtGdiGetKerningPairs",
	L"NtGdiGetLinkedUFIs",
	L"NtGdiGetMiterLimit",
	L"NtGdiGetMonitorID",
	L"NtGdiGetNearestColor",
	L"NtGdiGetNearestPaletteIndex",
	L"NtGdiGetObjectBitmapHandle",
	L"NtGdiGetOutlineTextMetricsInternalW",
	L"NtGdiGetPath",
	L"NtGdiGetPixel",
	L"NtGdiGetRandomRgn",
	L"NtGdiGetRasterizerCaps",
	L"NtGdiGetRealizationInfo",
	L"NtGdiGetRegionData",
	L"NtGdiGetRgnBox",
	L"NtGdiGetServerMetaFileBits",
	L"NtGdiGetSpoolMessage",
	L"NtGdiGetStats",
	L"NtGdiGetStockObject",
	L"NtGdiGetStringBitmapW",
	L"NtGdiGetSystemPaletteUse",
	L"NtGdiGetTextCharsetInfo",
	L"NtGdiGetTextExtent",
	L"NtGdiGetTextExtentExW",
	L"NtGdiGetTextFaceW",
	L"NtGdiGetTextMetricsW",
	L"NtGdiGetTransform",
	L"NtGdiGetUFI",
	L"NtGdiGetUFIPathname",
	L"NtGdiGetFontUnicodeRanges",
	L"NtGdiGetWidthTable",
	L"NtGdiGradientFill",
	L"NtGdiHfontCreate",
	L"NtGdiIcmBrushInfo",
	L"NtGdiInit",
	L"NtGdiInitSpool",
	L"NtGdiIntersectClipRect",
	L"NtGdiInvertRgn",
	L"NtGdiLineTo",
	L"NtGdiMakeFontDir",
	L"NtGdiMakeInfoDC",
	L"NtGdiMaskBlt",
	L"NtGdiModifyWorldTransform",
	L"NtGdiMonoBitmap",
	L"NtGdiMoveTo",
	L"NtGdiOffsetClipRgn",
	L"NtGdiOffsetRgn",
	L"NtGdiOpenDCW",
	L"NtGdiPatBlt",
	L"NtGdiPolyPatBlt",
	L"NtGdiPathToRegion",
	L"NtGdiPlgBlt",
	L"NtGdiPolyDraw",
	L"NtGdiPolyPolyDraw",
	L"NtGdiPolyTextOutW",
	L"NtGdiPtInRegion",
	L"NtGdiPtVisible",
	L"NtGdiQueryFonts",
	L"NtGdiQueryFontAssocInfo",
	L"NtGdiRectangle",
	L"NtGdiRectInRegion",
	L"NtGdiRectVisible",
	L"NtGdiRemoveFontResourceW",
	L"NtGdiRemoveFontMemResourceEx",
	L"NtGdiResetDC",
	L"NtGdiResizePalette",
	L"NtGdiRestoreDC",
	L"NtGdiRoundRect",
	L"NtGdiSaveDC",
	L"NtGdiScaleViewportExtEx",
	L"NtGdiScaleWindowExtEx",
	L"NtGdiSelectBitmap",
	L"NtGdiSelectBrush",
	L"NtGdiSelectClipPath",
	L"NtGdiSelectFont",
	L"NtGdiSelectPen",
	L"NtGdiSetBitmapBits",
	L"NtGdiSetBitmapDimension",
	L"NtGdiSetBoundsRect",
	L"NtGdiSetBrushOrg",
	L"NtGdiSetColorAdjustment",
	L"NtGdiSetColorSpace",
	L"NtGdiSetDeviceGammaRamp",
	L"NtGdiSetDIBitsToDeviceInternal",
	L"NtGdiSetFontEnumeration",
	L"NtGdiSetFontXform",
	L"NtGdiSetIcmMode",
	L"NtGdiSetLinkedUFIs",
	L"NtGdiSetMagicColors",
	L"NtGdiSetMetaRgn",
	L"NtGdiSetMiterLimit",
	L"NtGdiGetDeviceWidth",
	L"NtGdiMirrorWindowOrg",
	L"NtGdiSetLayout",
	L"NtGdiSetPixel",
	L"NtGdiSetPixelFormat",
	L"NtGdiSetRectRgn",
	L"NtGdiSetSystemPaletteUse",
	L"NtGdiSetTextJustification",
	L"NtGdiSetupPublicCFONT",
	L"NtGdiSetVirtualResolution",
	L"NtGdiSetSizeDevice",
	L"NtGdiStartDoc",
	L"NtGdiStartPage",
	L"NtGdiStretchBlt",
	L"NtGdiStretchDIBitsInternal",
	L"NtGdiStrokeAndFillPath",
	L"NtGdiStrokePath",
	L"NtGdiSwapBuffers",
	L"NtGdiTransformPoints",
	L"NtGdiTransparentBlt",
	L"NtGdiUnloadPrinterDriver",
	L"NtGdiUnmapMemFont",
	L"NtGdiUnrealizeObject",
	L"NtGdiUpdateColors",
	L"NtGdiWidenPath",
	L"NtUserActivateKeyboardLayout",
	L"NtUserAlterWindowStyle",
	L"NtUserAssociateInputContext",
	L"NtUserAttachThreadInput",
	L"NtUserBeginPaint",
	L"NtUserBitBltSysBmp",
	L"NtUserBlockInput",
	L"NtUserBuildHimcList",
	L"NtUserBuildHwndList",
	L"NtUserBuildNameList",
	L"NtUserBuildPropList",
	L"NtUserCallHwnd",
	L"NtUserCallHwndLock",
	L"NtUserCallHwndOpt",
	L"NtUserCallHwndParam",
	L"NtUserCallHwndParamLock",
	L"NtUserCallMsgFilter",
	L"NtUserCallNextHookEx",
	L"NtUserCallNoParam",
	L"NtUserCallOneParam",
	L"NtUserCallTwoParam",
	L"NtUserChangeClipboardChain",
	L"NtUserChangeDisplaySettings",
	L"NtUserCheckImeHotKey",
	L"NtUserCheckMenuItem",
	L"NtUserChildWindowFromPointEx",
	L"NtUserClipCursor",
	L"NtUserCloseClipboard",
	L"NtUserCloseDesktop",
	L"NtUserCloseWindowStation",
	L"NtUserConsoleControl",
	L"NtUserConvertMemHandle",
	L"NtUserCopyAcceleratorTable",
	L"NtUserCountClipboardFormats",
	L"NtUserCreateAcceleratorTable",
	L"NtUserCreateCaret",
	L"NtUserCreateDesktop",
	L"NtUserCreateInputContext",
	L"NtUserCreateLocalMemHandle",
	L"NtUserCreateWindowEx",
	L"NtUserCreateWindowStation",
	L"NtUserDdeGetQualityOfService",
	L"NtUserDdeInitialize",
	L"NtUserDdeSetQualityOfService",
	L"NtUserDeferWindowPos",
	L"NtUserDefSetText",
	L"NtUserDeleteMenu",
	L"NtUserDestroyAcceleratorTable",
	L"NtUserDestroyCursor",
	L"NtUserDestroyInputContext",
	L"NtUserDestroyMenu",
	L"NtUserDestroyWindow",
	L"NtUserDisableThreadIme",
	L"NtUserDispatchMessage",
	L"NtUserDragDetect",
	L"NtUserDragObject",
	L"NtUserDrawAnimatedRects",
	L"NtUserDrawCaption",
	L"NtUserDrawCaptionTemp",
	L"NtUserDrawIconEx",
	L"NtUserDrawMenuBarTemp",
	L"NtUserEmptyClipboard",
	L"NtUserEnableMenuItem",
	L"NtUserEnableScrollBar",
	L"NtUserEndDeferWindowPosEx",
	L"NtUserEndMenu",
	L"NtUserEndPaint",
	L"NtUserEnumDisplayDevices",
	L"NtUserEnumDisplayMonitors",
	L"NtUserEnumDisplaySettings",
	L"NtUserEvent",
	L"NtUserExcludeUpdateRgn",
	L"NtUserFillWindow",
	L"NtUserFindExistingCursorIcon",
	L"NtUserFindWindowEx",
	L"NtUserFlashWindowEx",
	L"NtUserGetAltTabInfo",
	L"NtUserGetAncestor",
	L"NtUserGetAppImeLevel",
	L"NtUserGetAsyncKeyState",
	L"NtUserGetCaretBlinkTime",
	L"NtUserGetCaretPos",
	L"NtUserGetClassInfo",
	L"NtUserGetClassName",
	L"NtUserGetClipboardData",
	L"NtUserGetClipboardFormatName",
	L"NtUserGetClipboardOwner",
	L"NtUserGetClipboardSequenceNumber",
	L"NtUserGetClipboardViewer",
	L"NtUserGetClipCursor",
	L"NtUserGetComboBoxInfo",
	L"NtUserGetControlBrush",
	L"NtUserGetControlColor",
	L"NtUserGetCPD",
	L"NtUserGetCursorFrameInfo",
	L"NtUserGetCursorInfo",
	L"NtUserGetDC",
	L"NtUserGetDCEx",
	L"NtUserGetDoubleClickTime",
	L"NtUserGetForegroundWindow",
	L"NtUserGetGuiResources",
	L"NtUserGetGUIThreadInfo",
	L"NtUserGetIconInfo",
	L"NtUserGetIconSize",
	L"NtUserGetImeHotKey",
	L"NtUserGetImeInfoEx",
	L"NtUserGetInternalWindowPos",
	L"NtUserGetKeyboardLayoutList",
	L"NtUserGetKeyboardLayoutName",
	L"NtUserGetKeyboardState",
	L"NtUserGetKeyNameText",
	L"NtUserGetKeyState",
	L"NtUserGetListBoxInfo",
	L"NtUserGetMenuBarInfo",
	L"NtUserGetMenuIndex",
	L"NtUserGetMenuItemRect",
	L"NtUserGetMessage",
	L"NtUserGetMouseMovePointsEx",
	L"NtUserGetObjectInformation",
	L"NtUserGetOpenClipboardWindow",
	L"NtUserGetPriorityClipboardFormat",
	L"NtUserGetProcessWindowStation",
	L"NtUserGetScrollBarInfo",
	L"NtUserGetSystemMenu",
	L"NtUserGetThreadDesktop",
	L"NtUserGetThreadState",
	L"NtUserGetTitleBarInfo",
	L"NtUserGetUpdateRect",
	L"NtUserGetUpdateRgn",
	L"NtUserGetWindowDC",
	L"NtUserGetWindowPlacement",
	L"NtUserGetWOWClass",
	L"NtUserHardErrorControl",
	L"NtUserHideCaret",
	L"NtUserHiliteMenuItem",
	L"NtUserImpersonateDdeClientWindow",
	L"NtUserInitialize",
	L"NtUserInitializeClientPfnArrays",
	L"NtUserInitTask",
	L"NtUserInternalGetWindowText",
	L"NtUserInvalidateRect",
	L"NtUserInvalidateRgn",
	L"NtUserIsClipboardFormatAvailable",
	L"NtUserKillTimer",
	L"NtUserLoadKeyboardLayoutEx",
	L"NtUserLockWindowStation",
	L"NtUserLockWindowUpdate",
	L"NtUserLockWorkStation",
	L"NtUserMapVirtualKeyEx",
	L"NtUserMenuItemFromPoint",
	L"NtUserMessageCall",
	L"NtUserMinMaximize",
	L"NtUserMNDragLeave",
	L"NtUserMNDragOver",
	L"NtUserModifyUserStartupInfoFlags",
	L"NtUserMoveWindow",
	L"NtUserNotifyIMEStatus",
	L"NtUserNotifyProcessCreate",
	L"NtUserNotifyWinEvent",
	L"NtUserOpenClipboard",
	L"NtUserOpenDesktop",
	L"NtUserOpenInputDesktop",
	L"NtUserOpenWindowStation",
	L"NtUserPaintDesktop",
	L"NtUserPeekMessage",
	L"NtUserPostMessage",
	L"NtUserPostThreadMessage",
	L"NtUserProcessConnect",
	L"NtUserQueryInformationThread",
	L"NtUserQueryInputContext",
	L"NtUserQuerySendMessage",
	L"NtUserQueryUserCounters",
	L"NtUserQueryWindow",
	L"NtUserRealChildWindowFromPoint",
	L"NtUserRedrawWindow",
	L"NtUserRegisterClassExWOW",
	L"NtUserRegisterHotKey",
	L"NtUserRegisterTasklist",
	L"NtUserRegisterWindowMessage",
	L"NtUserRemoveMenu",
	L"NtUserRemoveProp",
	L"NtUserResolveDesktop",
	L"NtUserResolveDesktopForWOW",
	L"NtUserSBGetParms",
	L"NtUserScrollDC",
	L"NtUserScrollWindowEx",
	L"NtUserSelectPalette",
	L"NtUserSendInput",
	L"NtUserSendMessageCallback",
	L"NtUserSendNotifyMessage",
	L"NtUserSetActiveWindow",
	L"NtUserSetAppImeLevel",
	L"NtUserSetCapture",
	L"NtUserSetClassLong",
	L"NtUserSetClassWord",
	L"NtUserSetClipboardData",
	L"NtUserSetClipboardViewer",
	L"NtUserSetConsoleReserveKeys",
	L"NtUserSetCursor",
	L"NtUserSetCursorContents",
	L"NtUserSetCursorIconData",
	L"NtUserSetDbgTag",
	L"NtUserSetFocus",
	L"NtUserSetImeHotKey",
	L"NtUserSetImeInfoEx",
	L"NtUserSetImeOwnerWindow",
	L"NtUserSetInformationProcess",
	L"NtUserSetInformationThread",
	L"NtUserSetInternalWindowPos",
	L"NtUserSetKeyboardState",
	L"NtUserSetLogonNotifyWindow",
	L"NtUserSetMenu",
	L"NtUserSetMenuContextHelpId",
	L"NtUserSetMenuDefaultItem",
	L"NtUserSetMenuFlagRtoL",
	L"NtUserSetObjectInformation",
	L"NtUserSetParent",
	L"NtUserSetProcessWindowStation",
	L"NtUserSetProp",
	L"NtUserSetRipFlags",
	L"NtUserSetScrollInfo",
	L"NtUserSetShellWindowEx",
	L"NtUserSetSysColors",
	L"NtUserSetSystemCursor",
	L"NtUserSetSystemMenu",
	L"NtUserSetSystemTimer",
	L"NtUserSetThreadDesktop",
	L"NtUserSetThreadLayoutHandles",
	L"NtUserSetThreadState",
	L"NtUserSetTimer",
	L"NtUserSetWindowFNID",
	L"NtUserSetWindowLong",
	L"NtUserSetWindowPlacement",
	L"NtUserSetWindowPos",
	L"NtUserSetWindowRgn",
	L"NtUserSetWindowsHookAW",
	L"NtUserSetWindowsHookEx",
	L"NtUserSetWindowStationUser",
	L"NtUserSetWindowWord",
	L"NtUserSetWinEventHook",
	L"NtUserShowCaret",
	L"NtUserShowScrollBar",
	L"NtUserShowWindow",
	L"NtUserShowWindowAsync",
	L"NtUserSoundSentry",
	L"NtUserSwitchDesktop",
	L"NtUserSystemParametersInfo",
	L"NtUserTestForInteractiveUser",
	L"NtUserThunkedMenuInfo",
	L"NtUserThunkedMenuItemInfo",
	L"NtUserToUnicodeEx",
	L"NtUserTrackMouseEvent",
	L"NtUserTrackPopupMenuEx",
	L"NtUserTranslateAccelerator",
	L"NtUserTranslateMessage",
	L"NtUserUnhookWindowsHookEx",
	L"NtUserUnhookWinEvent",
	L"NtUserUnloadKeyboardLayout",
	L"NtUserUnlockWindowStation",
	L"NtUserUnregisterClass",
	L"NtUserUnregisterHotKey",
	L"NtUserUpdateInputContext",
	L"NtUserUpdateInstance",
	L"NtUserUpdateLayeredWindow",
	L"NtUserSetLayeredWindowAttributes",
	L"NtUserUpdatePerUserSystemParameters",
	L"NtUserUserHandleGrantAccess",
	L"NtUserValidateHandleSecure",
	L"NtUserValidateRect",
	L"NtUserVkKeyScanEx",
	L"NtUserWaitForInputIdle",
	L"NtUserWaitForMsgAndEvent",
	L"NtUserWaitMessage",
	L"NtUserWin32PoolAllocationStats",
	L"NtUserWindowFromPoint",
	L"NtUserYieldTask",
	L"NtUserRemoteConnect",
	L"NtUserRemoteRedrawRectangle",
	L"NtUserRemoteRedrawScreen",
	L"NtUserRemoteStopScreenUpdates",
	L"NtUserCtxDisplayIOCtl",
	L"NtGdiEngAssociateSurface",
	L"NtGdiEngCreateBitmap",
	L"NtGdiEngCreateDeviceSurface",
	L"NtGdiEngCreateDeviceBitmap",
	L"NtGdiEngCreatePalette",
	L"NtGdiEngComputeGlyphSet",
	L"NtGdiEngCopyBits",
	L"NtGdiEngDeletePalette",
	L"NtGdiEngDeleteSurface",
	L"NtGdiEngEraseSurface",
	L"NtGdiEngUnlockSurface",
	L"NtGdiEngLockSurface",
	L"NtGdiEngBitBlt",
	L"NtGdiEngStretchBlt",
	L"NtGdiEngPlgBlt",
	L"NtGdiEngMarkBandingSurface",
	L"NtGdiEngStrokePath",
	L"NtGdiEngFillPath",
	L"NtGdiEngStrokeAndFillPath",
	L"NtGdiEngPaint",
	L"NtGdiEngLineTo",
	L"NtGdiEngAlphaBlend",
	L"NtGdiEngGradientFill",
	L"NtGdiEngTransparentBlt",
	L"NtGdiEngTextOut",
	L"NtGdiEngStretchBltROP",
	L"NtGdiXLATEOBJ_cGetPalette",
	L"NtGdiXLATEOBJ_iXlate",
	L"NtGdiXLATEOBJ_hGetColorTransform",
	L"NtGdiCLIPOBJ_bEnum",
	L"NtGdiCLIPOBJ_cEnumStart",
	L"NtGdiCLIPOBJ_ppoGetPath",
	L"NtGdiEngDeletePath",
	L"NtGdiEngCreateClip",
	L"NtGdiEngDeleteClip",
	L"NtGdiBRUSHOBJ_ulGetBrushColor",
	L"NtGdiBRUSHOBJ_pvAllocRbrush",
	L"NtGdiBRUSHOBJ_pvGetRbrush",
	L"NtGdiBRUSHOBJ_hGetColorTransform",
	L"NtGdiXFORMOBJ_bApplyXform",
	L"NtGdiXFORMOBJ_iGetXform",
	L"NtGdiFONTOBJ_vGetInfo",
	L"NtGdiFONTOBJ_pxoGetXform",
	L"NtGdiFONTOBJ_cGetGlyphs",
	L"NtGdiFONTOBJ_pifi",
	L"NtGdiFONTOBJ_pfdg",
	L"NtGdiFONTOBJ_pQueryGlyphAttrs",
	L"NtGdiFONTOBJ_pvTrueTypeFontFile",
	L"NtGdiFONTOBJ_cGetAllGlyphHandles",
	L"NtGdiSTROBJ_bEnum",
	L"NtGdiSTROBJ_bEnumPositionsOnly",
	L"NtGdiSTROBJ_bGetAdvanceWidths",
	L"NtGdiSTROBJ_vEnumStart",
	L"NtGdiSTROBJ_dwGetCodePage",
	L"NtGdiPATHOBJ_vGetBounds",
	L"NtGdiPATHOBJ_bEnum",
	L"NtGdiPATHOBJ_vEnumStart",
	L"NtGdiPATHOBJ_vEnumStartClipLines",
	L"NtGdiPATHOBJ_bEnumClipLines",
	L"NtGdiGetDhpdev",
	L"NtGdiEngCheckAbort",
	L"NtGdiHT_Get8BPPFormatPalette",
	L"NtGdiHT_Get8BPPMaskPalette",
	L"NtGdiUpdateTransform",
	L"NtUserValidateTimerCallback"
};

TCHAR *XpShadow[] = 
{
	TEXT("NtGdiAbortDoc"),
	TEXT("NtGdiAbortPath"),
	TEXT("NtGdiAddFontResourceW"),
	TEXT("NtGdiAddRemoteFontToDC"),
	TEXT("NtGdiAddFontMemResourceEx"),
	TEXT("NtGdiRemoveMergeFont"),
	TEXT("NtGdiAddRemoteMMInstanceToDC"),
	TEXT("NtGdiAlphaBlend"),
	TEXT("NtGdiAngleArc"),
	TEXT("NtGdiAnyLinkedFonts"),
	TEXT("NtGdiFontIsLinked"),
	TEXT("NtGdiArcInternal"),
	TEXT("NtGdiBeginPath"),
	TEXT("NtGdiBitBlt"),
	TEXT("NtGdiCancelDC"),
	TEXT("NtGdiCheckBitmapBits"),
	TEXT("NtGdiCloseFigure"),
	TEXT("NtGdiClearBitmapAttributes"),
	TEXT("NtGdiClearBrushAttributes"),
	TEXT("NtGdiColorCorrectPalette"),
	TEXT("NtGdiCombineRgn"),
	TEXT("NtGdiCombineTransform"),
	TEXT("NtGdiComputeXformCoefficients"),
	TEXT("NtGdiConsoleTextOut"),
	TEXT("NtGdiConvertMetafileRect"),
	TEXT("NtGdiCreateBitmap"),
	TEXT("NtGdiCreateClientObj"),
	TEXT("NtGdiCreateColorSpace"),
	TEXT("NtGdiCreateColorTransform"),
	TEXT("NtGdiCreateCompatibleBitmap"),
	TEXT("NtGdiCreateCompatibleDC"),
	TEXT("NtGdiCreateDIBBrush"),
	TEXT("NtGdiCreateDIBitmapInternal"),
	TEXT("NtGdiCreateDIBSection"),
	TEXT("NtGdiCreateEllipticRgn"),
	TEXT("NtGdiCreateHalftonePalette"),
	TEXT("NtGdiCreateHatchBrushInternal"),
	TEXT("NtGdiCreateMetafileDC"),
	TEXT("NtGdiCreatePaletteInternal"),
	TEXT("NtGdiCreatePatternBrushInternal"),
	TEXT("NtGdiCreatePen"),
	TEXT("NtGdiCreateRectRgn"),
	TEXT("NtGdiCreateRoundRectRgn"),
	TEXT("NtGdiCreateServerMetaFile"),
	TEXT("NtGdiCreateSolidBrush"),
	TEXT("NtGdiD3dContextCreate"),
	TEXT("NtGdiD3dContextDestroy"),
	TEXT("NtGdiD3dContextDestroyAll"),
	TEXT("NtGdiD3dValidateTextureStageState"),
	TEXT("NtGdiD3dDrawPrimitives2"),
	TEXT("NtGdiDdGetDriverState"),
	TEXT("NtGdiDdAddAttachedSurface"),
	TEXT("NtGdiDdAlphaBlt"),
	TEXT("NtGdiDdAttachSurface"),
	TEXT("NtGdiDdBeginMoCompFrame"),
	TEXT("NtGdiDdBlt"),
	TEXT("NtGdiDdCanCreateSurface"),
	TEXT("NtGdiDdCanCreateD3DBuffer"),
	TEXT("NtGdiDdColorControl"),
	TEXT("NtGdiDdCreateDirectDrawObject"),
	TEXT("NtGdiDdCreateSurface"),
	TEXT("NtGdiDdCreateD3DBuffer"),
	TEXT("NtGdiDdCreateMoComp"),
	TEXT("NtGdiDdCreateSurfaceObject"),
	TEXT("NtGdiDdDeleteDirectDrawObject"),
	TEXT("NtGdiDdDeleteSurfaceObject"),
	TEXT("NtGdiDdDestroyMoComp"),
	TEXT("NtGdiDdDestroySurface"),
	TEXT("NtGdiDdDestroyD3DBuffer"),
	TEXT("NtGdiDdEndMoCompFrame"),
	TEXT("NtGdiDdFlip"),
	TEXT("NtGdiDdFlipToGDISurface"),
	TEXT("NtGdiDdGetAvailDriverMemory"),
	TEXT("NtGdiDdGetBltStatus"),
	TEXT("NtGdiDdGetDC"),
	TEXT("NtGdiDdGetDriverInfo"),
	TEXT("NtGdiDdGetDxHandle"),
	TEXT("NtGdiDdGetFlipStatus"),
	TEXT("NtGdiDdGetInternalMoCompInfo"),
	TEXT("NtGdiDdGetMoCompBuffInfo"),
	TEXT("NtGdiDdGetMoCompGuids"),
	TEXT("NtGdiDdGetMoCompFormats"),
	TEXT("NtGdiDdGetScanLine"),
	TEXT("NtGdiDdLock"),
	TEXT("NtGdiDdLockD3D"),
	TEXT("NtGdiDdQueryDirectDrawObject"),
	TEXT("NtGdiDdQueryMoCompStatus"),
	TEXT("NtGdiDdReenableDirectDrawObject"),
	TEXT("NtGdiDdReleaseDC"),
	TEXT("NtGdiDdRenderMoComp"),
	TEXT("NtGdiDdResetVisrgn"),
	TEXT("NtGdiDdSetColorKey"),
	TEXT("NtGdiDdSetExclusiveMode"),
	TEXT("NtGdiDdSetGammaRamp"),
	TEXT("NtGdiDdCreateSurfaceEx"),
	TEXT("NtGdiDdSetOverlayPosition"),
	TEXT("NtGdiDdUnattachSurface"),
	TEXT("NtGdiDdUnlock"),
	TEXT("NtGdiDdUnlockD3D"),
	TEXT("NtGdiDdUpdateOverlay"),
	TEXT("NtGdiDdWaitForVerticalBlank"),
	TEXT("NtGdiDvpCanCreateVideoPort"),
	TEXT("NtGdiDvpColorControl"),
	TEXT("NtGdiDvpCreateVideoPort"),
	TEXT("NtGdiDvpDestroyVideoPort"),
	TEXT("NtGdiDvpFlipVideoPort"),
	TEXT("NtGdiDvpGetVideoPortBandwidth"),
	TEXT("NtGdiDvpGetVideoPortField"),
	TEXT("NtGdiDvpGetVideoPortFlipStatus"),
	TEXT("NtGdiDvpGetVideoPortInputFormats"),
	TEXT("NtGdiDvpGetVideoPortLine"),
	TEXT("NtGdiDvpGetVideoPortOutputFormats"),
	TEXT("NtGdiDvpGetVideoPortConnectInfo"),
	TEXT("NtGdiDvpGetVideoSignalStatus"),
	TEXT("NtGdiDvpUpdateVideoPort"),
	TEXT("NtGdiDvpWaitForVideoPortSync"),
	TEXT("NtGdiDvpAcquireNotification"),
	TEXT("NtGdiDvpReleaseNotification"),
	TEXT("NtGdiDxgGenericThunk"),
	TEXT("NtGdiDeleteClientObj"),
	TEXT("NtGdiDeleteColorSpace"),
	TEXT("NtGdiDeleteColorTransform"),
	TEXT("NtGdiDeleteObjectApp"),
	TEXT("NtGdiDescribePixelFormat"),
	TEXT("NtGdiGetPerBandInfo"),
	TEXT("NtGdiDoBanding"),
	TEXT("NtGdiDoPalette"),
	TEXT("NtGdiDrawEscape"),
	TEXT("NtGdiEllipse"),
	TEXT("NtGdiEnableEudc"),
	TEXT("NtGdiEndDoc"),
	TEXT("NtGdiEndPage"),
	TEXT("NtGdiEndPath"),
	TEXT("NtGdiEnumFontChunk"),
	TEXT("NtGdiEnumFontClose"),
	TEXT("NtGdiEnumFontOpen"),
	TEXT("NtGdiEnumObjects"),
	TEXT("NtGdiEqualRgn"),
	TEXT("NtGdiEudcLoadUnloadLink"),
	TEXT("NtGdiExcludeClipRect"),
	TEXT("NtGdiExtCreatePen"),
	TEXT("NtGdiExtCreateRegion"),
	TEXT("NtGdiExtEscape"),
	TEXT("NtGdiExtFloodFill"),
	TEXT("NtGdiExtGetObjectW"),
	TEXT("NtGdiExtSelectClipRgn"),
	TEXT("NtGdiExtTextOutW"),
	TEXT("NtGdiFillPath"),
	TEXT("NtGdiFillRgn"),
	TEXT("NtGdiFlattenPath"),
	TEXT("NtGdiFlushUserBatch"),
	TEXT("NtGdiFlush"),
	TEXT("NtGdiForceUFIMapping"),
	TEXT("NtGdiFrameRgn"),
	TEXT("NtGdiFullscreenControl"),
	TEXT("NtGdiGetAndSetDCDword"),
	TEXT("NtGdiGetAppClipBox"),
	TEXT("NtGdiGetBitmapBits"),
	TEXT("NtGdiGetBitmapDimension"),
	TEXT("NtGdiGetBoundsRect"),
	TEXT("NtGdiGetCharABCWidthsW"),
	TEXT("NtGdiGetCharacterPlacementW"),
	TEXT("NtGdiGetCharSet"),
	TEXT("NtGdiGetCharWidthW"),
	TEXT("NtGdiGetCharWidthInfo"),
	TEXT("NtGdiGetColorAdjustment"),
	TEXT("NtGdiGetColorSpaceforBitmap"),
	TEXT("NtGdiGetDCDword"),
	TEXT("NtGdiGetDCforBitmap"),
	TEXT("NtGdiGetDCObject"),
	TEXT("NtGdiGetDCPoint"),
	TEXT("NtGdiGetDeviceCaps"),
	TEXT("NtGdiGetDeviceGammaRamp"),
	TEXT("NtGdiGetDeviceCapsAll"),
	TEXT("NtGdiGetDIBitsInternal"),
	TEXT("NtGdiGetETM"),
	TEXT("NtGdiGetEudcTimeStampEx"),
	TEXT("NtGdiGetFontData"),
	TEXT("NtGdiGetFontResourceInfoInternalW"),
	TEXT("NtGdiGetGlyphIndicesW"),
	TEXT("NtGdiGetGlyphIndicesWInternal"),
	TEXT("NtGdiGetGlyphOutline"),
	TEXT("NtGdiGetKerningPairs"),
	TEXT("NtGdiGetLinkedUFIs"),
	TEXT("NtGdiGetMiterLimit"),
	TEXT("NtGdiGetMonitorID"),
	TEXT("NtGdiGetNearestColor"),
	TEXT("NtGdiGetNearestPaletteIndex"),
	TEXT("NtGdiGetObjectBitmapHandle"),
	TEXT("NtGdiGetOutlineTextMetricsInternalW"),
	TEXT("NtGdiGetPath"),
	TEXT("NtGdiGetPixel"),
	TEXT("NtGdiGetRandomRgn"),
	TEXT("NtGdiGetRasterizerCaps"),
	TEXT("NtGdiGetRealizationInfo"),
	TEXT("NtGdiGetRegionData"),
	TEXT("NtGdiGetRgnBox"),
	TEXT("NtGdiGetServerMetaFileBits"),
	TEXT("NtGdiGetSpoolMessage"),
	TEXT("NtGdiGetStats"),
	TEXT("NtGdiGetStockObject"),
	TEXT("NtGdiGetStringBitmapW"),
	TEXT("NtGdiGetSystemPaletteUse"),
	TEXT("NtGdiGetTextCharsetInfo"),
	TEXT("NtGdiGetTextExtent"),
	TEXT("NtGdiGetTextExtentExW"),
	TEXT("NtGdiGetTextFaceW"),
	TEXT("NtGdiGetTextMetricsW"),
	TEXT("NtGdiGetTransform"),
	TEXT("NtGdiGetUFI"),
	TEXT("NtGdiGetEmbUFI"),
	TEXT("NtGdiGetUFIPathname"),
	TEXT("NtGdiGetEmbedFonts"),
	TEXT("NtGdiChangeGhostFont"),
	TEXT("NtGdiAddEmbFontToDC"),
	TEXT("NtGdiGetFontUnicodeRanges"),
	TEXT("NtGdiGetWidthTable"),
	TEXT("NtGdiGradientFill"),
	TEXT("NtGdiHfontCreate"),
	TEXT("NtGdiIcmBrushInfo"),
	TEXT("NtGdiInit"),
	TEXT("NtGdiInitSpool"),
	TEXT("NtGdiIntersectClipRect"),
	TEXT("NtGdiInvertRgn"),
	TEXT("NtGdiLineTo"),
	TEXT("NtGdiMakeFontDir"),
	TEXT("NtGdiMakeInfoDC"),
	TEXT("NtGdiMaskBlt"),
	TEXT("NtGdiModifyWorldTransform"),
	TEXT("NtGdiMonoBitmap"),
	TEXT("NtGdiMoveTo"),
	TEXT("NtGdiOffsetClipRgn"),
	TEXT("NtGdiOffsetRgn"),
	TEXT("NtGdiOpenDCW"),
	TEXT("NtGdiPatBlt"),
	TEXT("NtGdiPolyPatBlt"),
	TEXT("NtGdiPathToRegion"),
	TEXT("NtGdiPlgBlt"),
	TEXT("NtGdiPolyDraw"),
	TEXT("NtGdiPolyPolyDraw"),
	TEXT("NtGdiPolyTextOutW"),
	TEXT("NtGdiPtInRegion"),
	TEXT("NtGdiPtVisible"),
	TEXT("NtGdiQueryFonts"),
	TEXT("NtGdiQueryFontAssocInfo"),
	TEXT("NtGdiRectangle"),
	TEXT("NtGdiRectInRegion"),
	TEXT("NtGdiRectVisible"),
	TEXT("NtGdiRemoveFontResourceW"),
	TEXT("NtGdiRemoveFontMemResourceEx"),
	TEXT("NtGdiResetDC"),
	TEXT("NtGdiResizePalette"),
	TEXT("NtGdiRestoreDC"),
	TEXT("NtGdiRoundRect"),
	TEXT("NtGdiSaveDC"),
	TEXT("NtGdiScaleViewportExtEx"),
	TEXT("NtGdiScaleWindowExtEx"),
	TEXT("NtGdiSelectBitmap"),
	TEXT("NtGdiSelectBrush"),
	TEXT("NtGdiSelectClipPath"),
	TEXT("NtGdiSelectFont"),
	TEXT("NtGdiSelectPen"),
	TEXT("NtGdiSetBitmapAttributes"),
	TEXT("NtGdiSetBitmapBits"),
	TEXT("NtGdiSetBitmapDimension"),
	TEXT("NtGdiSetBoundsRect"),
	TEXT("NtGdiSetBrushAttributes"),
	TEXT("NtGdiSetBrushOrg"),
	TEXT("NtGdiSetColorAdjustment"),
	TEXT("NtGdiSetColorSpace"),
	TEXT("NtGdiSetDeviceGammaRamp"),
	TEXT("NtGdiSetDIBitsToDeviceInternal"),
	TEXT("NtGdiSetFontEnumeration"),
	TEXT("NtGdiSetFontXform"),
	TEXT("NtGdiSetIcmMode"),
	TEXT("NtGdiSetLinkedUFIs"),
	TEXT("NtGdiSetMagicColors"),
	TEXT("NtGdiSetMetaRgn"),
	TEXT("NtGdiSetMiterLimit"),
	TEXT("NtGdiGetDeviceWidth"),
	TEXT("NtGdiMirrorWindowOrg"),
	TEXT("NtGdiSetLayout"),
	TEXT("NtGdiSetPixel"),
	TEXT("NtGdiSetPixelFormat"),
	TEXT("NtGdiSetRectRgn"),
	TEXT("NtGdiSetSystemPaletteUse"),
	TEXT("NtGdiSetTextJustification"),
	TEXT("NtGdiSetupPublicCFONT"),
	TEXT("NtGdiSetVirtualResolution"),
	TEXT("NtGdiSetSizeDevice"),
	TEXT("NtGdiStartDoc"),
	TEXT("NtGdiStartPage"),
	TEXT("NtGdiStretchBlt"),
	TEXT("NtGdiStretchDIBitsInternal"),
	TEXT("NtGdiStrokeAndFillPath"),
	TEXT("NtGdiStrokePath"),
	TEXT("NtGdiSwapBuffers"),
	TEXT("NtGdiTransformPoints"),
	TEXT("NtGdiTransparentBlt"),
	TEXT("NtGdiUnloadPrinterDriver"),
	TEXT("NtGdiUnmapMemFont"),
	TEXT("NtGdiUnrealizeObject"),
	TEXT("NtGdiUpdateColors"),
	TEXT("NtGdiWidenPath"),
	TEXT("NtUserActivateKeyboardLayout"),
	TEXT("NtUserAlterWindowStyle"),
	TEXT("NtUserAssociateInputContext"),
	TEXT("NtUserAttachThreadInput"),
	TEXT("NtUserBeginPaint"),
	TEXT("NtUserBitBltSysBmp"),
	TEXT("NtUserBlockInput"),
	TEXT("NtUserBuildHimcList"),
	TEXT("NtUserBuildHwndList"),
	TEXT("NtUserBuildNameList"),
	TEXT("NtUserBuildPropList"),
	TEXT("NtUserCallHwnd"),
	TEXT("NtUserCallHwndLock"),
	TEXT("NtUserCallHwndOpt"),
	TEXT("NtUserCallHwndParam"),
	TEXT("NtUserCallHwndParamLock"),
	TEXT("NtUserCallMsgFilter"),
	TEXT("NtUserCallNextHookEx"),
	TEXT("NtUserCallNoParam"),
	TEXT("NtUserCallOneParam"),
	TEXT("NtUserCallTwoParam"),
	TEXT("NtUserChangeClipboardChain"),
	TEXT("NtUserChangeDisplaySettings"),
	TEXT("NtUserCheckImeHotKey"),
	TEXT("NtUserCheckMenuItem"),
	TEXT("NtUserChildWindowFromPointEx"),
	TEXT("NtUserClipCursor"),
	TEXT("NtUserCloseClipboard"),
	TEXT("NtUserCloseDesktop"),
	TEXT("NtUserCloseWindowStation"),
	TEXT("NtUserConsoleControl"),
	TEXT("NtUserConvertMemHandle"),
	TEXT("NtUserCopyAcceleratorTable"),
	TEXT("NtUserCountClipboardFormats"),
	TEXT("NtUserCreateAcceleratorTable"),
	TEXT("NtUserCreateCaret"),
	TEXT("NtUserCreateDesktop"),
	TEXT("NtUserCreateInputContext"),
	TEXT("NtUserCreateLocalMemHandle"),
	TEXT("NtUserCreateWindowEx"),
	TEXT("NtUserCreateWindowStation"),
	TEXT("NtUserDdeGetQualityOfService"),
	TEXT("NtUserDdeInitialize"),
	TEXT("NtUserDdeSetQualityOfService"),
	TEXT("NtUserDeferWindowPos"),
	TEXT("NtUserDefSetText"),
	TEXT("NtUserDeleteMenu"),
	TEXT("NtUserDestroyAcceleratorTable"),
	TEXT("NtUserDestroyCursor"),
	TEXT("NtUserDestroyInputContext"),
	TEXT("NtUserDestroyMenu"),
	TEXT("NtUserDestroyWindow"),
	TEXT("NtUserDisableThreadIme"),
	TEXT("NtUserDispatchMessage"),
	TEXT("NtUserDragDetect"),
	TEXT("NtUserDragObject"),
	TEXT("NtUserDrawAnimatedRects"),
	TEXT("NtUserDrawCaption"),
	TEXT("NtUserDrawCaptionTemp"),
	TEXT("NtUserDrawIconEx"),
	TEXT("NtUserDrawMenuBarTemp"),
	TEXT("NtUserEmptyClipboard"),
	TEXT("NtUserEnableMenuItem"),
	TEXT("NtUserEnableScrollBar"),
	TEXT("NtUserEndDeferWindowPosEx"),
	TEXT("NtUserEndMenu"),
	TEXT("NtUserEndPaint"),
	TEXT("NtUserEnumDisplayDevices"),
	TEXT("NtUserEnumDisplayMonitors"),
	TEXT("NtUserEnumDisplaySettings"),
	TEXT("NtUserEvent"),
	TEXT("NtUserExcludeUpdateRgn"),
	TEXT("NtUserFillWindow"),
	TEXT("NtUserFindExistingCursorIcon"),
	TEXT("NtUserFindWindowEx"),
	TEXT("NtUserFlashWindowEx"),
	TEXT("NtUserGetAltTabInfo"),
	TEXT("NtUserGetAncestor"),
	TEXT("NtUserGetAppImeLevel"),
	TEXT("NtUserGetAsyncKeyState"),
	TEXT("NtUserGetAtomName"),
	TEXT("NtUserGetCaretBlinkTime"),
	TEXT("NtUserGetCaretPos"),
	TEXT("NtUserGetClassInfo"),
	TEXT("NtUserGetClassName"),
	TEXT("NtUserGetClipboardData"),
	TEXT("NtUserGetClipboardFormatName"),
	TEXT("NtUserGetClipboardOwner"),
	TEXT("NtUserGetClipboardSequenceNumber"),
	TEXT("NtUserGetClipboardViewer"),
	TEXT("NtUserGetClipCursor"),
	TEXT("NtUserGetComboBoxInfo"),
	TEXT("NtUserGetControlBrush"),
	TEXT("NtUserGetControlColor"),
	TEXT("NtUserGetCPD"),
	TEXT("NtUserGetCursorFrameInfo"),
	TEXT("NtUserGetCursorInfo"),
	TEXT("NtUserGetDC"),
	TEXT("NtUserGetDCEx"),
	TEXT("NtUserGetDoubleClickTime"),
	TEXT("NtUserGetForegroundWindow"),
	TEXT("NtUserGetGuiResources"),
	TEXT("NtUserGetGUIThreadInfo"),
	TEXT("NtUserGetIconInfo"),
	TEXT("NtUserGetIconSize"),
	TEXT("NtUserGetImeHotKey"),
	TEXT("NtUserGetImeInfoEx"),
	TEXT("NtUserGetInternalWindowPos"),
	TEXT("NtUserGetKeyboardLayoutList"),
	TEXT("NtUserGetKeyboardLayoutName"),
	TEXT("NtUserGetKeyboardState"),
	TEXT("NtUserGetKeyNameText"),
	TEXT("NtUserGetKeyState"),
	TEXT("NtUserGetListBoxInfo"),
	TEXT("NtUserGetMenuBarInfo"),
	TEXT("NtUserGetMenuIndex"),
	TEXT("NtUserGetMenuItemRect"),
	TEXT("NtUserGetMessage"),
	TEXT("NtUserGetMouseMovePointsEx"),
	TEXT("NtUserGetObjectInformation"),
	TEXT("NtUserGetOpenClipboardWindow"),
	TEXT("NtUserGetPriorityClipboardFormat"),
	TEXT("NtUserGetProcessWindowStation"),
	TEXT("NtUserGetRawInputBuffer"),
	TEXT("NtUserGetRawInputData"),
	TEXT("NtUserGetRawInputDeviceInfo"),
	TEXT("NtUserGetRawInputDeviceList"),
	TEXT("NtUserGetRegisteredRawInputDevices"),
	TEXT("NtUserGetScrollBarInfo"),
	TEXT("NtUserGetSystemMenu"),
	TEXT("NtUserGetThreadDesktop"),
	TEXT("NtUserGetThreadState"),
	TEXT("NtUserGetTitleBarInfo"),
	TEXT("NtUserGetUpdateRect"),
	TEXT("NtUserGetUpdateRgn"),
	TEXT("NtUserGetWindowDC"),
	TEXT("NtUserGetWindowPlacement"),
	TEXT("NtUserGetWOWClass"),
	TEXT("NtUserHardErrorControl"),
	TEXT("NtUserHideCaret"),
	TEXT("NtUserHiliteMenuItem"),
	TEXT("NtUserImpersonateDdeClientWindow"),
	TEXT("NtUserInitialize"),
	TEXT("NtUserInitializeClientPfnArrays"),
	TEXT("NtUserInitTask"),
	TEXT("NtUserInternalGetWindowText"),
	TEXT("NtUserInvalidateRect"),
	TEXT("NtUserInvalidateRgn"),
	TEXT("NtUserIsClipboardFormatAvailable"),
	TEXT("NtUserKillTimer"),
	TEXT("NtUserLoadKeyboardLayoutEx"),
	TEXT("NtUserLockWindowStation"),
	TEXT("NtUserLockWindowUpdate"),
	TEXT("NtUserLockWorkStation"),
	TEXT("NtUserMapVirtualKeyEx"),
	TEXT("NtUserMenuItemFromPoint"),
	TEXT("NtUserMessageCall"),
	TEXT("NtUserMinMaximize"),
	TEXT("NtUserMNDragLeave"),
	TEXT("NtUserMNDragOver"),
	TEXT("NtUserModifyUserStartupInfoFlags"),
	TEXT("NtUserMoveWindow"),
	TEXT("NtUserNotifyIMEStatus"),
	TEXT("NtUserNotifyProcessCreate"),
	TEXT("NtUserNotifyWinEvent"),
	TEXT("NtUserOpenClipboard"),
	TEXT("NtUserOpenDesktop"),
	TEXT("NtUserOpenInputDesktop"),
	TEXT("NtUserOpenWindowStation"),
	TEXT("NtUserPaintDesktop"),
	TEXT("NtUserPeekMessage"),
	TEXT("NtUserPostMessage"),
	TEXT("NtUserPostThreadMessage"),
	TEXT("NtUserPrintWindow"),
	TEXT("NtUserProcessConnect"),
	TEXT("NtUserQueryInformationThread"),
	TEXT("NtUserQueryInputContext"),
	TEXT("NtUserQuerySendMessage"),
	TEXT("NtUserQueryUserCounters"),
	TEXT("NtUserQueryWindow"),
	TEXT("NtUserRealChildWindowFromPoint"),
	TEXT("NtUserRealInternalGetMessage"),
	TEXT("NtUserRealWaitMessageEx"),
	TEXT("NtUserRedrawWindow"),
	TEXT("NtUserRegisterClassExWOW"),
	TEXT("NtUserRegisterUserApiHook"),
	TEXT("NtUserRegisterHotKey"),
	TEXT("NtUserRegisterRawInputDevices"),
	TEXT("NtUserRegisterTasklist"),
	TEXT("NtUserRegisterWindowMessage"),
	TEXT("NtUserRemoveMenu"),
	TEXT("NtUserRemoveProp"),
	TEXT("NtUserResolveDesktop"),
	TEXT("NtUserResolveDesktopForWOW"),
	TEXT("NtUserSBGetParms"),
	TEXT("NtUserScrollDC"),
	TEXT("NtUserScrollWindowEx"),
	TEXT("NtUserSelectPalette"),
	TEXT("NtUserSendInput"),
	TEXT("NtUserSetActiveWindow"),
	TEXT("NtUserSetAppImeLevel"),
	TEXT("NtUserSetCapture"),
	TEXT("NtUserSetClassLong"),
	TEXT("NtUserSetClassWord"),
	TEXT("NtUserSetClipboardData"),
	TEXT("NtUserSetClipboardViewer"),
	TEXT("NtUserSetConsoleReserveKeys"),
	TEXT("NtUserSetCursor"),
	TEXT("NtUserSetCursorContents"),
	TEXT("NtUserSetCursorIconData"),
	TEXT("NtUserSetDbgTag"),
	TEXT("NtUserSetFocus"),
	TEXT("NtUserSetImeHotKey"),
	TEXT("NtUserSetImeInfoEx"),
	TEXT("NtUserSetImeOwnerWindow"),
	TEXT("NtUserSetInformationProcess"),
	TEXT("NtUserSetInformationThread"),
	TEXT("NtUserSetInternalWindowPos"),
	TEXT("NtUserSetKeyboardState"),
	TEXT("NtUserSetLogonNotifyWindow"),
	TEXT("NtUserSetMenu"),
	TEXT("NtUserSetMenuContextHelpId"),
	TEXT("NtUserSetMenuDefaultItem"),
	TEXT("NtUserSetMenuFlagRtoL"),
	TEXT("NtUserSetObjectInformation"),
	TEXT("NtUserSetParent"),
	TEXT("NtUserSetProcessWindowStation"),
	TEXT("NtUserSetProp"),
	TEXT("NtUserSetRipFlags"),
	TEXT("NtUserSetScrollInfo"),
	TEXT("NtUserSetShellWindowEx"),
	TEXT("NtUserSetSysColors"),
	TEXT("NtUserSetSystemCursor"),
	TEXT("NtUserSetSystemMenu"),
	TEXT("NtUserSetSystemTimer"),
	TEXT("NtUserSetThreadDesktop"),
	TEXT("NtUserSetThreadLayoutHandles"),
	TEXT("NtUserSetThreadState"),
	TEXT("NtUserSetTimer"),
	TEXT("NtUserSetWindowFNID"),
	TEXT("NtUserSetWindowLong"),
	TEXT("NtUserSetWindowPlacement"),
	TEXT("NtUserSetWindowPos"),
	TEXT("NtUserSetWindowRgn"),
	TEXT("NtUserSetWindowsHookAW"),
	TEXT("NtUserSetWindowsHookEx"),
	TEXT("NtUserSetWindowStationUser"),
	TEXT("NtUserSetWindowWord"),
	TEXT("NtUserSetWinEventHook"),
	TEXT("NtUserShowCaret"),
	TEXT("NtUserShowScrollBar"),
	TEXT("NtUserShowWindow"),
	TEXT("NtUserShowWindowAsync"),
	TEXT("NtUserSoundSentry"),
	TEXT("NtUserSwitchDesktop"),
	TEXT("NtUserSystemParametersInfo"),
	TEXT("NtUserTestForInteractiveUser"),
	TEXT("NtUserThunkedMenuInfo"),
	TEXT("NtUserThunkedMenuItemInfo"),
	TEXT("NtUserToUnicodeEx"),
	TEXT("NtUserTrackMouseEvent"),
	TEXT("NtUserTrackPopupMenuEx"),
	TEXT("NtUserCalcMenuBar"),
	TEXT("NtUserPaintMenuBar"),
	TEXT("NtUserTranslateAccelerator"),
	TEXT("NtUserTranslateMessage"),
	TEXT("NtUserUnhookWindowsHookEx"),
	TEXT("NtUserUnhookWinEvent"),
	TEXT("NtUserUnloadKeyboardLayout"),
	TEXT("NtUserUnlockWindowStation"),
	TEXT("NtUserUnregisterClass"),
	TEXT("NtUserUnregisterUserApiHook"),
	TEXT("NtUserUnregisterHotKey"),
	TEXT("NtUserUpdateInputContext"),
	TEXT("NtUserUpdateInstance"),
	TEXT("NtUserUpdateLayeredWindow"),
	TEXT("NtUserGetLayeredWindowAttributes"),
	TEXT("NtUserSetLayeredWindowAttributes"),
	TEXT("NtUserUpdatePerUserSystemParameters"),
	TEXT("NtUserUserHandleGrantAccess"),
	TEXT("NtUserValidateHandleSecure"),
	TEXT("NtUserValidateRect"),
	TEXT("NtUserValidateTimerCallback"),
	TEXT("NtUserVkKeyScanEx"),
	TEXT("NtUserWaitForInputIdle"),
	TEXT("NtUserWaitForMsgAndEvent"),
	TEXT("NtUserWaitMessage"),
	TEXT("NtUserWin32PoolAllocationStats"),
	TEXT("NtUserWindowFromPoint"),
	TEXT("NtUserYieldTask"),
	TEXT("NtUserRemoteConnect"),
	TEXT("NtUserRemoteRedrawRectangle"),
	TEXT("NtUserRemoteRedrawScreen"),
	TEXT("NtUserRemoteStopScreenUpdates"),
	TEXT("NtUserCtxDisplayIOCtl"),
	TEXT("NtGdiEngAssociateSurface"),
	TEXT("NtGdiEngCreateBitmap"),
	TEXT("NtGdiEngCreateDeviceSurface"),
	TEXT("NtGdiEngCreateDeviceBitmap"),
	TEXT("NtGdiEngCreatePalette"),
	TEXT("NtGdiEngComputeGlyphSet"),
	TEXT("NtGdiEngCopyBits"),
	TEXT("NtGdiEngDeletePalette"),
	TEXT("NtGdiEngDeleteSurface"),
	TEXT("NtGdiEngEraseSurface"),
	TEXT("NtGdiEngUnlockSurface"),
	TEXT("NtGdiEngLockSurface"),
	TEXT("NtGdiEngBitBlt"),
	TEXT("NtGdiEngStretchBlt"),
	TEXT("NtGdiEngPlgBlt"),
	TEXT("NtGdiEngMarkBandingSurface"),
	TEXT("NtGdiEngStrokePath"),
	TEXT("NtGdiEngFillPath"),
	TEXT("NtGdiEngStrokeAndFillPath"),
	TEXT("NtGdiEngPaint"),
	TEXT("NtGdiEngLineTo"),
	TEXT("NtGdiEngAlphaBlend"),
	TEXT("NtGdiEngGradientFill"),
	TEXT("NtGdiEngTransparentBlt"),
	TEXT("NtGdiEngTextOut"),
	TEXT("NtGdiEngStretchBltROP"),
	TEXT("NtGdiXLATEOBJ_cGetPalette"),
	TEXT("NtGdiXLATEOBJ_iXlate"),
	TEXT("NtGdiXLATEOBJ_hGetColorTransform"),
	TEXT("NtGdiCLIPOBJ_bEnum"),
	TEXT("NtGdiCLIPOBJ_cEnumStart"),
	TEXT("NtGdiCLIPOBJ_ppoGetPath"),
	TEXT("NtGdiEngDeletePath"),
	TEXT("NtGdiEngCreateClip"),
	TEXT("NtGdiEngDeleteClip"),
	TEXT("NtGdiBRUSHOBJ_ulGetBrushColor"),
	TEXT("NtGdiBRUSHOBJ_pvAllocRbrush"),
	TEXT("NtGdiBRUSHOBJ_pvGetRbrush"),
	TEXT("NtGdiBRUSHOBJ_hGetColorTransform"),
	TEXT("NtGdiXFORMOBJ_bApplyXform"),
	TEXT("NtGdiXFORMOBJ_iGetXform"),
	TEXT("NtGdiFONTOBJ_vGetInfo"),
	TEXT("NtGdiFONTOBJ_pxoGetXform"),
	TEXT("NtGdiFONTOBJ_cGetGlyphs"),
	TEXT("NtGdiFONTOBJ_pifi"),
	TEXT("NtGdiFONTOBJ_pfdg"),
	TEXT("NtGdiFONTOBJ_pQueryGlyphAttrs"),
	TEXT("NtGdiFONTOBJ_pvTrueTypeFontFile"),
	TEXT("NtGdiFONTOBJ_cGetAllGlyphHandles"),
	TEXT("NtGdiSTROBJ_bEnum"),
	TEXT("NtGdiSTROBJ_bEnumPositionsOnly"),
	TEXT("NtGdiSTROBJ_bGetAdvanceWidths"),
	TEXT("NtGdiSTROBJ_vEnumStart"),
	TEXT("NtGdiSTROBJ_dwGetCodePage"),
	TEXT("NtGdiPATHOBJ_vGetBounds"),
	TEXT("NtGdiPATHOBJ_bEnum"),
	TEXT("NtGdiPATHOBJ_vEnumStart"),
	TEXT("NtGdiPATHOBJ_vEnumStartClipLines"),
	TEXT("NtGdiPATHOBJ_bEnumClipLines"),
	TEXT("NtGdiGetDhpdev"),
	TEXT("NtGdiEngCheckAbort"),
	TEXT("NtGdiHT_Get8BPPFormatPalette"),
	TEXT("NtGdiHT_Get8BPPMaskPalette"),
	TEXT("NtGdiUpdateTransform"),
	TEXT("NtGdiSetPUMPDOBJ"),
	TEXT("NtGdiBRUSHOBJ_DeleteRbrush"),
	TEXT("NtGdiUnmapMemFont"),
	TEXT("NtGdiDrawStream")
};

WCHAR *W2k3Shadow[] = {
	L"NtGdiAbortDoc",
	L"NtGdiAbortPath",
	L"NtGdiAddFontResourceW",
	L"NtGdiAddRemoteFontToDC",
	L"NtGdiAddFontMemResourceEx",
	L"NtGdiRemoveMergeFont",
	L"NtGdiAddRemoteMMInstanceToDC",
	L"NtGdiAlphaBlend",
	L"NtGdiAngleArc",
	L"NtGdiAnyLinkedFonts",
	L"NtGdiFontIsLinked",
	L"NtGdiArcInternal",
	L"NtGdiBeginPath",
	L"NtGdiBitBlt",
	L"NtGdiCancelDC",
	L"NtGdiCheckBitmapBits",
	L"NtGdiCloseFigure",
	L"NtGdiClearBitmapAttributes",
	L"NtGdiClearBrushAttributes",
	L"NtGdiColorCorrectPalette",
	L"NtGdiCombineRgn",
	L"NtGdiCombineTransform",
	L"NtGdiComputeXformCoefficients",
	L"NtGdiConsoleTextOut",
	L"NtGdiConvertMetafileRect",
	L"NtGdiCreateBitmap",
	L"NtGdiCreateClientObj",
	L"NtGdiCreateColorSpace",
	L"NtGdiCreateColorTransform",
	L"NtGdiCreateCompatibleBitmap",
	L"NtGdiCreateCompatibleDC",
	L"NtGdiCreateDIBBrush",
	L"NtGdiCreateDIBitmapInternal",
	L"NtGdiCreateDIBSection",
	L"NtGdiCreateEllipticRgn",
	L"NtGdiCreateHalftonePalette",
	L"NtGdiCreateHatchBrushInternal",
	L"NtGdiCreateMetafileDC",
	L"NtGdiCreatePaletteInternal",
	L"NtGdiCreatePatternBrushInternal",
	L"NtGdiCreatePen",
	L"NtGdiCreateRectRgn",
	L"NtGdiCreateRoundRectRgn",
	L"NtGdiCreateServerMetaFile",
	L"NtGdiCreateSolidBrush",
	L"NtGdiD3dContextCreate",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroyAll",
	L"NtGdiD3dValidateTextureStageState",
//	L"NtGdiD3dDrawPrimitivesNtGdiDdGetDriverState",
	L"NtGdiD3dDrawPrimitives2",
	L"NtGdiDdGetDriverState",
	L"NtGdiDdAddAttachedSurface",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAttachSurface",
	L"NtGdiDdBeginMoCompFrame",
	L"NtGdiDdBlt",
	L"NtGdiDdCanCreateSurface",
	L"NtGdiDdCanCreateD3DBuffer",
	L"NtGdiDdColorControl",
	L"NtGdiDdCreateDirectDrawObject",
	L"NtGdiDdCreateSurface",
	L"NtGdiDdCreateD3DBuffer",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdDeleteDirectDrawObject",
	L"NtGdiDdDeleteSurfaceObject",
	L"NtGdiDdDestroyMoComp",
	L"NtGdiDdDestroySurface",
	L"NtGdiDdDestroyD3DBuffer",
	L"NtGdiDdEndMoCompFrame",
	L"NtGdiDdFlip",
	L"NtGdiDdFlipToGDISurface",
	L"NtGdiDdGetAvailDriverMemory",
	L"NtGdiDdGetBltStatus",
	L"NtGdiDdGetDC",
	L"NtGdiDdGetDriverInfo",
	L"NtGdiDdGetDxHandle",
	L"NtGdiDdGetFlipStatus",
	L"NtGdiDdGetInternalMoCompInfo",
	L"NtGdiDdGetMoCompBuffInfo",
	L"NtGdiDdGetMoCompGuids",
	L"NtGdiDdGetMoCompFormats",
	L"NtGdiDdGetScanLine",
	L"NtGdiDdLock",
	L"NtGdiDdLockD3D",
	L"NtGdiDdQueryDirectDrawObject",
	L"NtGdiDdQueryMoCompStatus",
	L"NtGdiDdReenableDirectDrawObject",
	L"NtGdiDdReleaseDC",
	L"NtGdiDdRenderMoComp",
	L"NtGdiDdResetVisrgn",
	L"NtGdiDdSetColorKey",
	L"NtGdiDdSetExclusiveMode",
	L"NtGdiDdSetGammaRamp",
	L"NtGdiDdCreateSurfaceEx",
	L"NtGdiDdSetOverlayPosition",
	L"NtGdiDdUnattachSurface",
	L"NtGdiDdUnlock",
	L"NtGdiDdUnlockD3D",
	L"NtGdiDdUpdateOverlay",
	L"NtGdiDdWaitForVerticalBlank",
	L"NtGdiDvpCanCreateVideoPort",
	L"NtGdiDvpColorControl",
	L"NtGdiDvpCreateVideoPort",
	L"NtGdiDvpDestroyVideoPort",
	L"NtGdiDvpFlipVideoPort",
	L"NtGdiDvpGetVideoPortBandwidth",
	L"NtGdiDvpGetVideoPortField",
	L"NtGdiDvpGetVideoPortFlipStatus",
	L"NtGdiDvpGetVideoPortInputFormats",
	L"NtGdiDvpGetVideoPortLine",
	L"NtGdiDvpGetVideoPortOutputFormats",
	L"NtGdiDvpGetVideoPortConnectInfo",
	L"NtGdiDvpGetVideoSignalStatus",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDvpWaitForVideoPortSync",
	L"NtGdiDvpAcquireNotification",
	L"NtGdiDvpReleaseNotification",
	L"NtGdiDxgGenericThunk",
	L"NtGdiDeleteClientObj",
	L"NtGdiDeleteColorSpace",
	L"NtGdiDeleteColorTransform",
	L"NtGdiDeleteObjectApp",
	L"NtGdiDescribePixelFormat",
	L"NtGdiGetPerBandInfo",
	L"NtGdiDoBanding",
	L"NtGdiDoPalette",
	L"NtGdiDrawEscape",
	L"NtGdiEllipse",
	L"NtGdiEnableEudc",
	L"NtGdiEndDoc",
	L"NtGdiEndPage",
	L"NtGdiEndPath",
	L"NtGdiEnumFontChunk",
	L"NtGdiEnumFontClose",
	L"NtGdiEnumFontOpen",
	L"NtGdiEnumObjects",
	L"NtGdiEqualRgn",
	L"NtGdiEudcLoadUnloadLink",
	L"NtGdiExcludeClipRect",
	L"NtGdiExtCreatePen",
	L"NtGdiExtCreateRegion",
	L"NtGdiExtEscape",
	L"NtGdiExtFloodFill",
	L"NtGdiExtGetObjectW",
	L"NtGdiExtSelectClipRgn",
	L"NtGdiExtTextOutW",
	L"NtGdiFillPath",
	L"NtGdiFillRgn",
	L"NtGdiFlattenPath",
	L"NtGdiFlush",
	L"NtGdiForceUFIMapping",
	L"NtGdiFrameRgn",
	L"NtGdiFullscreenControl",
	L"NtGdiGetAndSetDCDword",
	L"NtGdiGetAppClipBox",
	L"NtGdiGetBitmapBits",
	L"NtGdiGetBitmapDimension",
	L"NtGdiGetBoundsRect",
	L"NtGdiGetCharABCWidthsW",
	L"NtGdiGetCharacterPlacementW",
	L"NtGdiGetCharSet",
	L"NtGdiGetCharWidthW",
	L"NtGdiGetCharWidthInfo",
	L"NtGdiGetColorAdjustment",
	L"NtGdiGetColorSpaceforBitmap",
	L"NtGdiGetDCDword",
	L"NtGdiGetDCforBitmap",
	L"NtGdiGetDCObject",
	L"NtGdiGetDCPoint",
	L"NtGdiGetDeviceCaps",
	L"NtGdiGetDeviceGammaRamp",
	L"NtGdiGetDeviceCapsAll",
	L"NtGdiGetDIBitsInternal",
	L"NtGdiGetETM",
	L"NtGdiGetEudcTimeStampEx",
	L"NtGdiGetFontData",
	L"NtGdiGetFontResourceInfoInternalW",
	L"NtGdiGetGlyphIndicesW",
	L"NtGdiGetGlyphIndicesWInternal",
	L"NtGdiGetGlyphOutline",
	L"NtGdiGetKerningPairs",
	L"NtGdiGetLinkedUFIs",
	L"NtGdiGetMiterLimit",
	L"NtGdiGetMonitorID",
	L"NtGdiGetNearestColor",
	L"NtGdiGetNearestPaletteIndex",
	L"NtGdiGetObjectBitmapHandle",
	L"NtGdiGetOutlineTextMetricsInternalW",
	L"NtGdiGetPath",
	L"NtGdiGetPixel",
	L"NtGdiGetRandomRgn",
	L"NtGdiGetRasterizerCaps",
	L"NtGdiGetRealizationInfo",
	L"NtGdiGetRegionData",
	L"NtGdiGetRgnBox",
	L"NtGdiGetServerMetaFileBits",
	L"NtGdiGetSpoolMessage",
	L"NtGdiGetStats",
	L"NtGdiGetStockObject",
	L"NtGdiGetStringBitmapW",
	L"NtGdiGetSystemPaletteUse",
	L"NtGdiGetTextCharsetInfo",
	L"NtGdiGetTextExtent",
	L"NtGdiGetTextExtentExW",
	L"NtGdiGetTextFaceW",
	L"NtGdiGetTextMetricsW",
	L"NtGdiGetTransform",
	L"NtGdiGetUFI",
	L"NtGdiGetEmbUFI",
	L"NtGdiGetUFIPathname",
	L"NtGdiGetEmbedFonts",
	L"NtGdiChangeGhostFont",
	L"NtGdiAddEmbFontToDC",
	L"NtGdiGetFontUnicodeRanges",
	L"NtGdiGetWidthTable",
	L"NtGdiGradientFill",
	L"NtGdiHfontCreate",
	L"NtGdiIcmBrushInfo",
	L"NtGdiInit",
	L"NtGdiInitSpool",
	L"NtGdiIntersectClipRect",
	L"NtGdiInvertRgn",
	L"NtGdiLineTo",
	L"NtGdiMakeFontDir",
	L"NtGdiMakeInfoDC",
	L"NtGdiMaskBlt",
	L"NtGdiModifyWorldTransform",
	L"NtGdiMonoBitmap",
	L"NtGdiMoveTo",
	L"NtGdiOffsetClipRgn",
	L"NtGdiOffsetRgn",
	L"NtGdiOpenDCW",
	L"NtGdiPatBlt",
	L"NtGdiPolyPatBlt",
	L"NtGdiPathToRegion",
	L"NtGdiPlgBlt",
	L"NtGdiPolyDraw",
	L"NtGdiPolyPolyDraw",
	L"NtGdiPolyTextOutW",
	L"NtGdiPtInRegion",
	L"NtGdiPtVisible",
	L"NtGdiQueryFonts",
	L"NtGdiQueryFontAssocInfo",
	L"NtGdiRectangle",
	L"NtGdiRectInRegion",
	L"NtGdiRectVisible",
	L"NtGdiRemoveFontResourceW",
	L"NtGdiRemoveFontMemResourceEx",
	L"NtGdiResetDC",
	L"NtGdiResizePalette",
	L"NtGdiRestoreDC",
	L"NtGdiRoundRect",
	L"NtGdiSaveDC",
	L"NtGdiScaleViewportExtEx",
	L"NtGdiScaleWindowExtEx",
	L"NtGdiSelectBitmap",
	L"NtGdiSelectBrush",
	L"NtGdiSelectClipPath",
	L"NtGdiSelectFont",
	L"NtGdiSelectPen",
	L"NtGdiSetBitmapAttributes",
	L"NtGdiSetBitmapBits",
	L"NtGdiSetBitmapDimension",
	L"NtGdiSetBoundsRect",
	L"NtGdiSetBrushAttributes",
	L"NtGdiSetBrushOrg",
	L"NtGdiSetColorAdjustment",
	L"NtGdiSetColorSpace",
	L"NtGdiSetDeviceGammaRamp",
	L"NtGdiSetDIBitsToDeviceInternal",
	L"NtGdiSetFontEnumeration",
	L"NtGdiSetFontXform",
	L"NtGdiSetIcmMode",
	L"NtGdiSetLinkedUFIs",
	L"NtGdiSetMagicColors",
	L"NtGdiSetMetaRgn",
	L"NtGdiSetMiterLimit",
	L"NtGdiGetDeviceWidth",
	L"NtGdiMirrorWindowOrg",
	L"NtGdiSetLayout",
	L"NtGdiSetPixel",
	L"NtGdiSetPixelFormat",
	L"NtGdiSetRectRgn",
	L"NtGdiSetSystemPaletteUse",
	L"NtGdiSetTextJustification",
	L"NtGdiSetupPublicCFONT",
	L"NtGdiSetVirtualResolution",
	L"NtGdiSetSizeDevice",
	L"NtGdiStartDoc",
	L"NtGdiStartPage",
	L"NtGdiStretchBlt",
	L"NtGdiStretchDIBitsInternal",
	L"NtGdiStrokeAndFillPath",
	L"NtGdiStrokePath",
	L"NtGdiSwapBuffers",
	L"NtGdiTransformPoints",
	L"NtGdiTransparentBlt",
	L"NtGdiUnloadPrinterDriver",
	L"NtGdiUnmapMemFont",
	L"NtGdiUnrealizeObject",
	L"NtGdiUpdateColors",
	L"NtGdiWidenPath",
	L"NtUserActivateKeyboardLayout",
	L"NtUserAlterWindowStyle",
	L"NtUserAssociateInputContext",
	L"NtUserAttachThreadInput",
	L"NtUserBeginPaint",
	L"NtUserBitBltSysBmp",
	L"NtUserBlockInput",
 	L"NtUserBuildHimcList",
	L"NtUserBuildHwndList",
	L"NtUserBuildNameList",
	L"NtUserBuildPropList",
	L"NtUserCallHwnd",
	L"NtUserCallHwndLock",
	L"NtUserCallHwndOpt",
	L"NtUserCallHwndParam",
	L"NtUserCallHwndParamLock",
	L"NtUserCallMsgFilter",
	L"NtUserCallNextHookEx",
	L"NtUserCallNoParam",
	L"NtUserCallOneParam",
	L"NtUserCallTwoParam",
	L"NtUserChangeClipboardChain",
	L"NtUserChangeDisplaySettings",
	L"NtUserCheckImeHotKey",
	L"NtUserCheckMenuItem",
	L"NtUserChildWindowFromPointEx",
	L"NtUserClipCursor",
	L"NtUserCloseClipboard",
	L"NtUserCloseDesktop",
	L"NtUserCloseWindowStation",
	L"NtUserConsoleControl",
	L"NtUserConvertMemHandle",
	L"NtUserCopyAcceleratorTable",
	L"NtUserCountClipboardFormats",
	L"NtUserCreateAcceleratorTable",
	L"NtUserCreateCaret",
	L"NtUserCreateDesktop",
	L"NtUserCreateInputContext",
	L"NtUserCreateLocalMemHandle",
	L"NtUserCreateWindowEx",
	L"NtUserCreateWindowStation",
	L"NtUserDdeGetQualityOfService",
	L"NtUserDdeInitialize",
	L"NtUserDdeSetQualityOfService",
	L"NtUserDeferWindowPos",
	L"NtUserDefSetText",
	L"NtUserDeleteMenu",
	L"NtUserDestroyAcceleratorTable",
	L"NtUserDestroyCursor",
	L"NtUserDestroyInputContext",
	L"NtUserDestroyMenu",
	L"NtUserDestroyWindow",
	L"NtUserDisableThreadIme",
	L"NtUserDispatchMessage",
	L"NtUserDragDetect",
	L"NtUserDragObject",
	L"NtUserDrawAnimatedRects",
	L"NtUserDrawCaption",
	L"NtUserDrawCaptionTemp",
	L"NtUserDrawIconEx",
	L"NtUserDrawMenuBarTemp",
	L"NtUserEmptyClipboard",
	L"NtUserEnableMenuItem",
	L"NtUserEnableScrollBar",
	L"NtUserEndDeferWindowPosEx",
	L"NtUserEndMenu",
	L"NtUserEndPaint",
	L"NtUserEnumDisplayDevices",
	L"NtUserEnumDisplayMonitors",
	L"NtUserEnumDisplaySettings",
	L"NtUserEvent",
	L"NtUserExcludeUpdateRgn",
	L"NtUserFillWindow",
	L"NtUserFindExistingCursorIcon",
	L"NtUserFindWindowEx",
	L"NtUserFlashWindowEx",
	L"NtUserGetAltTabInfo",
	L"NtUserGetAncestor",
	L"NtUserGetAppImeLevel",
	L"NtUserGetAsyncKeyState",
	L"NtUserGetAtomName",
	L"NtUserGetCaretBlinkTime",
	L"NtUserGetCaretPos",
	L"NtUserGetClassInfo",
	L"NtUserGetClassName",
	L"NtUserGetClipboardData",
	L"NtUserGetClipboardFormatName",
	L"NtUserGetClipboardOwner",
	L"NtUserGetClipboardSequenceNumber",
	L"NtUserGetClipboardViewer",
	L"NtUserGetClipCursor",
	L"NtUserGetComboBoxInfo",
	L"NtUserGetControlBrush",
	L"NtUserGetControlColor",
	L"NtUserGetCPD",
	L"NtUserGetCursorFrameInfo",
	L"NtUserGetCursorInfo",
	L"NtUserGetDC",
	L"NtUserGetDCEx",
	L"NtUserGetDoubleClickTime",
	L"NtUserGetForegroundWindow",
	L"NtUserGetGuiResources",
	L"NtUserGetGUIThreadInfo",
	L"NtUserGetIconInfo",
	L"NtUserGetIconSize",
	L"NtUserGetImeHotKey",
	L"NtUserGetImeInfoEx",
	L"NtUserGetInternalWindowPos",
	L"NtUserGetKeyboardLayoutList",
	L"NtUserGetKeyboardLayoutName",
	L"NtUserGetKeyboardState",
	L"NtUserGetKeyNameText",
	L"NtUserGetKeyState",
	L"NtUserGetListBoxInfo",
	L"NtUserGetMenuBarInfo",
	L"NtUserGetMenuIndex",
	L"NtUserGetMenuItemRect",
	L"NtUserGetMessage",
	L"NtUserGetMouseMovePointsEx",
	L"NtUserGetObjectInformation",
	L"NtUserGetOpenClipboardWindow",
	L"NtUserGetPriorityClipboardFormat",
	L"NtUserGetProcessWindowStation",
	L"NtUserGetRawInputBuffer",
	L"NtUserGetRawInputData",
	L"NtUserGetRawInputDeviceInfo",
	L"NtUserGetRawInputDeviceList",
	L"NtUserGetRegisteredRawInputDevices",
	L"NtUserGetScrollBarInfo",
	L"NtUserGetSystemMenu",
	L"NtUserGetThreadDesktop",
	L"NtUserGetThreadState",
	L"NtUserGetTitleBarInfo",
	L"NtUserGetUpdateRect",
	L"NtUserGetUpdateRgn",
	L"NtUserGetWindowDC",
	L"NtUserGetWindowPlacement",
	L"NtUserGetWOWClass",
	L"NtUserHardErrorControl",
	L"NtUserHideCaret",
	L"NtUserHiliteMenuItem",
	L"NtUserImpersonateDdeClientWindow",
	L"NtUserInitialize",
	L"NtUserInitializeClientPfnArrays",
	L"NtUserInitTask",
	L"NtUserInternalGetWindowText",
	L"NtUserInvalidateRect",
	L"NtUserInvalidateRgn",
	L"NtUserIsClipboardFormatAvailable",
	L"NtUserKillTimer",
	L"NtUserLoadKeyboardLayoutEx",
	L"NtUserLockWindowStation",
	L"NtUserLockWindowUpdate",
	L"NtUserLockWorkStation",
	L"NtUserMapVirtualKeyEx",
	L"NtUserMenuItemFromPoint",
	L"NtUserMessageCall",
	L"NtUserMinMaximize",
	L"NtUserMNDragLeave",
	L"NtUserMNDragOver",
	L"NtUserModifyUserStartupInfoFlags",
	L"NtUserMoveWindow",
	L"NtUserNotifyIMEStatus",
	L"NtUserNotifyProcessCreate",
	L"NtUserNotifyWinEvent",
	L"NtUserOpenClipboard",
	L"NtUserOpenDesktop",
	L"NtUserOpenInputDesktop",
	L"NtUserOpenWindowStation",
	L"NtUserPaintDesktop",
	L"NtUserPeekMessage",
	L"NtUserPostMessage",
	L"NtUserPostThreadMessage",
	L"NtUserPrintWindow",
	L"NtUserProcessConnect",
	L"NtUserQueryInformationThread",
	L"NtUserQueryInputContext",
	L"NtUserQuerySendMessage",
	L"NtUserQueryWindow",
	L"NtUserRealChildWindowFromPoint",
	L"NtUserRealInternalGetMessage",
	L"NtUserRealWaitMessageEx",
	L"NtUserRedrawWindow",
	L"NtUserRegisterClassExWOW",
	L"NtUserRegisterUserApiHook",
	L"NtUserRegisterHotKey",
	L"NtUserRegisterRawInputDevices",
	L"NtUserRegisterTasklist",
	L"NtUserRegisterWindowMessage",
	L"NtUserRemoveMenu",
	L"NtUserRemoveProp",
	L"NtUserResolveDesktop",
	L"NtUserResolveDesktopForWOW",
	L"NtUserSBGetParms",
	L"NtUserScrollDC",
	L"NtUserScrollWindowEx",
	L"NtUserSelectPalette",
	L"NtUserSendInput",
	L"NtUserSetActiveWindow",
	L"NtUserSetAppImeLevel",
	L"NtUserSetCapture",
	L"NtUserSetClassLong",
	L"NtUserSetClassWord",
	L"NtUserSetClipboardData",
	L"NtUserSetClipboardViewer",
	L"NtUserSetConsoleReserveKeys",
	L"NtUserSetCursor",
	L"NtUserSetCursorContents",
	L"NtUserSetCursorIconData",
	L"NtUserSetFocus",
	L"NtUserSetImeHotKey",
	L"NtUserSetImeInfoEx",
	L"NtUserSetImeOwnerWindow",
	L"NtUserSetInformationProcess",
	L"NtUserSetInformationThread",
	L"NtUserSetInternalWindowPos",
	L"NtUserSetKeyboardState",
	L"NtUserSetLogonNotifyWindow",
	L"NtUserSetMenu",
	L"NtUserSetMenuContextHelpId",
	L"NtUserSetMenuDefaultItem",
	L"NtUserSetMenuFlagRtoL",
	L"NtUserSetObjectInformation",
	L"NtUserSetParent",
	L"NtUserSetProcessWindowStation",
	L"NtUserSetProp",
	L"NtUserSetScrollInfo",
	L"NtUserSetShellWindowEx",
	L"NtUserSetSysColors",
	L"NtUserSetSystemCursor",
	L"NtUserSetSystemMenu",
	L"NtUserSetSystemTimer",
	L"NtUserSetThreadDesktop",
	L"NtUserSetThreadLayoutHandles",
	L"NtUserSetThreadState",
	L"NtUserSetTimer",
	L"NtUserSetWindowFNID",
	L"NtUserSetWindowLong",
	L"NtUserSetWindowPlacement",
	L"NtUserSetWindowPos",
	L"NtUserSetWindowRgn",
	L"NtUserSetWindowsHookAW",
	L"NtUserSetWindowsHookEx",
	L"NtUserSetWindowStationUser",
	L"NtUserSetWindowWord",
	L"NtUserSetWinEventHook",
	L"NtUserShowCaret",
	L"NtUserShowScrollBar",
	L"NtUserShowWindow",
	L"NtUserShowWindowAsync",
	L"NtUserSoundSentry",
	L"NtUserSwitchDesktop",
	L"NtUserSystemParametersInfo",
	L"NtUserTestForInteractiveUser",
	L"NtUserThunkedMenuInfo",
	L"NtUserThunkedMenuItemInfo",
	L"NtUserToUnicodeEx",
	L"NtUserTrackMouseEvent",
	L"NtUserTrackPopupMenuEx",
	L"NtUserCalcMenuBar",
	L"NtUserPaintMenuBar",
	L"NtUserTranslateAccelerator",
	L"NtUserTranslateMessage",
	L"NtUserUnhookWindowsHookEx",
	L"NtUserUnhookWinEvent",
	L"NtUserUnloadKeyboardLayout",
	L"NtUserUnlockWindowStation",
	L"NtUserUnregisterClass",
	L"NtUserUnregisterUserApiHook",
	L"NtUserUnregisterHotKey",
	L"NtUserUpdateInputContext",
	L"NtUserUpdateInstance",
	L"NtUserUpdateLayeredWindow",
	L"NtUserGetLayeredWindowAttributes",
	L"NtUserSetLayeredWindowAttributes",
	L"NtUserUpdatePerUserSystemParameters",
	L"NtUserUserHandleGrantAccess",
	L"NtUserValidateHandleSecure",
	L"NtUserValidateRect",
	L"NtUserValidateTimerCallback",
	L"NtUserVkKeyScanEx",
	L"NtUserWaitForInputIdle",
	L"NtUserWaitForMsgAndEvent",
	L"NtUserWaitMessage",
	L"NtUserWin32PoolAllocationStats",
	L"NtUserWindowFromPoint",
	L"NtUserYieldTask",
	L"NtUserRemoteConnect",
	L"NtUserRemoteRedrawRectangle",
	L"NtUserRemoteRedrawScreen",
	L"NtUserRemoteStopScreenUpdates",
	L"NtUserCtxDisplayIOCtl",
	L"NtGdiEngAssociateSurface",
	L"NtGdiEngCreateBitmap",
	L"NtGdiEngCreateDeviceSurface",
	L"NtGdiEngCreateDeviceBitmap",
	L"NtGdiEngCreatePalette",
	L"NtGdiEngComputeGlyphSet",
	L"NtGdiEngCopyBits",
	L"NtGdiEngDeletePalette",
	L"NtGdiEngDeleteSurface",
	L"NtGdiEngEraseSurface",
	L"NtGdiEngUnlockSurface",
	L"NtGdiEngLockSurface",
	L"NtGdiEngBitBlt",
	L"NtGdiEngStretchBlt",
	L"NtGdiEngPlgBlt",
	L"NtGdiEngMarkBandingSurface",
	L"NtGdiEngStrokePath",
	L"NtGdiEngFillPath",
	L"NtGdiEngStrokeAndFillPath",
	L"NtGdiEngPaint",
	L"NtGdiEngLineTo",
	L"NtGdiEngAlphaBlend",
	L"NtGdiEngGradientFill",
	L"NtGdiEngTransparentBlt",
	L"NtGdiEngTextOut",
	L"NtGdiEngStretchBltROP",
	L"NtGdiXLATEOBJ_cGetPalette",
	L"NtGdiXLATEOBJ_iXlate",
	L"NtGdiXLATEOBJ_hGetColorTransform",
	L"NtGdiCLIPOBJ_bEnum",
	L"NtGdiCLIPOBJ_cEnumStart",
	L"NtGdiCLIPOBJ_ppoGetPath",
	L"NtGdiEngDeletePath",
	L"NtGdiEngCreateClip",
	L"NtGdiEngDeleteClip",
	L"NtGdiBRUSHOBJ_ulGetBrushColor",
	L"NtGdiBRUSHOBJ_pvAllocRbrush",
	L"NtGdiBRUSHOBJ_pvGetRbrush",
	L"NtGdiBRUSHOBJ_hGetColorTransform",
	L"NtGdiXFORMOBJ_bApplyXform",
	L"NtGdiXFORMOBJ_iGetXform",
	L"NtGdiFONTOBJ_vGetInfo",
	L"NtGdiFONTOBJ_pxoGetXform",
	L"NtGdiFONTOBJ_cGetGlyphs",
	L"NtGdiFONTOBJ_pifi",
	L"NtGdiFONTOBJ_pfdg",
	L"NtGdiFONTOBJ_pQueryGlyphAttrs",
	L"NtGdiFONTOBJ_pvTrueTypeFontFile",
	L"NtGdiFONTOBJ_cGetAllGlyphHandles",
	L"NtGdiSTROBJ_bEnum",
	L"NtGdiSTROBJ_bEnumPositionsOnly",
	L"NtGdiSTROBJ_bGetAdvanceWidths",
	L"NtGdiSTROBJ_vEnumStart",
	L"NtGdiSTROBJ_dwGetCodePage",
	L"NtGdiPATHOBJ_vGetBounds",
	L"NtGdiPATHOBJ_bEnum",
	L"NtGdiPATHOBJ_vEnumStart",
	L"NtGdiPATHOBJ_vEnumStartClipLines",
	L"NtGdiPATHOBJ_bEnumClipLines",
	L"NtGdiGetDhpdev",
	L"NtGdiEngCheckAbort",
	L"NtGdiHT_Get8BPPFormatPalette",
	L"NtGdiHT_Get8BPPMaskPalette",
	L"NtGdiUpdateTransform",
	L"NtGdiSetPUMPDOBJ",
	L"NtGdiBRUSHOBJ_DeleteRbrush",
	L"NtGdiUnmapMemFont",
	L"NtGdiDrawStream",
	L"NtGdiMakeObjectUnXferable",
	L"DxEngGetRedirectionBitmap",
};

WCHAR *VistaShadow[] = {
	L"NtGdiAbortDoc",
	L"NtGdiAbortPath",
	L"NtGdiAddFontResourceW",
	L"NtGdiAddRemoteFontToDC",
	L"NtGdiAddFontMemResourceEx",
	L"NtGdiRemoveMergeFont",
	L"NtGdiAddRemoteMMInstanceToDC",
	L"NtGdiAlphaBlend",
	L"NtGdiAngleArc",
	L"NtGdiAnyLinkedFonts",
	L"NtGdiFontIsLinked",
	L"NtGdiArcInternal",
	L"NtGdiBeginPath",
	L"NtGdiBitBlt",
	L"NtGdiCancelDC",
	L"NtGdiCheckBitmapBits",
	L"NtGdiCloseFigure",
	L"NtGdiClearBitmapAttributes",
	L"NtGdiClearBrushAttributes",
	L"NtGdiColorCorrectPalette",
	L"NtGdiCombineRgn",
	L"NtGdiCombineTransform",
	L"NtGdiComputeXformCoefficients",
	L"NtGdiConfigureOPMProtectedOutput",
	L"NtGdiConsoleTextOut",
	L"NtGdiConvertMetafileRect",
	L"NtGdiCreateBitmap",
	L"NtGdiCreateClientObj",
	L"NtGdiCreateColorSpace",
	L"NtGdiCreateColorTransform",
	L"NtGdiCreateCompatibleBitmap",
	L"NtGdiCreateCompatibleDC",
	L"NtGdiCreateDIBBrush",
	L"NtGdiCreateDIBitmapInternal",
	L"NtGdiCreateDIBSection",
	L"NtGdiCreateEllipticRgn",
	L"NtGdiCreateHalftonePalette",
	L"NtGdiCreateHatchBrushInternal",
	L"NtGdiCreateMetafileDC",
	L"NtGdiCreateOPMProtectedOutputs",
	L"NtGdiCreatePaletteInternal",
	L"NtGdiCreatePatternBrushInternal",
	L"NtGdiCreatePen",
	L"NtGdiCreateRectRgn",
	L"NtGdiCreateRoundRectRgn",
	L"NtGdiCreateServerMetaFile",
	L"NtGdiCreateSolidBrush",
	L"NtGdiD3dContextCreate",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroyAll",
	L"NtGdiD3dValidateTextureStageState",
	L"NtGdiD3dDrawPrimitives2",
	L"NtGdiDdGetDriverState",
	L"NtGdiDdAddAttachedSurface",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAttachSurface",
	L"NtGdiDdBeginMoCompFrame",
	L"NtGdiDdBlt",
	L"NtGdiDdCanCreateSurface",
	L"NtGdiDdCanCreateD3DBuffer",
	L"NtGdiDdColorControl",
	L"NtGdiDdCreateDirectDrawObject",
	L"NtGdiDdCreateSurface",
	L"NtGdiDdCreateD3DBuffer",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdDeleteDirectDrawObject",
	L"NtGdiDdDeleteSurfaceObject",
	L"NtGdiDdDestroyMoComp",
	L"NtGdiDdDestroySurface",
	L"NtGdiDdDestroyD3DBuffer",
	L"NtGdiDdEndMoCompFrame",
	L"NtGdiDdFlip",
	L"NtGdiDdFlipToGDISurface",
	L"NtGdiDdGetAvailDriverMemory",
	L"NtGdiDdGetBltStatus",
	L"NtGdiDdGetDC",
	L"NtGdiDdGetDriverInfo",
	L"NtGdiDdGetDxHandle",
	L"NtGdiDdGetFlipStatus",
	L"NtGdiDdGetInternalMoCompInfo",
	L"NtGdiDdGetMoCompBuffInfo",
	L"NtGdiDdGetMoCompGuids",
	L"NtGdiDdGetMoCompFormats",
	L"NtGdiDdGetScanLine",
	L"NtGdiDdLock",
	L"NtGdiDdLockD3D",
	L"NtGdiDdQueryDirectDrawObject",
	L"NtGdiDdQueryMoCompStatus",
	L"NtGdiDdReenableDirectDrawObject",
	L"NtGdiDdReleaseDC",
	L"NtGdiDdRenderMoComp",
	L"NtGdiDdResetVisrgn",
	L"NtGdiDdSetColorKey",
	L"NtGdiDdSetExclusiveMode",
	L"NtGdiDdSetGammaRamp",
	L"NtGdiDdCreateSurfaceEx",
	L"NtGdiDdSetOverlayPosition",
	L"NtGdiDdUnattachSurface",
	L"NtGdiDdUnlock",
	L"NtGdiDdUnlockD3D",
	L"NtGdiDdUpdateOverlay",
	L"NtGdiDdWaitForVerticalBlank",
	L"NtGdiDvpCanCreateVideoPort",
	L"NtGdiDvpColorControl",
	L"NtGdiDvpCreateVideoPort",
	L"NtGdiDvpDestroyVideoPort",
	L"NtGdiDvpFlipVideoPort",
	L"NtGdiDvpGetVideoPortBandwidth",
	L"NtGdiDvpGetVideoPortField",
	L"NtGdiDvpGetVideoPortFlipStatus",
	L"NtGdiDvpGetVideoPortInputFormats",
	L"NtGdiDvpGetVideoPortLine",
	L"NtGdiDvpGetVideoPortOutputFormats",
	L"NtGdiDvpGetVideoPortConnectInfo",
	L"NtGdiDvpGetVideoSignalStatus",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDvpWaitForVideoPortSync",
	L"NtGdiDvpAcquireNotification",
	L"NtGdiDvpReleaseNotification",
	L"NtGdiDxgGenericThunk",
	L"NtGdiDeleteClientObj",
	L"NtGdiDeleteColorSpace",
	L"NtGdiDeleteColorTransform",
	L"NtGdiDeleteObjectApp",
	L"NtGdiDescribePixelFormat",
	L"NtGdiDestroyOPMProtectedOutput",
	L"NtGdiGetPerBandInfo",
	L"NtGdiDoBanding",
	L"NtGdiDoPalette",
	L"NtGdiDrawEscape",
	L"NtGdiEllipse",
	L"NtGdiEnableEudc",
	L"NtGdiEndDoc",
	L"NtGdiEndPage",
	L"NtGdiEndPath",
	L"NtGdiEnumFontChunk",
	L"NtGdiEnumFontClose",
	L"NtGdiEnumFontOpen",
	L"NtGdiEnumObjects",
	L"NtGdiEqualRgn",
	L"NtGdiEudcLoadUnloadLink",
	L"NtGdiExcludeClipRect",
	L"NtGdiExtCreatePen",
	L"NtGdiExtCreateRegion",
	L"NtGdiExtEscape",
	L"NtGdiExtFloodFill",
	L"NtGdiExtGetObjectW",
	L"NtGdiExtSelectClipRgn",
	L"NtGdiExtTextOutW",
	L"NtGdiFillPath",
	L"NtGdiFillRgn",
	L"NtGdiFlattenPath",
	L"NtGdiFlush",
	L"NtGdiForceUFIMapping",
	L"NtGdiFrameRgn",
	L"NtGdiFullscreenControl",
	L"NtGdiGetAndSetDCDword",
	L"NtGdiGetAppClipBox",
	L"NtGdiGetBitmapBits",
	L"NtGdiGetBitmapDimension",
	L"NtGdiGetBoundsRect",
	L"NtGdiGetCertificate",
	L"NtGdiGetCertificateSize",
	L"NtGdiGetCharABCWidthsW",
	L"NtGdiGetCharacterPlacementW",
	L"NtGdiGetCharSet",
	L"NtGdiGetCharWidthW",
	L"NtGdiGetCharWidthInfo",
	L"NtGdiGetColorAdjustment",
	L"NtGdiGetColorSpaceforBitmap",
	L"NtGdiGetCOPPCompatibleOPMInformation",
	L"NtGdiGetDCDword",
	L"NtGdiGetDCforBitmap",
	L"NtGdiGetDCObject",
	L"NtGdiGetDCPoint",
	L"NtGdiGetDeviceCaps",
	L"NtGdiGetDeviceGammaRamp",
	L"NtGdiGetDeviceCapsAll",
	L"NtGdiGetDIBitsInternal",
	L"NtGdiGetETM",
	L"NtGdiGetEudcTimeStampEx",
	L"NtGdiGetFontData",
	L"NtGdiGetFontResourceInfoInternalW",
	L"NtGdiGetGlyphIndicesW",
	L"NtGdiGetGlyphIndicesWInternal",
	L"NtGdiGetGlyphOutline",
	L"NtGdiGetOPMInformation",
	L"NtGdiGetKerningPairs",
	L"NtGdiGetLinkedUFIs",
	L"NtGdiGetMiterLimit",
	L"NtGdiGetMonitorID",
	L"NtGdiGetNearestColor",
	L"NtGdiGetNearestPaletteIndex",
	L"NtGdiGetObjectBitmapHandle",
	L"NtGdiGetOPMRandomNumber",
	L"NtGdiGetOutlineTextMetricsInternalW",
	L"NtGdiGetPath",
	L"NtGdiGetPixel",
	L"NtGdiGetRandomRgn",
	L"NtGdiGetRasterizerCaps",
	L"NtGdiGetRealizationInfo",
	L"NtGdiGetRegionData",
	L"NtGdiGetRgnBox",
	L"NtGdiGetServerMetaFileBits",
	L"NtGdiGetSpoolMessage",
	L"NtGdiGetStats",
	L"NtGdiGetStockObject",
	L"NtGdiGetStringBitmapW",
	L"NtGdiGetSuggestedOPMProtectedOutputArraySize",
	L"NtGdiGetSystemPaletteUse",
	L"NtGdiGetTextCharsetInfo",
	L"NtGdiGetTextExtent",
	L"NtGdiGetTextExtentExW",
	L"NtGdiGetTextFaceW",
	L"NtGdiGetTextMetricsW",
	L"NtGdiGetTransform",
	L"NtGdiGetUFI",
	L"NtGdiGetEmbUFI",
	L"NtGdiGetUFIPathname",
	L"NtGdiGetEmbedFonts",
	L"NtGdiChangeGhostFont",
	L"NtGdiAddEmbFontToDC",
	L"NtGdiGetFontUnicodeRanges",
	L"NtGdiGetWidthTable",
	L"NtGdiGradientFill",
	L"NtGdiHfontCreate",
	L"NtGdiIcmBrushInfo",
	L"bUnMap",
	L"NtGdiInitSpool",
	L"NtGdiIntersectClipRect",
	L"NtGdiInvertRgn",
	L"NtGdiLineTo",
	L"NtGdiMakeFontDir",
	L"NtGdiMakeInfoDC",
	L"NtGdiMaskBlt",
	L"NtGdiModifyWorldTransform",
	L"NtGdiMonoBitmap",
	L"NtGdiMoveTo",
	L"NtGdiOffsetClipRgn",
	L"NtGdiOffsetRgn",
	L"NtGdiOpenDCW",
	L"NtGdiPatBlt",
	L"NtGdiPolyPatBlt",
	L"NtGdiPathToRegion",
	L"NtGdiPlgBlt",
	L"NtGdiPolyDraw",
	L"NtGdiPolyPolyDraw",
	L"NtGdiPolyTextOutW",
	L"NtGdiPtInRegion",
	L"NtGdiPtVisible",
	L"NtGdiQueryFonts",
	L"NtGdiQueryFontAssocInfo",
	L"NtGdiRectangle",
	L"NtGdiRectInRegion",
	L"NtGdiRectVisible",
	L"NtGdiRemoveFontResourceW",
	L"NtGdiRemoveFontMemResourceEx",
	L"NtGdiResetDC",
	L"NtGdiResizePalette",
	L"NtGdiRestoreDC",
	L"NtGdiRoundRect",
	L"NtGdiSaveDC",
	L"NtGdiScaleViewportExtEx",
	L"NtGdiScaleWindowExtEx",
	L"GreSelectBitmap",
	L"NtGdiSelectBrush",
	L"NtGdiSelectClipPath",
	L"NtGdiSelectFont",
	L"NtGdiSelectPen",
	L"NtGdiSetBitmapAttributes",
	L"NtGdiSetBitmapBits",
	L"NtGdiSetBitmapDimension",
	L"NtGdiSetBoundsRect",
	L"NtGdiSetBrushAttributes",
	L"NtGdiSetBrushOrg",
	L"NtGdiSetColorAdjustment",
	L"NtGdiSetColorSpace",
	L"NtGdiSetDeviceGammaRamp",
	L"NtGdiSetDIBitsToDeviceInternal",
	L"NtGdiSetFontEnumeration",
	L"NtGdiSetFontXform",
	L"NtGdiSetIcmMode",
	L"NtGdiSetLinkedUFIs",
	L"NtGdiSetMagicColors",
	L"NtGdiSetMetaRgn",
	L"NtGdiSetMiterLimit",
	L"NtGdiGetDeviceWidth",
	L"NtGdiMirrorWindowOrg",
	L"NtGdiSetLayout",
	L"NtGdiSetOPMSigningKeyAndSequenceNumbers",
	L"NtGdiSetPixel",
	L"NtGdiSetPixelFormat",
	L"NtGdiSetRectRgn",
	L"NtGdiSetSystemPaletteUse",
	L"NtGdiSetTextJustification",
	L"NtGdiSetupPublicCFONT",
	L"NtGdiSetVirtualResolution",
	L"NtGdiSetSizeDevice",
	L"NtGdiStartDoc",
	L"NtGdiStartPage",
	L"NtGdiStretchBlt",
	L"NtGdiStretchDIBitsInternal",
	L"NtGdiStrokeAndFillPath",
	L"NtGdiStrokePath",
	L"NtGdiSwapBuffers",
	L"NtGdiTransformPoints",
	L"NtGdiTransparentBlt",
	L"DxgStubEnableDirectDrawRedirection",
	L"NtGdiUnmapMemFont",
	L"NtGdiUnrealizeObject",
	L"NtGdiUpdateColors",
	L"NtGdiWidenPath",
	L"NtUserActivateKeyboardLayout",
	L"NtUserAddClipboardFormatListener",
	L"NtUserAlterWindowStyle",
	L"NtUserAssociateInputContext",
	L"NtUserAttachThreadInput",
	L"NtUserBeginPaint",
	L"NtUserBitBltSysBmp",
	L"NtUserBlockInput",
	L"NtUserBuildHimcList",
	L"NtUserBuildHwndList",
	L"NtUserBuildNameList",
	L"NtUserBuildPropList",
	L"NtUserCallHwnd",
	L"NtUserCallHwndLock",
	L"NtUserCallHwndOpt",
	L"NtUserCallHwndParam",
	L"NtUserCallHwndParamLock",
	L"NtUserCallMsgFilter",
	L"NtUserCallNextHookEx",
	L"NtUserCallNoParam",
	L"NtUserCallOneParam",
	L"NtUserCallTwoParam",
	L"NtUserChangeClipboardChain",
	L"NtUserChangeDisplaySettings",
	L"NtUserCheckAccessForIntegrityLevel",
	L"NtUserCheckDesktopByThreadId",
	L"NtUserCheckWindowThreadDesktop",
	L"NtUserCheckImeHotKey",
	L"NtUserCheckMenuItem",
	L"NtUserChildWindowFromPointEx",
	L"NtUserClipCursor",
	L"NtUserCloseClipboard",
	L"NtUserCloseDesktop",
	L"NtUserCloseWindowStation",
	L"NtUserConsoleControl",
	L"NtUserConvertMemHandle",
	L"NtUserCopyAcceleratorTable",
	L"NtUserCountClipboardFormats",
	L"NtUserCreateAcceleratorTable",
	L"NtUserCreateCaret",
	L"NtUserCreateDesktopEx",
	L"NtUserCreateInputContext",
	L"NtUserCreateLocalMemHandle",
	L"NtUserCreateWindowEx",
	L"NtUserCreateWindowStation",
	L"NtUserDdeInitialize",
	L"NtUserDeferWindowPos",
	L"NtUserDefSetText",
	L"NtUserDeleteMenu",
	L"NtUserDestroyAcceleratorTable",
	L"NtUserDestroyCursor",
	L"NtUserDestroyInputContext",
	L"NtUserDestroyMenu",
	L"NtUserDestroyWindow",
	L"NtUserDisableThreadIme",
	L"NtUserDispatchMessage",
	L"NtUserDoSoundConnect",
	L"NtUserDoSoundDisconnect",
	L"NtUserDragDetect",
	L"NtUserDragObject",
	L"NtUserDrawAnimatedRects",
	L"NtUserDrawCaption",
	L"NtUserDrawCaptionTemp",
	L"NtUserDrawIconEx",
	L"NtUserDrawMenuBarTemp",
	L"NtUserEmptyClipboard",
	L"NtUserEnableMenuItem",
	L"NtUserEnableScrollBar",
	L"NtUserEndDeferWindowPosEx",
	L"NtUserEndMenu",
	L"NtUserEndPaint",
	L"NtUserEnumDisplayDevices",
	L"NtUserEnumDisplayMonitors",
	L"NtUserEnumDisplaySettings",
	L"NtUserEvent",
	L"NtUserExcludeUpdateRgn",
	L"NtUserFillWindow",
	L"NtUserFindExistingCursorIcon",
	L"NtUserFindWindowEx",
	L"NtUserFlashWindowEx",
	L"NtUserFrostCrashedWindow",
	L"NtUserGetAltTabInfo",
	L"NtUserGetAncestor",
	L"NtUserGetAppImeLevel",
	L"NtUserGetAsyncKeyState",
	L"NtUserGetAtomName",
	L"NtUserGetCaretBlinkTime",
	L"NtUserGetCaretPos",
	L"NtUserGetClassInfoEx",
	L"NtUserGetClassName",
	L"NtUserGetClipboardData",
	L"NtUserGetClipboardFormatName",
	L"NtUserGetClipboardOwner",
	L"NtUserGetClipboardSequenceNumber",
	L"NtUserGetClipboardViewer",
	L"NtUserGetClipCursor",
	L"NtUserGetComboBoxInfo",
	L"NtUserGetControlBrush",
	L"NtUserGetControlColor",
	L"NtUserGetCPD",
	L"NtUserGetCursorFrameInfo",
	L"NtUserGetCursorInfo",
	L"NtUserGetDC",
	L"NtUserGetDCEx",
	L"NtUserGetDoubleClickTime",
	L"NtUserGetForegroundWindow",
	L"NtUserGetGuiResources",
	L"NtUserGetGUIThreadInfo",
	L"NtUserGetIconInfo",
	L"NtUserGetIconSize",
	L"NtUserGetImeHotKey",
	L"NtUserGetImeInfoEx",
	L"NtUserGetInternalWindowPos",
	L"NtUserGetKeyboardLayoutList",
	L"NtUserGetKeyboardLayoutName",
	L"NtUserGetKeyboardState",
	L"NtUserGetKeyNameText",
	L"NtUserGetKeyState",
	L"NtUserGetListBoxInfo",
	L"NtUserGetMenuBarInfo",
	L"NtUserGetMenuIndex",
	L"NtUserGetMenuItemRect",
	L"NtUserGetMessage",
	L"NtUserGetMouseMovePointsEx",
	L"NtUserGetObjectInformation",
	L"NtUserGetOpenClipboardWindow",
	L"NtUserGetPriorityClipboardFormat",
	L"NtUserGetProcessWindowStation",
	L"NtUserGetRawInputBuffer",
	L"NtUserGetRawInputData",
	L"NtUserGetRawInputDeviceInfo",
	L"NtUserGetRawInputDeviceList",
	L"NtUserGetRegisteredRawInputDevices",
	L"NtUserGetScrollBarInfo",
	L"NtUserGetSystemMenu",
	L"NtUserGetThreadDesktop",
	L"NtUserGetThreadState",
	L"NtUserGetTitleBarInfo",
	L"NtUserGetUpdatedClipboardFormats",
	L"NtUserGetUpdateRect",
	L"NtUserGetUpdateRgn",
	L"NtUserGetWindowDC",
	L"NtUserGetWindowPlacement",
	L"NtUserGetWOWClass",
	L"NtUserGhostWindowFromHungWindow",
	L"NtUserHardErrorControl",
	L"NtUserHideCaret",
	L"NtUserHiliteMenuItem",
	L"NtUserHungWindowFromGhostWindow",
	L"NtUserImpersonateDdeClientWindow",
	L"NtUserInitialize",
	L"NtUserInitializeClientPfnArrays",
	L"NtUserInitTask",
	L"NtUserInternalGetWindowText",
	L"NtUserInternalGetWindowIcon",
	L"NtUserInvalidateRect",
	L"NtUserInvalidateRgn",
	L"NtUserIsClipboardFormatAvailable",
	L"NtUserKillTimer",
	L"NtUserLoadKeyboardLayoutEx",
	L"NtUserLockWindowStation",
	L"NtUserLockWindowUpdate",
	L"NtUserLockWorkStation",
	L"NtUserLogicalToPhysicalPoint",
	L"NtUserMapVirtualKeyEx",
	L"NtUserMenuItemFromPoint",
	L"NtUserMessageCall",
	L"NtUserMinMaximize",
	L"NtUserMNDragLeave",
	L"NtUserMNDragOver",
	L"NtUserModifyUserStartupInfoFlags",
	L"NtUserMoveWindow",
	L"NtUserNotifyIMEStatus",
	L"NtUserNotifyProcessCreate",
	L"NtUserNotifyWinEvent",
	L"NtUserOpenClipboard",
	L"NtUserOpenDesktop",
	L"NtUserOpenInputDesktop",
	L"NtUserOpenThreadDesktop",
	L"NtUserOpenWindowStation",
	L"NtUserPaintDesktop",
	L"NtUserPaintMonitor",
	L"NtUserPeekMessage",
	L"NtUserPhysicalToLogicalPoint",
	L"NtUserPostMessageinline",
	L"NtUserPostThreadMessage",
	L"NtUserPrintWindow",
	L"NtUserProcessConnect",
	L"NtUserQueryInformationThread",
	L"NtUserQueryInputContext",
	L"NtUserQuerySendMessage",
	L"NtUserQueryWindow",
	L"NtUserRealChildWindowFromPoint",
	L"NtUserRealInternalGetMessage",
	L"NtUserRealWaitMessageEx",
	L"NtUserRedrawWindow",
	L"NtUserRegisterClassExWOW",
	L"NtUserRegisterErrorReportingDialog",
	L"NtUserRegisterUserApiHook",
	L"NtUserRegisterHotKey",
	L"NtUserRegisterRawInputDevices",
	L"NtUserRegisterTasklist",
	L"NtUserRegisterWindowMessage",
	L"NtUserRemoveClipboardFormatListener",
	L"NtUserRemoveMenu",
	L"NtUserRemoveProp",
	L"NtUserResolveDesktop",
	L"NtUserResolveDesktopForWOW",
	L"NtUserSBGetParms",
	L"NtUserScrollDC",
	L"NtUserScrollWindowEx",
	L"NtUserSelectPalette",
	L"NtUserSendInput",
	L"NtUserSetActiveWindow",
	L"NtUserSetAppImeLevel",
	L"NtUserSetCapture",
	L"NtUserSetClassLong",
	L"NtUserSetClassWord",
	L"NtUserSetClipboardData",
	L"NtUserSetClipboardViewer",
	L"NtUserSetConsoleReserveKeys",
	L"NtUserSetCursor",
	L"NtUserSetCursorContents",
	L"NtUserSetCursorIconData",
	L"NtUserSetFocus",
	L"NtUserSetImeHotKey",
	L"NtUserSetImeInfoEx",
	L"NtUserSetImeOwnerWindow",
	L"NtUserSetInformationProcess",
	L"NtUserSetInformationThread",
	L"NtUserSetInternalWindowPos",
	L"NtUserSetKeyboardState",
	L"NtUserSetMenu",
	L"NtUserSetMenuContextHelpId",
	L"NtUserSetMenuDefaultItem",
	L"NtUserSetMenuFlagRtoL",
	L"NtUserSetObjectInformation",
	L"NtUserSetParent",
	L"NtUserSetProcessWindowStation",
	L"NtUserGetProp",
	L"NtUserSetProp",
	L"NtUserSetScrollInfo",
	L"NtUserSetShellWindowEx",
	L"NtUserSetSysColors",
	L"NtUserSetSystemCursor",
	L"NtUserSetSystemMenu",
	L"NtUserSetSystemTimer",
	L"NtUserSetThreadDesktop",
	L"NtUserSetThreadLayoutHandles",
	L"NtUserSetThreadState",
	L"NtUserSetTimer",
	L"NtUserSetProcessDPIAware",
	L"NtUserSetWindowFNID",
	L"NtUserSetWindowLong",
	L"NtUserSetWindowPlacement",
	L"NtUserSetWindowPos",
	L"NtUserSetWindowRgn",
	L"NtUserGetWindowRgnEx",
	L"NtUserSetWindowRgnEx",
	L"NtUserSetWindowsHookAW",
	L"NtUserSetWindowsHookEx",
	L"NtUserSetWindowStationUser",
	L"NtUserSetWindowWord",
	L"NtUserSetWinEventHook",
	L"NtUserShowCaret",
	L"NtUserShowScrollBar",
	L"NtUserShowWindow",
	L"NtUserShowWindowAsync",
	L"NtUserSoundSentry",
	L"NtUserSwitchDesktop",
	L"NtUserSystemParametersInfo",
	L"NtUserTestForInteractiveUser",
	L"NtUserThunkedMenuInfo",
	L"NtUserThunkedMenuItemInfo",
	L"NtUserToUnicodeEx",
	L"NtUserTrackMouseEvent",
	L"NtUserTrackPopupMenuEx",
	L"NtUserCalcMenuBar",
	L"NtUserPaintMenuBar",
	L"NtUserTranslateAccelerator",
	L"NtUserTranslateMessage",
	L"NtUserUnhookWindowsHookEx",
	L"NtUserUnhookWinEvent",
	L"NtUserUnloadKeyboardLayout",
	L"NtUserUnlockWindowStation",
	L"NtUserUnregisterClass",
	L"NtUserUnregisterUserApiHook",
	L"NtUserUnregisterHotKey",
	L"NtUserUpdateInputContext",
	L"NtUserUpdateInstance",
	L"NtUserUpdateLayeredWindow",
	L"NtUserGetLayeredWindowAttributes",
	L"NtUserSetLayeredWindowAttributes",
	L"NtUserUpdatePerUserSystemParameters",
	L"NtUserUserHandleGrantAccess",
	L"NtUserValidateHandleSecure",
	L"NtUserValidateRect",
	L"NtUserValidateTimerCallback",
	L"NtUserVkKeyScanEx",
	L"NtUserWaitForInputIdle",
	L"NtUserWaitForMsgAndEvent",
	L"NtUserWaitMessage",
	L"DxgStubCreateSurfaceObject",
	L"NtUserWindowFromPhysicalPoint",
	L"NtUserWindowFromPoint",
	L"NtUserYieldTask",
	L"NtUserRemoteConnect",
	L"NtUserRemoteRedrawRectangle",
	L"NtUserRemoteRedrawScreen",
	L"NtUserRemoteStopScreenUpdates",
	L"NtUserCtxDisplayIOCtl",
	L"NtUserRegisterSessionPort",
	L"NtUserUnregisterSessionPort",
	L"NtUserUpdateWindowTransform",
	L"NtUserDwmStartRedirection",
	L"NtUserDwmStopRedirection",
	L"NtUserDwmHintDxUpdate",
	L"NtUserDwmGetDxRgn",
	L"NtUserGetWindowMinimizeRect",
	L"NtGdiEngAssociateSurface",
	L"NtGdiEngCreateBitmap",
	L"NtGdiEngCreateDeviceSurface",
	L"NtGdiEngCreateDeviceBitmap",
	L"NtGdiEngCreatePalette",
	L"NtGdiEngComputeGlyphSet",
	L"NtGdiEngCopyBits",
	L"NtGdiEngDeletePalette",
	L"NtGdiEngDeleteSurface",
	L"NtGdiEngEraseSurface",
	L"NtGdiEngUnlockSurface",
	L"NtGdiEngLockSurface",
	L"NtGdiEngBitBlt",
	L"NtGdiEngStretchBlt",
	L"NtGdiEngPlgBlt",
	L"NtGdiEngMarkBandingSurface",
	L"NtGdiEngStrokePath",
	L"NtGdiEngFillPath",
	L"NtGdiEngStrokeAndFillPath",
	L"NtGdiEngPaint",
	L"NtGdiEngLineTo",
	L"NtGdiEngAlphaBlend",
	L"NtGdiEngGradientFill",
	L"NtGdiEngTransparentBlt",
	L"NtGdiEngTextOut",
	L"NtGdiEngStretchBltROP",
	L"NtGdiXLATEOBJ_cGetPalette",
	L"NtGdiXLATEOBJ_iXlate",
	L"NtGdiXLATEOBJ_hGetColorTransform",
	L"NtGdiCLIPOBJ_bEnum",
	L"NtGdiCLIPOBJ_cEnumStart",
	L"NtGdiCLIPOBJ_ppoGetPath",
	L"NtGdiEngDeletePath",
	L"NtGdiEngCreateClip",
	L"NtGdiEngDeleteClip",
	L"NtGdiBRUSHOBJ_ulGetBrushColor",
	L"NtGdiBRUSHOBJ_pvAllocRbrush",
	L"NtGdiBRUSHOBJ_pvGetRbrush",
	L"NtGdiBRUSHOBJ_hGetColorTransform",
	L"NtGdiXFORMOBJ_bApplyXform",
	L"NtGdiXFORMOBJ_iGetXform",
	L"NtGdiFONTOBJ_vGetInfo",
	L"NtGdiFONTOBJ_pxoGetXform",
	L"NtGdiFONTOBJ_cGetGlyphs",
	L"NtGdiFONTOBJ_pifi",
	L"NtGdiFONTOBJ_pfdg",
	L"NtGdiFONTOBJ_pQueryGlyphAttrs",
	L"NtGdiFONTOBJ_pvTrueTypeFontFile",
	L"NtGdiFONTOBJ_cGetAllGlyphHandles",
	L"NtGdiSTROBJ_bEnum",
	L"NtGdiSTROBJ_bEnumPositionsOnly",
	L"NtGdiSTROBJ_bGetAdvanceWidths",
	L"NtGdiSTROBJ_vEnumStart",
	L"NtGdiSTROBJ_dwGetCodePage",
	L"NtGdiPATHOBJ_vGetBounds",
	L"NtGdiPATHOBJ_bEnum",
	L"NtGdiPATHOBJ_vEnumStart",
	L"NtGdiPATHOBJ_vEnumStartClipLines",
	L"NtGdiPATHOBJ_bEnumClipLines",
	L"NtGdiGetDhpdev",
	L"NtGdiEngCheckAbort",
	L"NtGdiHT_Get8BPPFormatPalette",
	L"NtGdiHT_Get8BPPMaskPalette",
	L"NtGdiUpdateTransform",
	L"NtGdiSetPUMPDOBJ",
	L"NtGdiBRUSHOBJ_DeleteRbrush",
	L"NtGdiUnmapMemFont",
	L"NtGdiDrawStream",
	L"NtGdiDwmGetDirtyRgn",
	L"NtGdiDwmGetSurfaceData",
	L"NtGdiDdDDICreateAllocation",
	L"NtGdiDdDDIQueryResourceInfo",
	L"NtGdiDdDDIOpenResource",
	L"NtGdiDdDDIDestroyAllocation",
	L"NtGdiDdDDISetAllocationPriority",
	L"NtGdiDdDDIQueryAllocationResidency",
	L"NtGdiDdDDICreateDevice",
	L"NtGdiDdDDIDestroyDevice",
	L"NtGdiDdDDICreateContext",
	L"NtGdiDdDDIDestroyContext",
	L"NtGdiDdDDICreateSynchronizationObject",
	L"NtGdiDdDDIDestroySynchronizationObject",
	L"NtGdiDdDDIWaitForSynchronizationObject",
	L"NtGdiDdDDISignalSynchronizationObject",
	L"NtGdiDdDDIGetRuntimeData",
	L"NtGdiDdDDIQueryAdapterInfo",
	L"NtGdiDdDDILock",
	L"NtGdiDdDDIUnlock",
	L"NtGdiDdDDIGetDisplayModeList",
	L"NtGdiDdDDISetDisplayMode",
	L"NtGdiDdDDIGetMultisampleMethodList",
	L"NtGdiDdDDIPresent",
	L"NtGdiDdDDIRender",
	L"NtGdiDdDDIOpenAdapterFromDeviceName",
	L"NtGdiDdDDIOpenAdapterFromHdc",
	L"NtGdiDdDDICloseAdapter",
	L"NtGdiDdDDIGetSharedPrimaryHandle",
	L"NtGdiDdDDIEscape",
	L"NtGdiDdDDIQueryStatistics",
	L"NtGdiDdDDISetVidPnSourceOwner",
	L"NtGdiDdDDIGetPresentHistory",
	L"NtGdiDdDDICreateOverlay",
	L"NtGdiDdDDIUpdateOverlay",
	L"NtGdiDdDDIFlipOverlay",
	L"NtGdiDdDDIDestroyOverlay",
	L"NtGdiDdDDIWaitForVerticalBlankEvent",
	L"NtGdiDdDDISetGammaRamp",
	L"NtGdiDdDDIGetDeviceState",
	L"NtGdiDdDDICreateDCFromMemory",
	L"NtGdiDdDDIDestroyDCFromMemory",
	L"NtGdiDdDDISetContextSchedulingPriority",
	L"NtGdiDdDDIGetContextSchedulingPriority",
	L"NtGdiDdDDISetProcessSchedulingPriorityClass",
	L"NtGdiDdDDIGetProcessSchedulingPriorityClass",
	L"NtGdiDdDDIReleaseProcessVidPnSourceOwners",
	L"NtGdiDdDDIGetScanLine",
	L"NtGdiDdDDISetQueuedLimit",
	L"NtGdiDdDDIPollDisplayChildren",
	L"NtGdiDdDDIInvalidateActiveVidPn",
	L"NtGdiDdDDICheckOcclusion",
	L"NtGdiDdDDIWaitForIdle",
	L"NtGdiDdDDICheckMonitorPowerState",
	L"NtGdiDdDDICheckExclusiveOwnership",
	L"NtGdiDdDDISetDisplayPrivateDriverFormat",
	L"NtGdiDdDDISharedPrimaryLockNotification",
	L"NtGdiDdDDISharedPrimaryUnLockNotification",
	L"DxgStubEnableDirectDrawRedirection",
	L"DxgStubDeleteDirectDrawObject",
	L"NtGdiGetNumberOfPhysicalMonitors",
	L"NtGdiGetPhysicalMonitors",
	L"NtGdiGetPhysicalMonitorDescription",
	L"DestroyPhysicalMonitor",
	L"NtGdiDDCCIGetVCPFeature",
	L"NtGdiDDCCISetVCPFeature",
	L"NtGdiDDCCISaveCurrentSettings",
	L"NtGdiDDCCIGetCapabilitiesStringLength",
	L"NtGdiDDCCIGetCapabilitiesString",
	L"NtGdiDDCCIGetTimingReport",
	L"NtUserSetMirrorRendering",
	L"NtUserShowSystemCursor",
};

WCHAR *Win7Shadow[] = {
	L"NtGdiAbortDoc",
	L"NtGdiAbortPath",
	L"NtGdiAddFontResourceW",
	L"NtGdiAddRemoteFontToDC",
	L"NtGdiAddFontMemResourceEx",
	L"NtGdiRemoveMergeFont",
	L"NtGdiAddRemoteMMInstanceToDC",
	L"NtGdiAlphaBlend",
	L"NtGdiAngleArc",
	L"NtGdiAnyLinkedFonts",
	L"NtGdiFontIsLinked",
	L"NtGdiArcInternal",
	L"NtGdiBeginGdiRendering",
	L"NtGdiBeginPath",
	L"NtGdiBitBlt",
	L"NtGdiCancelDC",
	L"NtGdiCheckBitmapBits",
	L"NtGdiCloseFigure",
	L"NtGdiClearBitmapAttributes",
	L"NtGdiClearBrushAttributes",
	L"NtGdiColorCorrectPalette",
	L"NtGdiCombineRgn",
	L"NtGdiCombineTransform",
	L"NtGdiComputeXformCoefficients",
	L"NtGdiConfigureOPMProtectedOutput",
	L"NtGdiConvertMetafileRect",
	L"NtGdiCreateBitmap",
	L"NtGdiCreateBitmapFromDxSurface",
	L"NtGdiCreateClientObj",
	L"NtGdiCreateColorSpace",
	L"NtGdiCreateColorTransform",
	L"NtGdiCreateCompatibleBitmap",
	L"NtGdiCreateCompatibleDC",
	L"NtGdiCreateDIBBrush",
	L"NtGdiCreateDIBitmapInternal",
	L"NtGdiCreateDIBSection",
	L"NtGdiCreateEllipticRgn",
	L"NtGdiCreateHalftonePalette",
	L"NtGdiCreateHatchBrushInternal",
	L"NtGdiCreateMetafileDC",
	L"NtGdiCreateOPMProtectedOutputs",
	L"NtGdiCreatePaletteInternal",
	L"NtGdiCreatePatternBrushInternal",
	L"NtGdiCreatePen",
	L"NtGdiCreateRectRgn",
	L"NtGdiCreateRoundRectRgn",
	L"NtGdiCreateServerMetaFile",
	L"NtGdiCreateSolidBrush",
	L"NtGdiD3dContextCreate",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroyAll",
	L"NtGdiD3dValidateTextureStageState",
	L"NtGdiD3dDrawPrimitives2",
	L"NtGdiDdGetDriverState",
	L"NtGdiDdAddAttachedSurface",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAttachSurface",
	L"NtGdiDdBeginMoCompFrame",
	L"NtGdiDdBlt",
	L"NtGdiDdCanCreateSurface",
	L"NtGdiDdCanCreateD3DBuffer",
	L"NtGdiDdColorControl",
	L"NtGdiDdCreateDirectDrawObject",
	L"NtGdiDdCreateSurface",
	L"NtGdiDdCreateD3DBuffer",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdDeleteDirectDrawObject",
	L"NtGdiDdDeleteSurfaceObject",
	L"NtGdiDdDestroyMoComp",
	L"NtGdiDdDestroySurface",
	L"NtGdiDdDestroyD3DBuffer",
	L"NtGdiDdEndMoCompFrame",
	L"NtGdiDdFlip",
	L"NtGdiDdFlipToGDISurface",
	L"NtGdiDdGetAvailDriverMemory",
	L"NtGdiDdGetBltStatus",
	L"NtGdiDdGetDC",
	L"NtGdiDdGetDriverInfo",
	L"NtGdiDdGetDxHandle",
	L"NtGdiDdGetFlipStatus",
	L"NtGdiDdGetInternalMoCompInfo",
	L"NtGdiDdGetMoCompBuffInfo",
	L"NtGdiDdGetMoCompGuids",
	L"NtGdiDdGetMoCompFormats",
	L"NtGdiDdGetScanLine",
	L"NtGdiDdLock",
	L"NtGdiDdLockD3D",
	L"NtGdiDdQueryDirectDrawObject",
	L"NtGdiDdQueryMoCompStatus",
	L"NtGdiDdReenableDirectDrawObject",
	L"NtGdiDdReleaseDC",
	L"NtGdiDdRenderMoComp",
	L"NtGdiDdResetVisrgn",
	L"NtGdiDdSetColorKey",
	L"NtGdiDdSetExclusiveMode",
	L"NtGdiDdSetGammaRamp",
	L"NtGdiDdCreateSurfaceEx",
	L"NtGdiDdSetOverlayPosition",
	L"NtGdiDdUnattachSurface",
	L"NtGdiDdUnlock",
	L"NtGdiDdUnlockD3D",
	L"NtGdiDdUpdateOverlay",
	L"NtGdiDdWaitForVerticalBlank",
	L"NtGdiDvpCanCreateVideoPort",
	L"NtGdiDvpColorControl",
	L"NtGdiDvpCreateVideoPort",
	L"NtGdiDvpDestroyVideoPort",
	L"NtGdiDvpFlipVideoPort",
	L"NtGdiDvpGetVideoPortBandwidth",
	L"NtGdiDvpGetVideoPortField",
	L"NtGdiDvpGetVideoPortFlipStatus",
	L"NtGdiDvpGetVideoPortInputFormats",
	L"NtGdiDvpGetVideoPortLine",
	L"NtGdiDvpGetVideoPortOutputFormats",
	L"NtGdiDvpGetVideoPortConnectInfo",
	L"NtGdiDvpGetVideoSignalStatus",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDvpWaitForVideoPortSync",
	L"NtGdiDvpAcquireNotification",
	L"NtGdiDvpReleaseNotification",
	L"NtGdiDxgGenericThunk",
	L"NtGdiDeleteClientObj",
	L"NtGdiDeleteColorSpace",
	L"NtGdiDeleteColorTransform",
	L"NtGdiDeleteObjectApp",
	L"NtGdiDescribePixelFormat",
	L"NtGdiDestroyOPMProtectedOutput",
	L"NtGdiGetPerBandInfo",
	L"NtGdiDoBanding",
	L"NtGdiDoPalette",
	L"NtGdiDrawEscape",
	L"NtGdiEllipse",
	L"NtGdiEnableEudc",
	L"NtGdiEndDoc",
	L"NtGdiEndGdiRendering",
	L"NtGdiEndPage",
	L"NtGdiEndPath",
	L"NtGdiEnumFonts",
	L"NtGdiEnumObjects",
	L"NtGdiEqualRgn",
	L"NtGdiEudcLoadUnloadLink",
	L"NtGdiExcludeClipRect",
	L"NtGdiExtCreatePen",
	L"NtGdiExtCreateRegion",
	L"NtGdiExtEscape",
	L"NtGdiExtFloodFill",
	L"NtGdiExtGetObjectW",
	L"NtGdiExtSelectClipRgn",
	L"NtGdiExtTextOutW",
	L"NtGdiFillPath",
	L"NtGdiFillRgn",
	L"NtGdiFlattenPath",
	L"NtGdiFlush",
	L"NtGdiForceUFIMapping",
	L"NtGdiFrameRgn",
	L"NtGdiFullscreenControl",
	L"NtGdiGetAndSetDCDword",
	L"NtGdiGetAppClipBox",
	L"NtGdiGetBitmapBits",
	L"NtGdiGetBitmapDimension",
	L"NtGdiGetBoundsRect",
	L"NtGdiGetCertificate",
	L"NtGdiGetCertificateSize",
	L"NtGdiGetCharABCWidthsW",
	L"NtGdiGetCharacterPlacementW",
	L"NtGdiGetCharSet",
	L"NtGdiGetCharWidthW",
	L"NtGdiGetCharWidthInfo",
	L"NtGdiGetColorAdjustment",
	L"NtGdiGetColorSpaceforBitmap",
	L"NtGdiGetCOPPCompatibleOPMInformation",
	L"NtGdiGetDCDword",
	L"NtGdiGetDCforBitmap",
	L"NtGdiGetDCObject",
	L"NtGdiGetDCPoint",
	L"NtGdiGetDeviceCaps",
	L"NtGdiGetDeviceGammaRamp",
	L"NtGdiGetDeviceCapsAll",
	L"NtGdiGetDIBitsInternal",
	L"NtGdiGetETM",
	L"NtGdiGetEudcTimeStampEx",
	L"NtGdiGetFontData",
	L"NtGdiGetFontFileData",
	L"NtGdiGetFontFileInfo",
	L"NtGdiGetFontResourceInfoInternalW",
	L"NtGdiGetGlyphIndicesW",
	L"NtGdiGetGlyphIndicesWInternal",
	L"NtGdiGetGlyphOutline",
	L"NtGdiGetOPMInformation",
	L"NtGdiGetKerningPairs",
	L"NtGdiGetLinkedUFIs",
	L"NtGdiGetMiterLimit",
	L"NtGdiGetMonitorID",
	L"NtGdiGetNearestColor",
	L"NtGdiGetNearestPaletteIndex",
	L"NtGdiGetObjectBitmapHandle",
	L"NtGdiGetOPMRandomNumber",
	L"NtGdiGetOutlineTextMetricsInternalW",
	L"NtGdiGetPath",
	L"NtGdiGetPixel",
	L"NtGdiGetRandomRgn",
	L"NtGdiGetRasterizerCaps",
	L"NtGdiGetRealizationInfo",
	L"NtGdiGetRegionData",
	L"NtGdiGetRgnBox",
	L"NtGdiGetServerMetaFileBits",
	L"DxgStubContextCreate",
	L"NtGdiGetStats",
	L"NtGdiGetStockObject",
	L"NtGdiGetStringBitmapW",
	L"NtGdiGetSuggestedOPMProtectedOutputArraySize",
	L"NtGdiGetSystemPaletteUse",
	L"NtGdiGetTextCharsetInfo",
	L"NtGdiGetTextExtent",
	L"NtGdiGetTextExtentExW",
	L"NtGdiGetTextFaceW",
	L"NtGdiGetTextMetricsW",
	L"NtGdiGetTransform",
	L"NtGdiGetUFI",
	L"NtGdiGetEmbUFI",
	L"NtGdiGetUFIPathname",
	L"NtGdiGetEmbedFonts",
	L"NtGdiChangeGhostFont",
	L"NtGdiAddEmbFontToDC",
	L"NtGdiGetFontUnicodeRanges",
	L"NtGdiGetWidthTable",
	L"NtGdiGradientFill",
	L"NtGdiHfontCreate",
	L"NtGdiIcmBrushInfo",
	L"IsIMMEnabledSystem",
	L"NtGdiInitSpool",
	L"NtGdiIntersectClipRect",
	L"NtGdiInvertRgn",
	L"NtGdiLineTo",
	L"NtGdiMakeFontDir",
	L"NtGdiMakeInfoDC",
	L"NtGdiMaskBlt",
	L"NtGdiModifyWorldTransform",
	L"NtGdiMonoBitmap",
	L"NtGdiMoveTo",
	L"NtGdiOffsetClipRgn",
	L"NtGdiOffsetRgn",
	L"NtGdiOpenDCW",
	L"NtGdiPatBlt",
	L"NtGdiPolyPatBlt",
	L"NtGdiPathToRegion",
	L"NtGdiPlgBlt",
	L"NtGdiPolyDraw",
	L"NtGdiPolyPolyDraw",
	L"NtGdiPolyTextOutW",
	L"NtGdiPtInRegion",
	L"NtGdiPtVisible",
	L"NtGdiQueryFonts",
	L"NtGdiQueryFontAssocInfo",
	L"NtGdiRectangle",
	L"NtGdiRectInRegion",
	L"NtGdiRectVisible",
	L"NtGdiRemoveFontResourceW",
	L"NtGdiRemoveFontMemResourceEx",
	L"NtGdiResetDC",
	L"NtGdiResizePalette",
	L"NtGdiRestoreDC",
	L"NtGdiRoundRect",
	L"NtGdiSaveDC",
	L"NtGdiScaleViewportExtEx",
	L"NtGdiScaleWindowExtEx",
	L"GreSelectBitmap",
	L"NtGdiSelectBrush",
	L"NtGdiSelectClipPath",
	L"NtGdiSelectFont",
	L"NtGdiSelectPen",
	L"NtGdiSetBitmapAttributes",
	L"NtGdiSetBitmapBits",
	L"NtGdiSetBitmapDimension",
	L"NtGdiSetBoundsRect",
	L"NtGdiSetBrushAttributes",
	L"NtGdiSetBrushOrg",
	L"NtGdiSetColorAdjustment",
	L"NtGdiSetColorSpace",
	L"NtGdiSetDeviceGammaRamp",
	L"NtGdiSetDIBitsToDeviceInternal",
	L"NtGdiSetFontEnumeration",
	L"NtGdiSetFontXform",
	L"NtGdiSetIcmMode",
	L"NtGdiSetLinkedUFIs",
	L"NtGdiSetMagicColors",
	L"NtGdiSetMetaRgn",
	L"NtGdiSetMiterLimit",
	L"NtGdiGetDeviceWidth",
	L"NtGdiMirrorWindowOrg",
	L"NtGdiSetLayout",
	L"NtGdiSetOPMSigningKeyAndSequenceNumbers",
	L"NtGdiSetPixel",
	L"NtGdiSetPixelFormat",
	L"NtGdiSetRectRgn",
	L"NtGdiSetSystemPaletteUse",
	L"NtGdiSetTextJustification",
	L"NtGdiSetVirtualResolution",
	L"NtGdiSetSizeDevice",
	L"NtGdiStartDoc",
	L"NtGdiStartPage",
	L"NtGdiStretchBlt",
	L"NtGdiStretchDIBitsInternal",
	L"NtGdiStrokeAndFillPath",
	L"NtGdiStrokePath",
	L"NtGdiSwapBuffers",
	L"NtGdiTransformPoints",
	L"NtGdiTransparentBlt",
	L"DxgStubEnableDirectDrawRedirection",
	L"NtGdiUnmapMemFont",
	L"NtGdiUnrealizeObject",
	L"NtGdiUpdateColors",
	L"NtGdiWidenPath",
	L"NtUserActivateKeyboardLayout",
	L"NtUserAddClipboardFormatListener",
	L"NtUserAlterWindowStyle",
	L"NtUserAssociateInputContext",
	L"NtUserAttachThreadInput",
	L"NtUserBeginPaint",
	L"NtUserBitBltSysBmp",
	L"NtUserBlockInput",
	L"NtUserBuildHimcList",
	L"NtUserBuildHwndList",
	L"NtUserBuildNameList",
	L"NtUserBuildPropList",
	L"NtUserCallHwnd",
	L"NtUserCallHwndLock",
	L"NtUserCallHwndOpt",
	L"NtUserCallHwndParam",
	L"NtUserCallHwndParamLock",
	L"NtUserCallMsgFilter",
	L"NtUserCallNextHookEx",
	L"NtUserCallNoParam",
	L"NtUserCallOneParam",
	L"NtUserCallTwoParam",
	L"NtUserChangeClipboardChain",
	L"NtUserChangeDisplaySettings",
	L"NtUserGetDisplayConfigBufferSizes",
	L"NtUserSetDisplayConfig",
	L"NtUserQueryDisplayConfig",
	L"NtUserDisplayConfigGetDeviceInfo",
	L"NtUserDisplayConfigSetDeviceInfo",
	L"NtUserCheckAccessForIntegrityLevel",
	L"NtUserCheckDesktopByThreadId",
	L"NtUserCheckWindowThreadDesktop",
	L"NtUserCheckMenuItem",
	L"NtUserChildWindowFromPointEx",
	L"NtUserClipCursor",
	L"NtUserCloseClipboard",
	L"NtUserCloseDesktop",
	L"NtUserCloseWindowStation",
	L"NtUserConsoleControl",
	L"NtUserConvertMemHandle",
	L"NtUserCopyAcceleratorTable",
	L"NtUserCountClipboardFormats",
	L"NtUserCreateAcceleratorTable",
	L"NtUserCreateCaret",
	L"NtUserCreateDesktopEx",
	L"NtUserCreateInputContext",
	L"NtUserCreateLocalMemHandle",
	L"NtUserCreateWindowEx",
	L"NtUserCreateWindowStation",
	L"NtUserDdeInitialize",
	L"NtUserDeferWindowPos",
	L"NtUserDefSetText",
	L"NtUserDeleteMenu",
	L"NtUserDestroyAcceleratorTable",
	L"NtUserDestroyCursor",
	L"NtUserDestroyInputContext",
	L"NtUserDestroyMenu",
	L"NtUserDestroyWindow",
	L"NtUserDisableThreadIme",
	L"NtUserDispatchMessage",
	L"NtUserDoSoundConnect",
	L"NtUserDoSoundDisconnect",
	L"NtUserDragDetect",
	L"NtUserDragObject",
	L"NtUserDrawAnimatedRects",
	L"NtUserDrawCaption",
	L"NtUserDrawCaptionTemp",
	L"NtUserDrawIconEx",
	L"NtUserDrawMenuBarTemp",
	L"NtUserEmptyClipboard",
	L"NtUserEnableMenuItem",
	L"NtUserEnableScrollBar",
	L"NtUserEndDeferWindowPosEx",
	L"NtUserEndMenu",
	L"NtUserEndPaint",
	L"NtUserEnumDisplayDevices",
	L"NtUserEnumDisplayMonitors",
	L"NtUserEnumDisplaySettings",
	L"NtUserEvent",
	L"NtUserExcludeUpdateRgn",
	L"NtUserFillWindow",
	L"NtUserFindExistingCursorIcon",
	L"NtUserFindWindowEx",
	L"NtUserFlashWindowEx",
	L"NtUserFrostCrashedWindow",
	L"NtUserGetAltTabInfo",
	L"NtUserGetAncestor",
	L"NtUserGetAppImeLevel",
	L"NtUserGetAsyncKeyState",
	L"NtUserGetAtomName",
	L"NtUserGetCaretBlinkTime",
	L"NtUserGetCaretPos",
	L"NtUserGetClassInfoEx",
	L"NtUserGetClassName",
	L"NtUserGetClipboardData",
	L"NtUserGetClipboardFormatName",
	L"NtUserGetClipboardOwner",
	L"NtUserGetClipboardSequenceNumber",
	L"NtUserGetClipboardViewer",
	L"NtUserGetClipCursor",
	L"NtUserGetComboBoxInfo",
	L"NtUserGetControlBrush",
	L"NtUserGetControlColor",
	L"NtUserGetCPD",
	L"NtUserGetCursorFrameInfo",
	L"NtUserGetCursorInfo",
	L"NtUserGetDC",
	L"NtUserGetDCEx",
	L"NtUserGetDoubleClickTime",
	L"NtUserGetForegroundWindow",
	L"NtUserGetGuiResources",
	L"NtUserGetGUIThreadInfo",
	L"NtUserGetIconInfo",
	L"NtUserGetIconSize",
	L"NtUserGetImeHotKey",
	L"NtUserGetImeInfoEx",
	L"NtUserGetInputLocaleInfo",
	L"NtUserGetInternalWindowPos",
	L"NtUserGetKeyboardLayoutList",
	L"NtUserGetKeyboardLayoutName",
	L"NtUserGetKeyboardState",
	L"NtUserGetKeyNameText",
	L"NtUserGetKeyState",
	L"NtUserGetListBoxInfo",
	L"NtUserGetMenuBarInfo",
	L"NtUserGetMenuIndex",
	L"NtUserGetMenuItemRect",
	L"NtUserGetMessage",
	L"NtUserGetMouseMovePointsEx",
	L"NtUserGetObjectInformation",
	L"NtUserGetOpenClipboardWindow",
	L"NtUserGetPriorityClipboardFormat",
	L"NtUserGetProcessWindowStation",
	L"NtUserGetRawInputBuffer",
	L"NtUserGetRawInputData",
	L"NtUserGetRawInputDeviceInfo",
	L"NtUserGetRawInputDeviceList",
	L"NtUserGetRegisteredRawInputDevices",
	L"NtUserGetScrollBarInfo",
	L"NtUserGetSystemMenu",
	L"NtUserGetThreadDesktop",
	L"NtUserGetThreadState",
	L"NtUserGetTitleBarInfo",
	L"NtUserGetTopLevelWindow",
	L"NtUserGetUpdatedClipboardFormats",
	L"NtUserGetUpdateRect",
	L"NtUserGetUpdateRgn",
	L"NtUserGetWindowCompositionInfo",
	L"NtUserGetWindowCompositionAttribute",
	L"NtUserGetWindowDC",
	L"NtUserGetWindowDisplayAffinity",
	L"NtUserGetWindowPlacement",
	L"NtUserGetWOWClass",
	L"NtUserGhostWindowFromHungWindow",
	L"NtUserHardErrorControl",
	L"NtUserHideCaret",
	L"NtUserHiliteMenuItem",
	L"NtUserHungWindowFromGhostWindow",
	L"NtUserImpersonateDdeClientWindow",
	L"NtUserInitialize",
	L"NtUserInitializeClientPfnArrays",
	L"NtUserInitTask",
	L"NtUserInternalGetWindowText",
	L"NtUserInternalGetWindowIcon",
	L"NtUserInvalidateRect",
	L"NtUserInvalidateRgn",
	L"NtUserIsClipboardFormatAvailable",
	L"NtUserIsTopLevelWindow",
	L"NtUserKillTimer",
	L"NtUserLoadKeyboardLayoutEx",
	L"NtUserLockWindowStation",
	L"NtUserLockWindowUpdate",
	L"NtUserLockWorkStation",
	L"NtUserLogicalToPhysicalPoint",
	L"NtUserMapVirtualKeyEx",
	L"NtUserMenuItemFromPoint",
	L"NtUserMessageCall",
	L"NtUserMinMaximize",
	L"NtUserMNDragLeave",
	L"NtUserMNDragOver",
	L"NtUserModifyUserStartupInfoFlags",
	L"NtUserMoveWindow",
	L"NtUserNotifyIMEStatus",
	L"NtUserNotifyProcessCreate",
	L"NtUserNotifyWinEvent",
	L"NtUserOpenClipboard",
	L"NtUserOpenDesktop",
	L"NtUserOpenInputDesktop",
	L"NtUserOpenThreadDesktop",
	L"NtUserOpenWindowStation",
	L"NtUserPaintDesktop",
	L"NtUserPaintMonitor",
	L"NtUserPeekMessage",
	L"NtUserPhysicalToLogicalPoint",
	L"NtUserPostMessage",
	L"NtUserPostThreadMessage",
	L"NtUserPrintWindow",
	L"NtUserProcessConnect",
	L"NtUserQueryInformationThread",
	L"NtUserQueryInputContext",
	L"NtUserQuerySendMessage",
	L"NtUserQueryWindow",
	L"NtUserRealChildWindowFromPoint",
	L"NtUserRealInternalGetMessage",
	L"NtUserRealWaitMessageEx",
	L"NtUserRedrawWindow",
	L"NtUserRegisterClassExWOW",
	L"NtUserRegisterErrorReportingDialog",
	L"NtUserRegisterUserApiHook",
	L"NtUserRegisterHotKey",
	L"NtUserRegisterRawInputDevices",
	L"NtUserRegisterServicesProcess",
	L"NtUserRegisterTasklist",
	L"NtUserRegisterWindowMessage",
	L"NtUserRemoveClipboardFormatListener",
	L"NtUserRemoveMenu",
	L"NtUserRemoveProp",
	L"NtUserResolveDesktopForWOW",
	L"NtUserSBGetParms",
	L"NtUserScrollDC",
	L"NtUserScrollWindowEx",
	L"NtUserSelectPalette",
	L"NtUserSendInput",
	L"NtUserSetActiveWindow",
	L"NtUserSetAppImeLevel",
	L"NtUserSetCapture",
	L"NtUserSetChildWindowNoActivate",
	L"NtUserSetClassLong",
	L"NtUserSetClassWord",
	L"NtUserSetClipboardData",
	L"NtUserSetClipboardViewer",
	L"NtUserSetCursor",
	L"NtUserSetCursorContents",
	L"NtUserSetCursorIconData",
	L"NtUserSetFocus",
	L"NtUserSetImeHotKey",
	L"NtUserSetImeInfoEx",
	L"NtUserSetImeOwnerWindow",
	L"NtUserSetInformationThread",
	L"NtUserSetInternalWindowPos",
	L"NtUserSetKeyboardState",
	L"NtUserSetMenu",
	L"NtUserSetMenuContextHelpId",
	L"NtUserSetMenuDefaultItem",
	L"NtUserSetMenuFlagRtoL",
	L"NtUserSetObjectInformation",
	L"NtUserSetParent",
	L"NtUserSetProcessWindowStation",
	L"NtUserGetProp",
	L"NtUserSetProp",
	L"NtUserSetScrollInfo",
	L"NtUserSetShellWindowEx",
	L"NtUserSetSysColors",
	L"NtUserSetSystemCursor",
	L"NtUserSetSystemMenu",
	L"NtUserSetSystemTimer",
	L"NtUserSetThreadDesktop",
	L"NtUserSetThreadLayoutHandles",
	L"NtUserSetThreadState",
	L"NtUserSetTimer",
	L"NtUserSetProcessDPIAware",
	L"NtUserSetWindowCompositionAttribute",
	L"NtUserSetWindowDisplayAffinity",
	L"NtUserSetWindowFNID",
	L"NtUserSetWindowLong",
	L"NtUserSetWindowPlacement",
	L"NtUserSetWindowPos",
	L"NtUserSetWindowRgn",
	L"NtUserGetWindowRgnEx",
	L"NtUserSetWindowRgnEx",
	L"NtUserSetWindowsHookAW",
	L"NtUserSetWindowsHookEx",
	L"NtUserSetWindowStationUser",
	L"NtUserSetWindowWord",
	L"NtUserSetWinEventHook",
	L"NtUserShowCaret",
	L"NtUserShowScrollBar",
	L"NtUserShowWindow",
	L"NtUserShowWindowAsync",
	L"NtUserSoundSentry",
	L"NtUserSwitchDesktop",
	L"NtUserSystemParametersInfo",
	L"NtUserTestForInteractiveUser",
	L"NtUserThunkedMenuInfo",
	L"NtUserThunkedMenuItemInfo",
	L"NtUserToUnicodeEx",
	L"NtUserTrackMouseEvent",
	L"NtUserTrackPopupMenuEx",
	L"NtUserCalculatePopupWindowPosition",
	L"NtUserCalcMenuBar",
	L"NtUserPaintMenuBar",
	L"NtUserTranslateAccelerator",
	L"NtUserTranslateMessage",
	L"NtUserUnhookWindowsHookEx",
	L"NtUserUnhookWinEvent",
	L"NtUserUnloadKeyboardLayout",
	L"NtUserUnlockWindowStation",
	L"NtUserUnregisterClass",
	L"NtUserUnregisterUserApiHook",
	L"NtUserUnregisterHotKey",
	L"NtUserUpdateInputContext",
	L"NtUserUpdateInstance",
	L"NtUserUpdateLayeredWindow",
	L"NtUserGetLayeredWindowAttributes",
	L"NtUserSetLayeredWindowAttributes",
	L"NtUserUpdatePerUserSystemParameters",
	L"NtUserUserHandleGrantAccess",
	L"NtUserValidateHandleSecure",
	L"NtUserValidateRect",
	L"NtUserValidateTimerCallback",
	L"NtUserVkKeyScanEx",
	L"NtUserWaitForInputIdle",
	L"NtUserWaitForMsgAndEvent",
	L"NtUserWaitMessage",
	L"NtUserWindowFromPhysicalPoint",
	L"NtUserWindowFromPoint",
	L"NtUserYieldTask",
	L"NtUserRemoteConnect",
	L"NtUserRemoteRedrawRectangle",
	L"NtUserRemoteRedrawScreen",
	L"NtUserRemoteStopScreenUpdates",
	L"NtUserCtxDisplayIOCtl",
	L"NtUserRegisterSessionPort",
	L"NtUserUnregisterSessionPort",
	L"NtUserUpdateWindowTransform",
	L"NtUserDwmStartRedirection",
	L"NtUserDwmStopRedirection",
	L"NtUserGetWindowMinimizeRect",
	L"NtUserSfmDxBindSwapChain",
	L"NtUserSfmDxOpenSwapChain",
	L"NtUserSfmDxReleaseSwapChain",
	L"NtUserSfmDxSetSwapChainBindingStatus",
	L"NtUserSfmDxQuerySwapChainBindingStatus",
	L"NtUserSfmDxReportPendingBindingsToDwm",
	L"NtUserSfmDxGetSwapChainStats",
	L"NtUserSfmDxSetSwapChainStats",
	L"NtUserSfmGetLogicalSurfaceBinding",
	L"NtUserSfmDestroyLogicalSurfaceBinding",
	L"NtUserModifyWindowTouchCapability",
	L"NtUserIsTouchWindow",
	L"NtUserSendTouchInput",
	L"NtUserEndTouchOperation",
	L"NtUserGetTouchInputInfo",
	L"NtUserChangeWindowMessageFilterEx",
	L"NtUserInjectGesture",
	L"NtUserGetGestureInfo",
	L"NtUserGetGestureExtArgs",
	L"NtUserManageGestureHandlerWindow",
	L"NtUserSetGestureConfig",
	L"NtUserGetGestureConfig",
	L"NtGdiEngAssociateSurface",
	L"NtGdiEngCreateBitmap",
	L"NtGdiEngCreateDeviceSurface",
	L"NtGdiEngCreateDeviceBitmap",
	L"NtGdiEngCreatePalette",
	L"NtGdiEngComputeGlyphSet",
	L"NtGdiEngCopyBits",
	L"NtGdiEngDeletePalette",
	L"NtGdiEngDeleteSurface",
	L"NtGdiEngEraseSurface",
	L"NtGdiEngUnlockSurface",
	L"NtGdiEngLockSurface",
	L"NtGdiEngBitBlt",
	L"NtGdiEngStretchBlt",
	L"NtGdiEngPlgBlt",
	L"NtGdiEngMarkBandingSurface",
	L"NtGdiEngStrokePath",
	L"NtGdiEngFillPath",
	L"NtGdiEngStrokeAndFillPath",
	L"NtGdiEngPaint",
	L"NtGdiEngLineTo",
	L"NtGdiEngAlphaBlend",
	L"NtGdiEngGradientFill",
	L"NtGdiEngTransparentBlt",
	L"NtGdiEngTextOut",
	L"NtGdiEngStretchBltROP",
	L"NtGdiXLATEOBJ_cGetPalette",
	L"NtGdiXLATEOBJ_iXlate",
	L"NtGdiXLATEOBJ_hGetColorTransform",
	L"NtGdiCLIPOBJ_bEnum",
	L"NtGdiCLIPOBJ_cEnumStart",
	L"NtGdiCLIPOBJ_ppoGetPath",
	L"NtGdiEngDeletePath",
	L"NtGdiEngCreateClip",
	L"NtGdiEngDeleteClip",
	L"NtGdiBRUSHOBJ_ulGetBrushColor",
	L"NtGdiBRUSHOBJ_pvAllocRbrush",
	L"NtGdiBRUSHOBJ_pvGetRbrush",
	L"NtGdiBRUSHOBJ_hGetColorTransform",
	L"NtGdiXFORMOBJ_bApplyXform",
	L"NtGdiXFORMOBJ_iGetXform",
	L"NtGdiFONTOBJ_vGetInfo",
	L"NtGdiFONTOBJ_pxoGetXform",
	L"NtGdiFONTOBJ_cGetGlyphs",
	L"NtGdiFONTOBJ_pifi",
	L"NtGdiFONTOBJ_pfdg",
	L"NtGdiFONTOBJ_pQueryGlyphAttrs",
	L"NtGdiFONTOBJ_pvTrueTypeFontFile",
	L"NtGdiFONTOBJ_cGetAllGlyphHandles",
	L"NtGdiSTROBJ_bEnum",
	L"NtGdiSTROBJ_bEnumPositionsOnly",
	L"NtGdiSTROBJ_bGetAdvanceWidths",
	L"NtGdiSTROBJ_vEnumStart",
	L"NtGdiSTROBJ_dwGetCodePage",
	L"NtGdiPATHOBJ_vGetBounds",
	L"NtGdiPATHOBJ_bEnum",
	L"NtGdiPATHOBJ_vEnumStart",
	L"NtGdiPATHOBJ_vEnumStartClipLines",
	L"NtGdiPATHOBJ_bEnumClipLines",
	L"NtGdiGetDhpdev",
	L"NtGdiEngCheckAbort",
	L"NtGdiHT_Get8BPPFormatPalette",
	L"NtGdiHT_Get8BPPMaskPalette",
	L"NtGdiUpdateTransform",
	L"NtGdiSetPUMPDOBJ",
	L"NtGdiBRUSHOBJ_DeleteRbrush",
	L"NtGdiUnmapMemFont",
	L"NtGdiDrawStream",
	L"NtGdiSfmGetNotificationTokens",
	L"NtGdiHLSurfGetInformation",
	L"NtGdiHLSurfSetInformation",
	L"NtGdiDdDDICreateAllocation",
	L"NtGdiDdDDIQueryResourceInfo",
	L"NtGdiDdDDIOpenResource",
	L"NtGdiDdDDIDestroyAllocation",
	L"NtGdiDdDDISetAllocationPriority",
	L"NtGdiDdDDIQueryAllocationResidency",
	L"NtGdiDdDDICreateDevice",
	L"NtGdiDdDDIDestroyDevice",
	L"NtGdiDdDDICreateContext",
	L"NtGdiDdDDIDestroyContext",
	L"NtGdiDdDDICreateSynchronizationObject",
	L"NtGdiDdDDIOpenSynchronizationObject",
	L"NtGdiDdDDIDestroySynchronizationObject",
	L"NtGdiDdDDIWaitForSynchronizationObject",
	L"NtGdiDdDDISignalSynchronizationObject",
	L"NtGdiDdDDIGetRuntimeData",
	L"NtGdiDdDDIQueryAdapterInfo",
	L"NtGdiDdDDILock",
	L"NtGdiDdDDIUnlock",
	L"NtGdiDdDDIGetDisplayModeList",
	L"NtGdiDdDDISetDisplayMode",
	L"NtGdiDdDDIGetMultisampleMethodList",
	L"NtGdiDdDDIPresent",
	L"NtGdiDdDDIRender",
	L"NtGdiDdDDIOpenAdapterFromDeviceName",
	L"NtGdiDdDDIOpenAdapterFromHdc",
	L"NtGdiDdDDICloseAdapter",
	L"NtGdiDdDDIGetSharedPrimaryHandle",
	L"NtGdiDdDDIEscape",
	L"NtGdiDdDDIQueryStatistics",
	L"NtGdiDdDDISetVidPnSourceOwner",
	L"NtGdiDdDDIGetPresentHistory",
	L"NtGdiDdDDIGetPresentQueueEvent",
	L"NtGdiDdDDICreateOverlay",
	L"NtGdiDdDDIUpdateOverlay",
	L"NtGdiDdDDIFlipOverlay",
	L"NtGdiDdDDIDestroyOverlay",
	L"NtGdiDdDDIWaitForVerticalBlankEvent",
	L"NtGdiDdDDISetGammaRamp",
	L"NtGdiDdDDIGetDeviceState",
	L"NtGdiDdDDICreateDCFromMemory",
	L"NtGdiDdDDIDestroyDCFromMemory",
	L"NtGdiDdDDISetContextSchedulingPriority",
	L"NtGdiDdDDIGetContextSchedulingPriority",
	L"NtGdiDdDDISetProcessSchedulingPriorityClass",
	L"NtGdiDdDDIGetProcessSchedulingPriorityClass",
	L"NtGdiDdDDIReleaseProcessVidPnSourceOwners",
	L"NtGdiDdDDIGetScanLine",
	L"NtGdiDdDDISetQueuedLimit",
	L"NtGdiDdDDIPollDisplayChildren",
	L"NtGdiDdDDIInvalidateActiveVidPn",
	L"NtGdiDdDDICheckOcclusion",
	L"NtGdiDdDDIWaitForIdle",
	L"NtGdiDdDDICheckMonitorPowerState",
	L"NtGdiDdDDICheckExclusiveOwnership",
	L"NtGdiDdDDISetDisplayPrivateDriverFormat",
	L"NtGdiDdDDISharedPrimaryLockNotification",
	L"NtGdiDdDDISharedPrimaryUnLockNotification",
	L"NtGdiDdDDICreateKeyedMutex",
	L"NtGdiDdDDIOpenKeyedMutex",
	L"NtGdiDdDDIDestroyKeyedMutex",
	L"NtGdiDdDDIAcquireKeyedMutex",
	L"NtGdiDdDDIReleaseKeyedMutex",
	L"NtGdiDdDDIConfigureSharedResource",
	L"NtGdiDdDDIGetOverlayState",
	L"NtGdiDdDDICheckVidPnExclusiveOwnership",
	L"NtGdiDdDDICheckSharedResourceAccess",
	L"DxgStubEnableDirectDrawRedirection",
	L"DxgStubDeleteDirectDrawObject",
	L"NtGdiGetNumberOfPhysicalMonitors",
	L"NtGdiGetPhysicalMonitors",
	L"NtGdiGetPhysicalMonitorDescription",
	L"DestroyPhysicalMonitor",
	L"NtGdiDDCCIGetVCPFeature",
	L"NtGdiDDCCISetVCPFeature",
	L"NtGdiDDCCISaveCurrentSettings",
	L"NtGdiDDCCIGetCapabilitiesStringLength",
	L"NtGdiDDCCIGetCapabilitiesString",
	L"NtGdiDDCCIGetTimingReport",
	L"NtGdiDdCreateFullscreenSprite",
	L"NtGdiDdNotifyFullscreenSpriteUpdate",
	L"NtGdiDdDestroyFullscreenSprite",
	L"NtGdiDdQueryVisRgnUniqueness",
	L"NtUserSetMirrorRendering",
	L"NtUserShowSystemCursor",
	L"NtUserMagControl",
	L"NtUserMagSetContextInformation",
	L"NtUserMagGetContextInformation",
	L"NtUserHwndQueryRedirectionInfo",
	L"NtUserHwndSetRedirectionInfo"
};

WCHAR *Win8Shadow[] = {
	L"NtUserYieldTask",
	L"NtGdiWidenPath",
	L"NtGdiUpdateColors",
	L"NtGdiUnrealizeObject",
	L"NtGdiUnmapMemFont",
	L"NtGdiUnloadPrinterDriver",
	L"NtGdiTransparentBlt",
	L"NtGdiTransformPoints",
	L"NtGdiSwapBuffers",
	L"NtGdiStrokePath",
	L"NtGdiStrokeAndFillPath",
	L"NtGdiStretchDIBitsInternal",
	L"NtGdiStretchBlt",
	L"NtGdiStartPage",
	L"NtGdiStartDoc",
	L"NtGdiSetSizeDevice",
	L"NtGdiSetVirtualResolution",
	L"NtGdiSetTextJustification",
	L"NtGdiSetSystemPaletteUse",
	L"NtGdiSetRectRgn",
	L"NtGdiSetPixelFormat",
	L"NtGdiSetPixel",
	L"NtGdiSetOPMSigningKeyAndSequenceNumbers",
	L"NtGdiSetLayout",
	L"NtGdiMirrorWindowOrg",
	L"NtGdiGetDeviceWidth",
	L"NtGdiSetMiterLimit",
	L"NtGdiSetMetaRgn",
	L"NtGdiSetMagicColors",
	L"NtGdiSetLinkedUFIs",
	L"NtGdiSetIcmMode",
	L"NtGdiSetFontXform",
	L"NtGdiSetFontEnumeration",
	L"NtGdiSetDIBitsToDeviceInternal",
	L"NtGdiSetDeviceGammaRamp",
	L"NtGdiSetColorSpace",
	L"NtGdiSetColorAdjustment",
	L"NtGdiSetBrushOrg",
	L"NtGdiSetBrushAttributes",
	L"NtGdiSetBoundsRect",
	L"NtGdiSetBitmapDimension",
	L"NtGdiSetBitmapBits",
	L"NtGdiSetBitmapAttributes",
	L"NtGdiSelectPen",
	L"NtGdiSelectFont",
	L"NtGdiSelectClipPath",
	L"NtGdiSelectBrush",
	L"NtGdiSelectBitmap",
	L"NtGdiScaleWindowExtEx",
	L"NtGdiScaleViewportExtEx",
	L"NtGdiSaveDC",
	L"NtGdiRoundRect",
	L"NtGdiRestoreDC",
	L"NtGdiResizePalette",
	L"NtGdiResetDC",
	L"NtGdiRemoveFontMemResourceEx",
	L"NtGdiRemoveFontResourceW",
	L"NtGdiRectVisible",
	L"NtGdiRectInRegion",
	L"NtGdiRectangle",
	L"NtGdiQueryFontAssocInfo",
	L"NtGdiQueryFonts",
	L"NtGdiPtVisible",
	L"NtGdiPtInRegion",
	L"NtGdiPolyTextOutW",
	L"NtGdiPolyPolyDraw",
	L"NtGdiPolyDraw",
	L"NtGdiPlgBlt",
	L"NtGdiPathToRegion",
	L"NtGdiPolyPatBlt",
	L"NtGdiPatBlt",
	L"NtGdiOpenDCW",
	L"NtGdiOffsetRgn",
	L"NtGdiOffsetClipRgn",
	L"NtGdiMoveTo",
	L"NtGdiMonoBitmap",
	L"NtGdiModifyWorldTransform",
	L"NtGdiMaskBlt",
	L"NtGdiMakeInfoDC",
	L"NtGdiMakeFontDir",
	L"NtGdiLineTo",
	L"NtGdiInvertRgn",
	L"NtGdiIntersectClipRect",
	L"NtGdiInitSpool",
	L"NtGdiInit",
	L"NtGdiIcmBrushInfo",
	L"NtGdiHfontCreate",
	L"NtGdiGradientFill",
	L"NtGdiGetWidthTable",
	L"NtGdiGetFontUnicodeRanges",
	L"NtGdiAddEmbFontToDC",
	L"NtGdiChangeGhostFont",
	L"NtGdiGetEmbedFonts",
	L"NtGdiGetUFIPathname",
	L"NtGdiGetEmbUFI",
	L"NtGdiGetUFI",
	L"NtGdiGetTransform",
	L"NtGdiGetTextMetricsW",
	L"NtGdiGetTextFaceW",
	L"NtGdiGetTextExtentExW",
	L"NtGdiGetTextExtent",
	L"NtGdiGetTextCharsetInfo",
	L"NtGdiGetSystemPaletteUse",
	L"NtGdiGetSuggestedOPMProtectedOutputArraySize",
	L"NtGdiGetStringBitmapW",
	L"NtGdiGetStockObject",
	L"NtGdiGetStats",
	L"NtGdiGetSpoolMessage",
	L"NtGdiGetServerMetaFileBits",
	L"NtGdiGetRgnBox",
	L"NtGdiGetRegionData",
	L"NtGdiGetRealizationInfo",
	L"NtGdiGetRasterizerCaps",
	L"NtGdiGetRandomRgn",
	L"NtGdiGetPixel",
	L"NtGdiGetPath",
	L"NtGdiGetOutlineTextMetricsInternalW",
	L"NtGdiGetOPMRandomNumber",
	L"NtGdiGetObjectBitmapHandle",
	L"NtGdiGetNearestPaletteIndex",
	L"NtGdiGetNearestColor",
	L"NtGdiGetMonitorID",
	L"NtGdiGetMiterLimit",
	L"NtGdiGetLinkedUFIs",
	L"NtGdiGetKerningPairs",
	L"NtGdiGetOPMInformation",
	L"NtGdiGetGlyphOutline",
	L"NtGdiGetGlyphIndicesWInternal",
	L"NtGdiGetGlyphIndicesW",
	L"NtGdiGetFontResourceInfoInternalW",
	L"NtGdiGetFontFileInfo",
	L"NtGdiGetFontFileData",
	L"NtGdiGetFontData",
	L"NtGdiGetEudcTimeStampEx",
	L"NtGdiGetETM",
	L"NtGdiGetDIBitsInternal",
	L"NtGdiGetDeviceCapsAll",
	L"NtGdiGetDeviceGammaRamp",
	L"NtGdiGetDeviceCaps",
	L"NtGdiGetDCPoint",
	L"NtGdiGetDCObject",
	L"NtGdiGetDCforBitmap",
	L"NtGdiGetDCDword",
	L"NtGdiGetCOPPCompatibleOPMInformation",
	L"NtGdiGetColorSpaceforBitmap",
	L"NtGdiGetColorAdjustment",
	L"NtGdiGetCharWidthInfo",
	L"NtGdiGetCharWidthW",
	L"NtGdiGetCharSet",
	L"NtGdiGetCharacterPlacementW",
	L"NtGdiGetCharABCWidthsW",
	L"NtGdiGetCertificateSize",
	L"NtGdiGetCertificate",
	L"NtGdiGetBoundsRect",
	L"NtGdiGetBitmapDimension",
	L"NtGdiGetBitmapBits",
	L"NtGdiGetAppClipBox",
	L"NtGdiGetAndSetDCDword",
	L"NtGdiFullscreenControl",
	L"NtGdiFrameRgn",
	L"NtGdiForceUFIMapping",
	L"NtGdiFlush",
	L"NtGdiFlattenPath",
	L"NtGdiFillRgn",
	L"NtGdiFillPath",
	L"NtGdiExtTextOutW",
	L"NtGdiExtSelectClipRgn",
	L"NtGdiExtGetObjectW",
	L"NtGdiExtFloodFill",
	L"NtGdiExtEscape",
	L"NtGdiExtCreateRegion",
	L"NtGdiExtCreatePen",
	L"NtGdiExcludeClipRect",
	L"NtGdiEudcLoadUnloadLink",
	L"NtGdiEqualRgn",
	L"NtGdiEnumObjects",
	L"NtGdiEnumFonts",
	L"NtGdiEndPath",
	L"NtGdiEndPage",
	L"NtGdiEndGdiRendering",
	L"NtGdiEndDoc",
	L"NtGdiEnableEudc",
	L"NtGdiEllipse",
	L"NtGdiDrawEscape",
	L"NtGdiDoPalette",
	L"NtGdiDoBanding",
	L"NtGdiGetPerBandInfo",
	L"NtGdiDestroyOPMProtectedOutput",
	L"NtGdiDescribePixelFormat",
	L"NtGdiDeleteObjectApp",
	L"NtGdiDeleteColorTransform",
	L"NtGdiDeleteColorSpace",
	L"NtGdiDeleteClientObj",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdUnattachSurface",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiD3dContextDestroy",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdQueryDirectDrawObject",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdFlip",
	L"NtGdiDdCreateMoComp",
	L"NtGdiD3dContextDestroy",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroy",
	L"NtGdiDdCreateSurfaceObject",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateSurface",
	L"NtGdiDdCreateSurface",
	L"NtGdiD3dContextDestroy",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdCreateMoComp",
	L"NtGdiDdAlphaBlt",
	L"NtGdiDdAlphaBlt",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dDrawPrimitives2",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroy",
	L"NtGdiD3dContextDestroy",
	L"NtGdiDvpUpdateVideoPort",
	L"NtGdiCreateSolidBrush",
	L"NtGdiCreateServerMetaFile",
	L"NtGdiCreateRoundRectRgn",
	L"NtGdiCreateRectRgn",
	L"NtGdiCreatePen",
	L"NtGdiCreatePatternBrushInternal",
	L"NtGdiCreatePaletteInternal",
	L"NtGdiCreateOPMProtectedOutputs",
	L"NtGdiCreateMetafileDC",
	L"NtGdiCreateHatchBrushInternal",
	L"NtGdiCreateHalftonePalette",
	L"NtGdiCreateEllipticRgn",
	L"NtGdiCreateSessionMappedDIBSection",
	L"NtGdiCreateDIBSection",
	L"NtGdiCreateDIBitmapInternal",
	L"NtGdiCreateDIBBrush",
	L"NtGdiCreateCompatibleDC",
	L"NtGdiCreateCompatibleBitmap",
	L"NtGdiCreateColorTransform",
	L"NtGdiCreateColorSpace",
	L"NtGdiCreateClientObj",
	L"NtGdiCreateBitmapFromDxSurface2",
	L"NtGdiCreateBitmapFromDxSurface",
	L"NtGdiCreateBitmap",
	L"NtGdiConvertMetafileRect",
	L"NtGdiConfigureOPMProtectedOutput",
	L"NtGdiComputeXformCoefficients",
	L"NtGdiCombineTransform",
	L"NtGdiCombineRgn",
	L"NtGdiColorCorrectPalette",
	L"NtGdiClearBrushAttributes",
	L"NtGdiClearBitmapAttributes",
	L"NtGdiCloseFigure",
	L"NtGdiCheckBitmapBits",
	L"NtGdiCancelDC",
	L"NtGdiBitBlt",
	L"NtGdiBeginPath",
	L"NtGdiBeginGdiRendering",
	L"NtGdiArcInternal",
	L"NtGdiFontIsLinked",
	L"NtGdiAnyLinkedFonts",
	L"NtGdiAngleArc",
	L"NtGdiAlphaBlend",
	L"NtGdiAddRemoteMMInstanceToDC",
	L"NtGdiRemoveMergeFont",
	L"NtGdiAddFontMemResourceEx",
	L"NtGdiAddRemoteFontToDC",
	L"NtGdiAddFontResourceW",
	L"NtGdiAbortPath",
	L"NtGdiAbortDoc",
	L"NtUserDefSetText",
	L"NtUserDeferWindowPosAndBand",
	L"NtUserDdeInitialize",
	L"NtUserCanBrokerForceForeground",
	L"NtUserCreateWindowStation",
	L"NtUserCreateWindowEx",
	L"NtUserCreateLocalMemHandle",
	L"NtUserCreateInputContext",
	L"NtUserCreateDesktopEx",
	L"NtUserCreateCaret",
	L"NtUserCreateAcceleratorTable",
	L"NtUserCountClipboardFormats",
	L"NtUserCopyAcceleratorTable",
	L"NtUserConvertMemHandle",
	L"NtUserConsoleControl",
	L"NtUserCloseWindowStation",
	L"NtUserCloseDesktop",
	L"NtUserCloseClipboard",
	L"NtUserClipCursor",
	L"NtUserChildWindowFromPointEx",
	L"NtUserCheckMenuItem",
	L"NtUserCheckWindowThreadDesktop",
	L"NtUserDwmValidateWindow",
	L"NtUserCheckAccessForIntegrityLevel",
	L"NtUserDisplayConfigSetDeviceInfo",
	L"NtUserDisplayConfigGetDeviceInfo",
	L"NtUserQueryDisplayConfig",
	L"NtUserSetDisplayConfig",
	L"NtUserGetDisplayConfigBufferSizes",
	L"NtUserChangeDisplaySettings",
	L"NtUserChangeClipboardChain",
	L"NtUserCallTwoParam",
	L"NtUserCallOneParam",
	L"NtUserCallNoParam",
	L"NtUserCallNextHookEx",
	L"NtUserCallMsgFilter",
	L"NtUserCallHwndParamLock",
	L"NtUserCallHwndParam",
	L"NtUserCallHwndOpt",
	L"NtUserCallHwndLock",
	L"NtUserCallHwnd",
	L"NtUserBuildPropList",
	L"NtUserBuildNameList",
	L"NtUserBuildHwndList",
	L"NtUserBuildHimcList",
	L"NtUserBlockInput",
	L"NtUserBitBltSysBmp",
	L"NtUserBeginPaint",
	L"NtUserAttachThreadInput",
	L"NtUserAssociateInputContext",
	L"NtUserAlterWindowStyle",
	L"NtUserAddClipboardFormatListener",
	L"NtUserActivateKeyboardLayout",
	L"NtUserDelegateCapturePointers",
	L"NtUserDelegateInput",
	L"NtUserDispatchMessage",
	L"NtUserDisableProcessWindowFiltering",
	L"NtUserDisableThreadIme",
	L"NtUserDestroyWindow",
	L"NtUserDestroyMenu",
	L"NtUserDestroyInputContext",
	L"NtUserDestroyCursor",
	L"NtUserDestroyAcceleratorTable",
	L"NtUserDeleteMenu",
	L"NtUserDoSoundDisconnect",
	L"NtUserDoSoundConnect",
	L"NtUserGhostWindowFromHungWindow",
	L"NtUserGetWOWClass",
	L"NtUserGetWindowPlacement",
	L"NtUserGetWindowDisplayAffinity",
	L"NtUserGetWindowDC",
	L"NtUserGetWindowCompositionAttribute",
	L"NtUserGetWindowCompositionInfo",
	L"NtUserGetWindowBand",
	L"NtUserGetUpdateRgn",
	L"NtUserGetUpdateRect",
	L"NtUserGetUpdatedClipboardFormats",
	L"NtUserGetTopLevelWindow",
	L"NtUserGetTitleBarInfo",
	L"NtUserGetThreadState",
	L"NtUserGetThreadDesktop",
	L"NtUserGetSystemMenu",
	L"NtUserGetScrollBarInfo",
	L"NtUserGetRegisteredRawInputDevices",
	L"NtUserGetRawInputDeviceList",
	L"NtUserGetRawInputDeviceInfo",
	L"NtUserGetRawInputData",
	L"NtUserGetRawInputBuffer",
	L"NtUserGetProcessWindowStation",
	L"NtUserGetPriorityClipboardFormat",
	L"NtUserGetOpenClipboardWindow",
	L"NtUserGetObjectInformation",
	L"NtUserGetMouseMovePointsEx",
	L"NtUserGetMessage",
	L"NtUserGetMenuItemRect",
	L"NtUserGetMenuIndex",
	L"NtUserGetMenuBarInfo",
	L"NtUserGetListBoxInfo",
	L"NtUserGetKeyState",
	L"NtUserGetKeyNameText",
	L"NtUserGetKeyboardState",
	L"NtUserGetKeyboardLayoutName",
	L"NtUserGetKeyboardLayoutList",
	L"NtUserGetInternalWindowPos",
	L"NtUserGetInputLocaleInfo",
	L"NtUserGetImeInfoEx",
	L"NtUserGetImeHotKey",
	L"NtUserGetIconSize",
	L"NtUserGetIconInfo",
	L"NtUserGetGUIThreadInfo",
	L"NtUserGetGuiResources",
	L"NtUserGetGlobalIMEStatus",
	L"NtUserGetForegroundWindow",
	L"NtUserGetDoubleClickTime",
	L"NtUserGetDesktopID",
	L"NtUserGetDCEx",
	L"NtUserGetDC",
	L"NtUserGetCursorInfo",
	L"NtUserGetCursorFrameInfo",
	L"NtUserGetCurrentInputMessageSource",
	L"NtUserGetCIMSSM",
	L"NtUserGetCPD",
	L"NtUserGetControlColor",
	L"NtUserGetControlBrush",
	L"NtUserGetComboBoxInfo",
	L"NtUserGetClipCursor",
	L"NtUserGetClipboardViewer",
	L"NtUserGetClipboardSequenceNumber",
	L"NtUserGetClipboardOwner",
	L"NtUserGetClipboardFormatName",
	L"NtUserGetClipboardData",
	L"NtUserGetClassName",
	L"NtUserGetClassInfoEx",
	L"NtUserGetCaretPos",
	L"NtUserGetCaretBlinkTime",
	L"NtUserGetAtomName",
	L"NtUserGetAsyncKeyState",
	L"NtUserGetAppImeLevel",
	L"NtUserGetAncestor",
	L"NtUserGetAltTabInfo",
	L"NtUserFrostCrashedWindow",
	L"NtUserFlashWindowEx",
	L"NtUserFindWindowEx",
	L"NtUserFindExistingCursorIcon",
	L"NtUserFillWindow",
	L"NtUserExcludeUpdateRgn",
	L"NtUserEvent",
	L"NtUserEnumDisplaySettings",
	L"NtUserEnumDisplayMonitors",
	L"NtUserEnumDisplayDevices",
	L"NtUserEndPaint",
	L"NtUserEndMenu",
	L"NtUserEndDeferWindowPosEx",
	L"NtUserEnableScrollBar",
	L"NtUserEnableMenuItem",
	L"NtUserEmptyClipboard",
	L"NtUserDrawMenuBarTemp",
	L"NtUserDrawIconEx",
	L"NtUserDrawCaptionTemp",
	L"NtUserDrawCaption",
	L"NtUserDrawAnimatedRects",
	L"NtUserDragObject",
	L"NtUserDragDetect",
	L"NtUserHandleDelegatedInput",
	L"NtUserRealChildWindowFromPoint",
	L"NtUserQueryWindow",
	L"NtUserQuerySendMessage",
	L"NtUserQueryInputContext",
	L"NtUserQueryInformationThread",
	L"NtUserQueryBSDRWindow",
	L"NtUserProcessConnect",
	L"NtUserPrintWindow",
	L"NtUserPostThreadMessage",
	L"NtUserPostMessage",
	L"NtUserPhysicalToLogicalPoint",
	L"NtUserPeekMessage",
	L"NtUserPaintMonitor",
	L"NtUserPaintDesktop",
	L"NtUserOpenWindowStation",
	L"NtUserOpenThreadDesktop",
	L"NtUserOpenInputDesktop",
	L"NtUserOpenDesktop",
	L"NtUserOpenClipboard",
	L"NtUserNotifyWinEvent",
	L"NtUserNotifyProcessCreate",
	L"NtUserNotifyIMEStatus",
	L"NtUserMoveWindow",
	L"NtUserModifyUserStartupInfoFlags",
	L"NtUserMNDragOver",
	L"NtUserMNDragLeave",
	L"NtUserMinMaximize",
	L"NtUserMessageCall",
	L"NtUserMenuItemFromPoint",
	L"NtUserMapVirtualKeyEx",
	L"NtUserLayoutCompleted",
	L"NtUserLogicalToPhysicalPoint",
	L"NtUserLockWorkStation",
	L"NtUserLockWindowUpdate",
	L"NtUserLockWindowStation",
	L"NtUserLoadKeyboardLayoutEx",
	L"NtUserKillTimer",
	L"NtUserIsTopLevelWindow",
	L"NtUserIsClipboardFormatAvailable",
	L"NtUserInvalidateRgn",
	L"NtUserInvalidateRect",
	L"NtUserInternalGetWindowIcon",
	L"NtUserInternalGetWindowText",
	L"NtUserInitTask",
	L"NtUserInitializeClientPfnArrays",
	L"NtUserInitialize",
	L"NtUserImpersonateDdeClientWindow",
	L"NtUserHungWindowFromGhostWindow",
	L"NtUserHiliteMenuItem",
	L"NtUserHideCaret",
	L"NtUserHardErrorControl",
	L"NtUserRealInternalGetMessage",
	L"NtUserRealWaitMessageEx",
	L"NtUserTranslateMessage",
	L"NtUserTranslateAccelerator",
	L"NtUserPaintMenuBar",
	L"NtUserCalcMenuBar",
	L"NtUserCalculatePopupWindowPosition",
	L"NtUserTrackPopupMenuEx",
	L"NtUserTrackMouseEvent",
	L"NtUserToUnicodeEx",
	L"NtUserThunkedMenuItemInfo",
	L"NtUserThunkedMenuInfo",
	L"NtUserTestForInteractiveUser",
	L"NtUserSendEventMessage",
	L"NtUserSystemParametersInfo",
	L"NtUserSwitchDesktop",
	L"NtUserSoundSentry",
	L"NtUserShutdownReasonDestroy",
	L"NtUserShutdownBlockReasonQuery",
	L"NtUserShutdownBlockReasonCreate",
	L"NtUserShowWindowAsync",
	L"NtUserShowWindow",
	L"NtUserShowScrollBar",
	L"NtUserShowCaret",
	L"NtUserSetWinEventHook",
	L"NtUserSetWindowWord",
	L"NtUserSetWindowStationUser",
	L"NtUserSetWindowsHookEx",
	L"NtUserSetWindowsHookAW",
	L"NtUserSetWindowRgnEx",
	L"NtUserGetWindowRgnEx",
	L"NtUserSetWindowRgn",
	L"NtUserSetWindowPos",
	L"NtUserSetWindowPlacement",
	L"NtUserSetWindowLong",
	L"NtUserSetWindowFNID",
	L"NtUserSetWindowDisplayAffinity",
	L"NtUserSetWindowCompositionTransition",
	L"NtUserUpdateDefaultDesktopThumbnail",
	L"NtUserSetWindowCompositionAttribute",
	L"NtUserSetWindowBand",
	L"NtUserSetProcessUIAccessZorder",
	L"NtUserSetProcessDPIAware",
	L"NtUserSetTimer",
	L"NtUserSetThreadState",
	L"NtUserSetThreadLayoutHandles",
	L"NtUserSetThreadDesktop",
	L"NtUserSetThreadInputBlocked",
	L"NtUserSetSystemTimer",
	L"NtUserSetSystemMenu",
	L"NtUserSetSystemCursor",
	L"NtUserSetSysColors",
	L"NtUserSetShellWindowEx",
	L"NtUserSetImmersiveBackgroundWindow",
	L"NtUserSetScrollInfo",
	L"NtUserSetProp",
	L"NtUserGetProp",
	L"NtUserSetProcessWindowStation",
	L"NtUserSetParent",
	L"NtUserSetObjectInformation",
	L"NtUserSetMenuFlagRtoL",
	L"NtUserSetMenuDefaultItem",
	L"NtUserSetMenuContextHelpId",
	L"NtUserSetMenu",
	L"NtUserSetKeyboardState",
	L"NtUserSetInternalWindowPos",
	L"NtUserSetInformationThread",
	L"NtUserSetImeOwnerWindow",
	L"NtUserSetImeInfoEx",
	L"NtUserSetImeHotKey",
	L"NtUserSetFocus",
	L"NtUserSetCursorIconData",
	L"NtUserSetCursorContents",
	L"NtUserSetCursor",
	L"NtUserSetClipboardViewer",
	L"NtUserSetClipboardData",
	L"NtUserSetClassWord",
	L"NtUserSetClassLong",
	L"NtUserSetChildWindowNoActivate",
	L"NtUserSetCapture",
	L"NtUserSetAppImeLevel",
	L"NtUserSetActiveWindow",
	L"NtUserSendInput",
	L"NtUserSelectPalette",
	L"NtUserScrollWindowEx",
	L"NtUserScrollDC",
	L"NtUserSBGetParms",
	L"NtUserResolveDesktopForWOW",
	L"NtUserRemoveProp",
	L"NtUserRemoveMenu",
	L"NtUserRemoveClipboardFormatListener",
	L"NtUserRegisterWindowMessage",
	L"NtUserRegisterTasklist",
	L"NtUserRegisterServicesProcess",
	L"NtUserRegisterRawInputDevices",
	L"NtUserRegisterHotKey",
	L"NtUserRegisterUserApiHook",
	L"NtUserRegisterErrorReportingDialog",
	L"NtUserRegisterClassExWOW",
	L"NtUserRegisterBSDRWindow",
	L"NtUserRedrawWindow",
	L"NtUserUndelegateInput",
	L"NtUserGetWindowMinimizeRect",
	L"NtUserDwmStopRedirection",
	L"NtUserDwmStartRedirection",
	L"NtUserDwmGetRemoteSessionOcclusionEvent",
	L"NtUserDwmGetRemoteSessionOcclusionState",
	L"NtUserUpdateWindowTransform",
	L"NtUserCheckProcessSession",
	L"NtUserUnregisterSessionPort",
	L"NtUserRegisterSessionPort",
	L"NtUserCtxDisplayIOCtl",
	L"NtUserRemoteStopScreenUpdates",
	L"NtUserRemoteRedrawScreen",
	L"NtUserRemoteRedrawRectangle",
	L"NtUserRemoteConnect",
	L"NtUserWaitAvailableMessageEx",
	L"NtUserWindowFromPoint",
	L"NtUserWindowFromPhysicalPoint",
	L"NtUserWaitMessage",
	L"NtUserWaitForMsgAndEvent",
	L"NtUserWaitForInputIdle",
	L"NtUserVkKeyScanEx",
	L"NtUserValidateTimerCallback",
	L"NtUserValidateRect",
	L"NtUserValidateHandleSecure",
	L"NtUserUserHandleGrantAccess",
	L"NtUserUpdatePerUserSystemParameters",
	L"NtUserSetLayeredWindowAttributes",
	L"NtUserGetLayeredWindowAttributes",
	L"NtUserUpdateLayeredWindow",
	L"NtUserUpdateInstance",
	L"NtUserUpdateInputContext",
	L"NtUserUnregisterHotKey",
	L"NtUserUnregisterUserApiHook",
	L"NtUserUnregisterClass",
	L"NtUserUnlockWindowStation",
	L"NtUserUnloadKeyboardLayout",
	L"NtUserUnhookWinEvent",
	L"NtUserUnhookWindowsHookEx",
	L"NtUserGetTouchInputInfo",
	L"NtUserIsTouchWindow",
	L"NtUserModifyWindowTouchCapability",
	L"NtGdiEngStretchBltROP",
	L"NtGdiEngTextOut",
	L"NtGdiEngTransparentBlt",
	L"NtGdiEngGradientFill",
	L"NtGdiEngAlphaBlend",
	L"NtGdiEngLineTo",
	L"NtGdiEngPaint",
	L"NtGdiEngStrokeAndFillPath",
	L"NtGdiEngFillPath",
	L"NtGdiEngStrokePath",
	L"NtGdiEngMarkBandingSurface",
	L"NtGdiEngPlgBlt",
	L"NtGdiEngStretchBlt",
	L"NtGdiEngBitBlt",
	L"NtGdiEngLockSurface",
	L"NtGdiEngUnlockSurface",
	L"NtGdiEngEraseSurface",
	L"NtGdiEngDeleteSurface",
	L"NtGdiEngDeletePalette",
	L"NtGdiEngCopyBits",
	L"NtGdiEngComputeGlyphSet",
	L"NtGdiEngCreatePalette",
	L"NtGdiEngCreateDeviceBitmap",
	L"NtGdiEngCreateDeviceSurface",
	L"NtGdiEngCreateBitmap",
	L"NtGdiEngAssociateSurface",
	L"NtUserSetWindowFeedbackSetting",
	L"NtUserRegisterEdgy",
	L"NtUserGetWindowFeedbackSetting",
	L"NtUserHidePointerContactVisualization",
	L"NtUserGetTouchValidationStatus",
	L"NtUserInitializeTouchInjection",
	L"NtUserInjectTouchInput",
	L"NtUserRegisterTouchHitTestingWindow",
	L"NtUserSetDisplayMapping",
	L"NtUserSetCalibrationData",
	L"NtUserGetRawPointerDeviceData",
	L"NtUserGetPointerDeviceCursors",
	L"NtUserGetPointerDeviceRects",
	L"NtUserRegisterPointerDeviceNotifications",
	L"NtUserGetPointerDeviceProperties",
	L"NtUserGetPointerDevice",
	L"NtUserGetPointerDevices",
	L"NtUserPromotePointer",
	L"NtUserDiscardPointerFrameMessages",
	L"NtUserRegisterPointerInputTarget",
	L"NtUserGetPointerInfoList",
	L"NtUserGetPointerCursorId",
	L"NtUserGetPointerType",
	L"NtUserGetGestureConfig",
	L"NtUserSetGestureConfig",
	L"NtUserGetGestureExtArgs",
	L"NtUserGetGestureInfo",
	L"NtUserInjectGesture",
	L"NtUserChangeWindowMessageFilterEx",
	L"NtGdiXLATEOBJ_hGetColorTransform",
	L"NtGdiXLATEOBJ_iXlate",
	L"NtGdiXLATEOBJ_cGetPalette",
	L"NtGdiEngDeleteClip",
	L"NtGdiEngCreateClip",
	L"NtGdiEngDeletePath",
	L"NtGdiCLIPOBJ_ppoGetPath",
	L"NtGdiCLIPOBJ_cEnumStart",
	L"NtGdiCLIPOBJ_bEnum",
	L"NtGdiBRUSHOBJ_hGetColorTransform",
	L"NtGdiBRUSHOBJ_pvGetRbrush",
	L"NtGdiBRUSHOBJ_pvAllocRbrush",
	L"NtGdiBRUSHOBJ_ulGetBrushColor",
	L"NtGdiXFORMOBJ_iGetXform",
	L"NtGdiXFORMOBJ_bApplyXform",
	L"NtGdiFONTOBJ_pQueryGlyphAttrs",
	L"NtGdiFONTOBJ_pfdg",
	L"NtGdiFONTOBJ_pifi",
	L"NtGdiFONTOBJ_cGetGlyphs",
	L"NtGdiFONTOBJ_pxoGetXform",
	L"NtGdiFONTOBJ_vGetInfo",
	L"NtGdiFONTOBJ_cGetAllGlyphHandles",
	L"NtGdiFONTOBJ_pvTrueTypeFontFile",
	L"NtGdiSTROBJ_dwGetCodePage",
	L"NtGdiSTROBJ_vEnumStart",
	L"NtGdiSTROBJ_bGetAdvanceWidths",
	L"NtGdiSTROBJ_bEnumPositionsOnly",
	L"NtGdiSTROBJ_bEnum",
	L"NtGdiPATHOBJ_bEnumClipLines",
	L"NtGdiPATHOBJ_vEnumStartClipLines",
	L"NtGdiPATHOBJ_vEnumStart",
	L"NtGdiPATHOBJ_bEnum",
	L"NtGdiPATHOBJ_vGetBounds",
	L"NtGdiEngCheckAbort",
	L"NtGdiGetDhpdev",
	L"NtGdiHT_Get8BPPMaskPalette",
	L"NtGdiHT_Get8BPPFormatPalette",
	L"NtGdiUpdateTransform",
	L"NtGdiUMPDEngFreeUserMem",
	L"NtGdiBRUSHOBJ_DeleteRbrush",
	L"NtGdiSetPUMPDOBJ",
	L"NtGdiSetUMPDSandboxState",
	L"NtGdiDrawStream",
	L"NtGdiHLSurfSetInformation",
	L"NtGdiHLSurfGetInformation",
	L"NtGdiDwmCreatedBitmapRemotingOutput",
	L"NtGdiDdDDIGetScanLine",
	L"NtGdiDdDDIReleaseProcessVidPnSourceOwners",
	L"NtGdiDdDDIGetProcessSchedulingPriorityClass",
	L"NtGdiDdDDISetProcessSchedulingPriorityClass",
	L"NtGdiDdDDIGetContextSchedulingPriority",
	L"NtGdiDdDDISetContextSchedulingPriority",
	L"NtGdiDdDDIDestroyDCFromMemory",
	L"NtGdiDdDDICreateDCFromMemory",
	L"NtGdiDdDDIGetDeviceState",
	L"NtGdiDdDDISetGammaRamp",
	L"NtGdiDdDDIWaitForVerticalBlankEvent",
	L"NtGdiDdDDIDestroyOverlay",
	L"NtGdiDdDDIFlipOverlay",
	L"NtGdiDdDDIUpdateOverlay",
	L"NtGdiDdDDICreateOverlay",
	L"NtGdiDdDDIGetPresentQueueEvent",
	L"NtGdiDdDDIGetPresentHistory",
	L"NtGdiDdDDISetVidPnSourceOwner1",
	L"NtGdiDdDDISetVidPnSourceOwner",
	L"NtGdiDdDDIQueryStatistics",
	L"NtGdiDdDDIEscape",
	L"NtGdiDdDDIGetSharedPrimaryHandle",
	L"NtGdiDdDDICloseAdapter",
	L"NtGdiDdDDIOpenAdapterFromLuid",
	L"NtGdiDdDDIEnumAdapters",
	L"NtGdiDdDDIOpenAdapterFromHdc",
	L"NtGdiDdDDIOpenAdapterFromDeviceName",
	L"NtGdiDdDDIRender",
	L"NtGdiDdDDIPresent",
	L"NtGdiDdDDIGetMultisampleMethodList",
	L"NtGdiDdDDISetDisplayMode",
	L"NtGdiDdDDIGetDisplayModeList",
	L"NtGdiDdDDIUnlock",
	L"NtGdiDdDDILock",
	L"NtGdiDdDDIQueryAdapterInfo",
	L"NtGdiDdDDIGetRuntimeData",
	L"NtGdiDdDDISignalSynchronizationObject",
	L"NtGdiDdDDIWaitForSynchronizationObject",
	L"NtGdiDdDDIDestroySynchronizationObject",
	L"NtGdiDdDDIOpenSynchronizationObject",
	L"NtGdiDdDDICreateSynchronizationObject",
	L"NtGdiDdDDIDestroyContext",
	L"NtGdiDdDDICreateContext",
	L"NtGdiDdDDIDestroyDevice",
	L"NtGdiDdDDICreateDevice",
	L"NtGdiDdDDIQueryAllocationResidency",
	L"NtGdiDdDDISetAllocationPriority",
	L"NtGdiDdDDIDestroyAllocation",
	L"NtGdiDdDDIOpenResourceFromNtHandle",
	L"NtGdiDdDDIOpenSyncObjectFromNtHandle",
	L"NtGdiDdDDIOpenResource",
	L"NtGdiDdDDIOpenNtHandleFromName",
	L"NtGdiDdDDIShareObjects",
	L"NtGdiDdDDIQueryResourceInfoFromNtHandle",
	L"NtGdiDdDDIQueryResourceInfo",
	L"NtGdiDdDDICreateAllocation",
	L"NtGdiDdDDIOutputDuplReleaseFrame",
	L"NtGdiDdDDIQueryRemoteVidPnSourceFromGdiDisplayName",
	L"NtGdiDdDDIOutputDuplPresent",
	L"NtGdiDdDDIReleaseKeyedMutex2",
	L"NtGdiDdDDIAcquireKeyedMutex2",
	L"NtGdiDdDDIOpenKeyedMutex2",
	L"NtGdiDdDDICreateKeyedMutex2",
	L"NtGdiDdDDIOutputDuplGetPointerShapeData",
	L"NtGdiDdDDIOutputDuplGetMetaData",
	L"NtGdiDdDDIOutputDuplGetFrameInfo",
	L"NtGdiDdDDIDestroyOutputDupl",
	L"NtGdiDdDDICreateOutputDupl",
	L"NtGdiDdDDIReclaimAllocations",
	L"NtGdiDdDDIOfferAllocations",
	L"NtGdiDdDDICheckSharedResourceAccess",
	L"NtGdiDdDDICheckVidPnExclusiveOwnership",
	L"NtGdiDdDDIGetOverlayState",
	L"NtGdiDdDDIConfigureSharedResource",
	L"NtGdiDdDDIReleaseKeyedMutex",
	L"NtGdiDdDDIAcquireKeyedMutex",
	L"NtGdiDdDDIDestroyKeyedMutex",
	L"NtGdiDdDDIOpenKeyedMutex",
	L"NtGdiDdDDICreateKeyedMutex",
	L"NtGdiDdDDISharedPrimaryUnLockNotification",
	L"NtGdiDdDDISharedPrimaryLockNotification",
	L"NtGdiDdDDISetDisplayPrivateDriverFormat",
	L"NtGdiDdDDICheckExclusiveOwnership",
	L"NtGdiDdDDICheckMonitorPowerState",
	L"NtGdiDdDDIWaitForIdle",
	L"NtGdiDdDDICheckOcclusion",
	L"NtGdiDdDDIInvalidateActiveVidPn",
	L"NtGdiDdDDIPollDisplayChildren",
	L"NtGdiDdDDISetQueuedLimit",
	L"NtGdiDdDDIPinDirectFlipResources",
	L"NtGdiDdDDIUnpinDirectFlipResources",
	L"NtGdiDdDDIWaitForVerticalBlankEvent2",
	L"NtGdiDdDDISetContextInProcessSchedulingPriority",
	L"NtGdiDdDDIGetContextInProcessSchedulingPriority",
	L"NtGdiDdDDIGetSharedResourceAdapterLuid",
	L"NtGdiDdDDISetStereoEnabled",
	L"NtGdiMakeObjectUnXferable",
	L"NtGdiMakeObjectXferable",
	L"NtGdiDestroyPhysicalMonitor",
	L"NtGdiGetPhysicalMonitorDescription",
	L"NtGdiGetPhysicalMonitors",
	L"NtGdiGetNumberOfPhysicalMonitors",
	L"NtGdiDDCCIGetTimingReport",
	L"NtGdiDDCCIGetCapabilitiesString",
	L"NtGdiDDCCIGetCapabilitiesStringLength",
	L"NtGdiDDCCISaveCurrentSettings",
	L"NtGdiDDCCISetVCPFeature",
	L"NtGdiDDCCIGetVCPFeature",
	L"NtGdiDdQueryVisRgnUniqueness",
	L"NtGdiDdDestroyFullscreenSprite",
	L"NtGdiDdNotifyFullscreenSpriteUpdate",
	L"NtGdiDdCreateFullscreenSprite",
	L"NtUserShowSystemCursor",
	L"NtUserSetMirrorRendering",
	L"NtUserMagGetContextInformation",
	L"NtUserMagSetContextInformation",
	L"NtUserMagControl",
	L"NtUserSlicerControl",
	L"NtUserHwndSetRedirectionInfo",
	L"NtUserHwndQueryRedirectionInfo",
	L"NtCreateCompositionSurfaceHandle",
	L"NtValidateCompositionSurfaceHandle",
	L"NtBindCompositionSurface",
	L"NtUnBindCompositionSurface",
	L"NtQueryCompositionSurfaceBinding",
	L"CFlipExBuffer::RemoveRealization",
	L"NtQueryCompositionSurfaceStatistics",
	L"NtOpenCompositionSurfaceSectionInfo",
	L"NtOpenCompositionSurfaceSwapChainHandleInfo",
	L"NtQueryCompositionSurfaceRenderingRealization",
	L"NtOpenCompositionSurfaceDirtyRegion",
	L"NtSetCompositionSurfaceOutOfFrameDirectFlipNotification",
	L"NtSetCompositionSurfaceStatistics",
	L"NtTokenManagerOpenEvent",
	L"NtTokenManagerThread",
	L"NtTokenManagerGetOutOfFrameDirectFlipSurfaceUpdates",
	L"NtDCompositionBeginFrame",
	L"NtDCompositionConfirmFrame",
	L"NtDCompositionRetireFrame",
	L"NtDCompositionDiscardFrame",
	L"NtDCompositionGetFrameSurfaceUpdates",
	L"NtDCompositionGetFrameLegacyTokens",
	L"NtDCompositionDestroyConnectionContext",
	L"NtDCompositionGetConnectionContextBatch",
	L"NtDCompositionGetFrameStatistics",
	L"NtDCompositionGetDeletedResources",
	L"NtDCompositionSetResourceDeletedNotificationTag",
	L"NtDCompositionCreateConnectionContext",
	L"NtDCompositionDestroyChannel",
	L"NtDCompositionReleaseAllResources",
	L"NtDCompositionSubmitDWMBatch",
	L"NtDCompositionCommitChannel",
	L"NtDCompositionWaitForChannel",
	L"NtDCompositionSetChannelCommitCompletionEvent",
	L"NtDCompositionTelemetryTouchInteractionBegin",
	L"NtDCompositionTelemetryTouchInteractionUpdate",
	L"NtDCompositionTelemetryTouchInteractionEnd",
	L"NtDCompositionCurrentBatchId",
	L"NtDCompositionReleaseResource",
	L"NtDCompositionRemoveCrossDeviceVisualChild",
	L"NtDCompositionRemoveVisualChild",
	L"NtDCompositionAddCrossDeviceVisualChild",
	L"NtDCompositionAddVisualChild",
	L"NtDCompositionReplaceVisualChildren",
	L"NtDCompositionSetResourceAnimationProperty",
	L"NtDCompositionSetResourceReferenceArrayProperty",
	L"NtDCompositionSetResourceReferenceProperty",
	L"NtDCompositionSetResourceBufferProperty",
	L"NtDCompositionSetResourceIntegerProperty",
	L"NtDCompositionSetResourceFloatProperty",
	L"NtDCompositionCreateResource",
	L"NtDCompositionCreateDwmChannel",
	L"NtDCompositionCreateChannel",
	L"NtDCompositionSynchronize",
	L"NtDCompositionDwmSyncFlush",
	L"NtDCompositionValidateAndReferenceSystemVisualForHwndTarget",
	L"NtDCompositionSignalGpuFence",
	L"NtDCompositionGetChannels",
	L"NtDCompositionConnectPipe",
	L"NtUserDestroyDCompositionHwndTarget",
	L"NtUserCreateDCompositionHwndTarget",
	L"NtUserWaitForRedirectionStartComplete",
	L"NtUserSignalRedirectionStartComplete",
	L"NtUserSetActiveProcess",
	L"NtUserGetDisplayAutoRotationPreferencesByProcessId",
	L"NtUserGetDisplayAutoRotationPreferences",
	L"NtUserSetDisplayAutoRotationPreferences",
	L"NtUserSetAutoRotation",
	L"NtUserGetAutoRotationState",
	L"NtUserAutoRotateScreen",
	L"NtUserSetSensorPresence",
	L"NtUserAcquireIAMKey",
	L"NtUserSetFallbackForeground",
	L"NtUserSetBrokeredForeground",
	L"NtUserDisableImmersiveOwner",
	L"NtUserEnableIAMAccess",
	L"NtUserGetProcessUIContextInformation",
	L"NtUserSetProcessRestrictionExemption",
	L"NtUserEnableMouseInPointer",
	L"NtUserIsMouseInPointerEnabled",
	L"NtUserPromoteMouseInPointer",
	L"NtUserAutoPromoteMouseInPointer",
	L"NtUserEnableMouseInputForCursorSuppression",
	L"NtUserIsMouseInputEnabled",
	L"NtUserInternalClipCursor",
	L"NtUserCheckProcessForClipboardAccess",
	L"NtUserGetClipboardAccessToken",
	L"NtUserGetQueueEventStatus",
};